<?php
require_once("../include/syno_conf.php");
require_once("util.php");

define('FLICKR_SIGNATURE_PHP', '/var/packages/PhotoStation/target/photo/SocialNetwork/flickr_get_signature.php');
//define('PHP_CMD', '/bin/php -n -d extension_dir=/lib/php/modules -d extension=syno_compiler.so -d extension=curl.so -d extension=bz2.so -d extension=hash.so -d extension=json.so');

DEFINE("FLICKR_API_KEY", "af941f92a452c48068cf53e11447367d");
define("FLICKR_UPLOAD_TMP", '/tmp/photostation');

class FlickrUtil {
	public static $PHP_ARG = array('-n',
		'-d', 'extension_dir=/lib/php/modules',
		'-d', 'extension=syno_compiler.so',
		'-d', 'extension=curl.so',
		'-d', 'extension=bz2.so',
		'-d', 'extension=hash.so',
		'-d', 'extension=json.so');
}

$result = array("success" => false);

if (isset($_GET['oauth_token']) && isset($_GET['token_secret']) && isset($_GET['user_nsid'])) {
	session_write_close();
	SYNOPHOTO_Flickr_GetAccessToken($_GET['oauth_token'], $_GET['token_secret'], $_GET['user_nsid']);
} else if (isset($_POST['action'])) {
	switch ($_POST['action']) {
	case "upload":
		if (!isset($_POST['id']) || !isset($_POST['token']) ||
				!isset($_POST['secret']) || !isset($_POST['description'])) {
			$result['message'] = "invalid upload arguments";
			echo json_encode($result);
			exit();
		}
		csSYNOPhotoDB::GetDBInstance()->SetSessionCache(true);
		session_write_close();
		SYNOPHOTO_Flickr_Upload($_POST['id'], $_POST['token'], $_POST['secret'], $_POST['description']);
		break;
	case "multi_upload":
		if (!isset($_POST['prog_id']) || !isset($_POST['token']) ||
				!isset($_POST['secret']) || !isset($_POST['photoList']) || strpos($_POST['prog_id'], "..") !== FALSE) {
			$result['message'] = "invalid multi_upload arguments";
			echo json_encode($result);
			exit();
		}
		csSYNOPhotoDB::GetDBInstance()->SetSessionCache(true);
		session_write_close();
		SYNOPHOTO_Flickr_MultiUpload($_POST['prog_id'], $_POST['token'], $_POST['secret'], $_POST['photoList']);
		break;
	case "cancel_upload":
		if (!isset($_POST['prog_id']) || strpos($_POST['prog_id'], "..") !== FALSE) {
			$result['message'] = "invalid cancel_upload arguments";
			echo json_encode($result);
			exit();
		}
		session_write_close();
		SYNOPHOTO_Flickr_CancelUpload($_POST['prog_id']);
		break;
	case "get_upload_status":
		if (!isset($_POST['prog_id']) || strpos($_POST['prog_id'], "..") !== FALSE) {
			$result['message'] = "invalid get_upload_status arguments";
			echo json_encode($result);
			exit();
		}
		session_write_close();
		SYNOPHOTO_Flickr_GetUploadStatus($_POST['prog_id']);
		break;
	case "get_user":
		if (!isset($_POST['token']) || !isset($_POST['secret']) || !isset($_POST['id'])) {
			$result['message'] = "invalid get_user_info arguments";
			echo json_encode($result);
			exit();
		}
		session_write_close();
		SYNOPHOTO_Flickr_GetUserInfo($_POST['token'], $_POST['secret'], $_POST['id']);
		break;
	default:
		$result['message'] = "invalid action";
		echo json_encode($result);
	}
} else {
	$result['message'] = "token or action not found";
	echo json_encode($result);
}

function SYNOPHOTO_Flickr_GetAccessToken ($oauthToken, $tokenSecret, $userNsid)
{
	$userInfo = getUserInfo($oauthToken, $tokenSecret, $userNsid);
	if (!$userInfo['success']) {
		echo json_encode($userInfo['error']);
		exit();
	}
	echo GetCallbackHtmlTemplate("_onFlickrLogin", $oauthToken, $userInfo['user']['name'], $userInfo['user']['image'], $tokenSecret, $userNsid);
}

function SYNOPHOTO_Flickr_GetUserInfo($oauthToken, $tokenSecret, $userNsid)
{
	$userInfo = getUserInfo($oauthToken, $tokenSecret, $userNsid);
	if (!$userInfo['success']) {
		echo json_encode($userInfo['error']);
		exit();
	}
	echo json_encode($userInfo);
}

function getUserInfo($oauthToken, $tokenSecret, $userNsid)
{
	$RESTUrl = "https://www.flickr.com/services/rest";
	$time = time();
	$query =
		"format=json".
		"&method=flickr.people.getInfo".
		"&nojsoncallback=1".
		"&oauth_consumer_key=".FLICKR_API_KEY.
		"&oauth_nonce=".crc32(time()).
		"&oauth_signature_method=HMAC-SHA1".
		"&oauth_timestamp=".$time.
		"&oauth_token=".$oauthToken.
		"&oauth_version=1.0".
		"&user_id=".$userNsid;
	$baseString = "GET&".urlencode($RESTUrl)."&".urlencode($query);

	//$cmd = sprintf(
	//	"%s %s -t %s -b %s",
	//	PHP_CMD, FLICKR_SIGNATURE_PHP,
	//	escapeshellarg($tokenSecret),
	//	escapeshellarg($baseString)
	//);
	//$signature = exec($cmd, $output, $val);
	$signature = '';
	csSYNOPhotoMisc::ExecCmd('/bin/php', array_merge(FlickrUtil::$PHP_ARG, array(FLICKR_SIGNATURE_PHP,
		'-t', $tokenSecret,
		'-b', $baseString)), false, $signature);
	$signature = $signature[count($signature) - 1];

	$url = $RESTUrl."?".$query."&oauth_signature=".urlencode($signature);
	$curl = curl_init();
	curl_setopt($curl, CURLOPT_URL, $url);
	curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
	curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);

	$curl_result = curl_exec($curl);
	if (FALSE === $curl_result) {
		return array("success" => false, "error" => "connection error");
	}
	$ret = json_decode($curl_result, true);
	if (FALSE == $ret) {
		return array("success" => false, "error" => "json decode error");
	} else if ("fail" === $ret['stat']) {
		return array("success" => false, "error" => $ret);
	}
	$username = $ret['person']['username']['_content'];
	$imageUrl = "http://www.flickr.com/images/buddyicon.gif";
	if ($ret['person']['iconserver'] > 0) {
		$imageUrl = "http://farm".$ret['person']['iconfarm'].".staticflickr.com/".$ret['person']['iconserver']."/buddyicons/".$userNsid.".jpg";
	}
	curl_close($curl);

	return array("success" => true, "user" => array("name" => $username, "image" => $imageUrl));
}

function getPhotoPath($imageId)
{
	$arr = explode('_', $imageId);
	if (3 !== count($arr)) {
		$result = array("success" => false, "message" => "invalid id format");
		return $result;
	}
	if ($arr[0] !== "photo") {
		$result = array("success" => false, "message" => "not photo id");
		return $result;
	}
	$dirName = @pack('H*', $arr[1]);
	$fileName = @pack('H*', $arr[2]);
	if ('/' === $dirName) {
		$filePath = $fileName;
	} else {
		$filePath = $dirName.'/'.$fileName;
	}
	$path = realpath(SYNOPHOTO_SERVICE_REAL_DIR.'/'.$filePath);

	$useOrig = csSYNOPhotoMisc::GetConfigDB("photo", "share_upload_orig", "photo_config") == 'on';
	$photoInfo = csSYNOPhotoDB::GetDBInstance()->GetPhotoInfo($path);

	$realPath = $path;
	//30MB is limit
	if(!$useOrig || !isset($photoInfo['size']) || 30*1024*1024 < $photoInfo['size']) {
		if (SYNOPhotoEA::checkFilePath($path, SYNOPhotoEA::FILE_THUMB_XL, $thumbPath)) {
			$realPath = $thumbPath;
		} else if (SYNOPhotoEA::checkFilePath($path, SYNOPhotoEA::FILE_THUMB_LARGE_PREVIEW, $thumbPath)) {
			$realPath = $thumbPath;
		}
	}

	if (!@file_exists($realPath)) {
		$result = array("success" => false, "message" => "file not found");
		return $result;
	}

	//check access right
	if (strpos($realPath, realpath(SYNOPHOTO_SERVICE_REAL_DIR)) !== 0) {
		$result = array("success" => false, "message" => "access denied");
		return $result;
	}
	if (!CheckAlbumAccessRight($dirName)) {
		$result = array("success" => false, "message" => "access denied");
		return $result;
	}
	if (!isset($_SESSION[SYNOPHOTO_ADMIN_USER]['admin_syno_user']) && !csSYNOPhotoMisc::GetConfigDB("photo", "allow_guest_fb_upload", "photo_config")) {
		$result = array("success" => false, "message" => "no upload permission");
		return $result;
	}
	// check flickr upload Setting
	$social = SocialNetwork::ReadList();
	if (is_array($social)) {
		foreach ($social as $item) {
			if ('Flickr' === $item['name'] && true !== $item['enable']) {
				$result = array("success" => false, "message" => "no youtube upload permission");
				return $result;
			}
		}
	}
	$result['success'] = true;
	$result['path'] = $realPath;
	$result['filename'] = $fileName;
	return $result;
}

function SYNOPHOTO_Flickr_Upload($imageId, $oauthToken, $tokenSecret, $description)
{
	if (!csSYNOPhotoMisc::IsAllowedSocialUploadIdentity()) {
		$result = array("success" => false, "message" => "not allowed identity");
		echo json_encode($result);
		exit;
	}

	$result = getPhotoPath($imageId);
	if ($result['success']) {
		$realPath = $result['path'];
		$result = uploadPhoto($tokenSecret, $oauthToken, $realPath, $result['filename'], $description);
	}

	echo json_encode($result);
}

function SYNOPHOTO_Flickr_MultiUpload($progressId, $oauthToken, $tokenSecret, $photoList)
{
	if (!csSYNOPhotoMisc::IsAllowedSocialUploadIdentity()) {
		$result = array("success" => false, "message" => "not allowed identity");
		echo json_encode($result);
		exit;
	}

	$photoIds = explode(',', $photoList);
	if (!@file_exists(FLICKR_UPLOAD_TMP)) {
		@mkdir(FLICKR_UPLOAD_TMP, 0777, true);
	} else if (!is_dir(FLICKR_UPLOAD_TMP)) {
		$result = array("success" => "finish", "error" => "failed to create tmpDir");
		@file_put_contents(FLICKR_UPLOAD_TMP."/".$progressId, json_encode($progress));
		exit();
	}
	$totalNum = count($photoIds);
	$uploadedNum = 0;
	foreach ($photoIds as $id) {
		if (@file_exists(FLICKR_UPLOAD_TMP."/".$progressId."_cancel")) {
			break;
		}
		$result = getPhotoPath($id);
		if (!$result['success']) {
			continue;
		}
		$realPath = $result['path'];
		$filename = substr($realPath, strrpos($realPath, '/')+1);
		$progress = array(
			"name" => $result['filename'],
			"percent" => number_format($uploadedNum/$totalNum, 2)
		);
		// write to progress file
		@file_put_contents(FLICKR_UPLOAD_TMP."/".$progressId, json_encode($progress));
		$result = uploadPhoto($tokenSecret, $oauthToken, $realPath, $result['filename'], "");
		if (!$result['success']) {
			echo $filename." ".$result['message'];
		}
		OutputSingleSpace();
		$uploadedNum++;
	}
	$progress = array("success" => "finish");
	@file_put_contents(FLICKR_UPLOAD_TMP."/".$progressId, json_encode($progress));
	@unlink(FLICKR_UPLOAD_TMP."/".$progressId."_cancel");
	echo json_encode($progress);
}

function uploadPhoto($tokenSecret, $oauthToken, $filepath, $title, $description)
{
	$uploadUrl = "https://api.flickr.com/services/upload/";
	$time = time();
	$query = array(
		"oauth_consumer_key" => FLICKR_API_KEY,
		"oauth_nonce" => crc32(time()),
		"oauth_signature_method" => "HMAC-SHA1",
		"oauth_timestamp" => $time,
		"oauth_token" => $oauthToken,
		"oauth_version" => "1.0",
	);

	if ($description != "") {
		$title = $description;
	}

	// use rawurlencode to encode space to '%20' instead of +(urlencode)
	$baseString = "POST&".urlencode($uploadUrl)."&".urlencode(http_build_query($query)).urlencode("&title=".rawurlencode($title));
	//$cmd = sprintf(
	//	"%s %s -t %s -b %s",
	//	PHP_CMD, FLICKR_SIGNATURE_PHP,
	//	escapeshellarg($tokenSecret),
	//	escapeshellarg($baseString)
	//);
	//$signature = exec($cmd, $output, $val);
	$signature = '';
	csSYNOPhotoMisc::ExecCmd('/bin/php', array_merge(FlickrUtil::$PHP_ARG, array(FLICKR_SIGNATURE_PHP,
		'-t', $tokenSecret,
		'-b', $baseString)), false, $signature);
	$signature = $signature[count($signature) - 1];
	$url = $uploadUrl;

	$image = file_get_contents($filepath);
	$boundary = "Photo_Station_".md5($filepath)."_".$time;
	$filename = substr($filepath, strrpos($filepath, '/'));

	$postData = "--".$boundary."\r\n".
		"Content-Disposition: form-data; name=\"title\"\r\n".
		"\r\n".
		$title."\r\n".
		"--".$boundary."\r\n".
		"Content-Disposition: form-data; name=\"photo\"; filename=\"".$filename."\"\r\n".
		"Content-Type: ".GetPhotoMimeType($filepath)."\r\n".
		"\r\n".
		$image."\r\n".
		"--".$boundary."--\r\n";

	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, $url);
	curl_setopt($ch, CURLOPT_POST, true);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
	$authHeaderStr = 'Authorization: OAuth oauth_signature="'.urlencode($signature).'"';
	foreach ($query as $key => $value) {
		$authHeaderStr .= ', '.$key.'="'.$value.'"';
	}
	$header = array(
		$authHeaderStr,
		"Content-Type: multipart/form-data; boundary=".$boundary,
		"Content-Length: ".strlen($postData)
	);
	curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
	curl_setopt($ch, CURLOPT_POSTFIELDS, $postData);
	$ret = curl_exec($ch);
	$xml = @simplexml_load_string($ret);
	curl_close($ch);
	// decode xml error, it may be oauth error
	if (FALSE === $xml) {
		$result['success'] = false;
		$result['message'] = $ret;
	} else if ((string)$xml->attributes()->stat !== 'ok') {
		$result['success'] = false;
		$result['message'] = $xml;
	} else {
		$result['success'] = true;
	}
	return $result;
}

function SYNOPHOTO_Flickr_CancelUpload($progressId)
{
	$filePath = FLICKR_UPLOAD_TMP."/".$progressId."_cancel";
	@file_put_contents($filePath, "");
	$result = array("success" => true);
	echo json_encode($result);
}

function SYNOPHOTO_Flickr_GetUploadStatus($progressId)
{
	$filePath = FLICKR_UPLOAD_TMP."/".$progressId;
	if (!@file_exists($filePath)) {
		echo json_encode(array("success" => false));
	}
	$result = @file_get_contents($filePath);
	$json = json_decode($result, true);
	if (FALSE !== $json && $json['success'] === "finish") {
		@unlink($filePath);
	}
	echo $result;
}

function CheckAlbumAccessRight($sharePath)
{
	$ret = true;
	// admin
	if (isset($_SESSION[SYNOPHOTO_ADMIN_USER]['admin_syno_user'])) {
		return true;
	}

	// not root share folder
	if ($sharePath !== "") {
		$albumInfo = csSYNOPhotoDB::GetDBInstance()->GetAlbum($sharePath);
		if (empty($albumInfo['password'])) {
			// Check accessible
			if (!csSYNOPhotoMisc::CheckAlbumAccessible($sharePath)) {
				$ret = false;
			}
		} else if (!isset($_SESSION[SYNOPHOTO_ADMIN_USER]['password_pass_album'][$sharePath])) {
			$ret = false;
		}
	} else if (csSYNOPhotoMisc::GetConfigDB("photo", "allow_root_folder_public", "photo_config") !== "on" &&
			!isset($_SESSION[SYNOPHOTO_ADMIN_USER]['uploadable_album']['/'])) {
		$ret = false;
	}
	return $ret;
}

function GetPhotoMimeType($path)
{
	$SYNOPHOTO_PICASA_MIME = array(
		'jpg' => 'image/jpeg',
		'jpeg' => 'image/jpeg',
		'jpe' => 'image/jpeg',
		'bmp' => 'image/bmp',
		'gif' => 'image/gif',
		'png' => 'image/png'
	);

	$path = strtolower($path);
	$path_parts = pathinfo($path);
	$extension = $path_parts['extension'];
	if (array_key_exists($extension, $SYNOPHOTO_PICASA_MIME)) {
		return $SYNOPHOTO_PICASA_MIME[$extension];
	}
	return null;
}

?>
