<?php

function GetCallbackHtmlTemplate($callback, $token, $name, $image, $uid = false, $expire = false)
{
	$params = "'$token', '" . addslashes($name) . "', '$image'";
	if (false !== $uid) {
		$params .= ", '$uid'";
	}
	if (false !== $expire) {
		$params .= ", '$expire'";
	}

	return "<html>
			<head>
				<script>
					function loadHandler(){
						window.opener.$callback($params);
						window.close();
					}
				</script>
			</head>
			<body onload='loadHandler()'></body>
		</html>";
}


function CurlRequest($url, $postData = false)
{
	$curl = curl_init();

	if (false !== $postData) {
		curl_setopt($curl, CURLOPT_POST, true);
		curl_setopt($curl, CURLOPT_POSTFIELDS, $postData);
	}

	curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
	curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
	curl_setopt($curl, CURLOPT_CONNECTTIMEOUT, 30);
	curl_setopt($curl, CURLOPT_TIMEOUT, 30);
	curl_setopt($curl, CURLOPT_FOLLOWLOCATION, true);
	curl_setopt($curl, CURLOPT_VERBOSE, true);
	curl_setopt($curl, CURLOPT_URL, $url);

	$result = curl_exec($curl);

	if (false === $result) {
		FillErrorMessage(curl_error($curl), curl_errno($curl), 'local');
	}

	curl_close($curl);

	return $result;
}

function FillErrorMessage($err, $err_code, $err_source)
{
	global $error;

	$error['error'] = $err;
	$error['error_code'] = $err_code;
	$error['error_source'] = $err_source;
}

function SYNOPHOTO_UTIL_ResponseErrorHtml()
{
	global $error;

	echo "<html><head></head><body>".
		"error: ".htmlspecialchars($error['error'])."<br>".
		"error_code: ".htmlspecialchars($error['error_code'])."<br>".
		"error_source: ".htmlspecialchars($error['error_source'])."<br>".
		"</body></html>";

	exit;
}

function SYNOPHOTO_UTIL_ResponseErrorJson()
{
	global $error;

	$returnJson = array(
		'success' => false,
		'error' => $error
	);

	echo json_encode($returnJson);

	exit;
}

function OutputSingleSpace() {
	// Avoid FastCGI idle timeout
	echo ' ';
	ob_flush();
	flush();
}

function SYNOPHOTO_UTIL_GetGoogleUser($accessToken)
{
	// get user name and profile image
	$url = "https://www.googleapis.com/oauth2/v1/userinfo";
	$curl = curl_init();
	curl_setopt($curl, CURLOPT_HTTPHEADER, array('Authorization: Bearer '.$accessToken));
	curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
	curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
	curl_setopt($curl, CURLOPT_CONNECTTIMEOUT, 30);
	curl_setopt($curl, CURLOPT_TIMEOUT, 30);
	curl_setopt($curl, CURLOPT_FOLLOWLOCATION, true);
	curl_setopt($curl, CURLOPT_VERBOSE, true);
	curl_setopt($curl, CURLOPT_URL, $url);

	$result = curl_exec($curl);

	$profileInfo = json_decode($result, true);
	if(NULL === $profileInfo) {
		return array("success" => false, "error" => "json_decode error");
	}

	if (!isset($profileInfo['name'])) {
		return array("success" => false, "error" => "get user's name failed");
	}

	$name = $profileInfo['name'];

	$imageUrl = "";
	if (isset($profileInfo['picture'])) {
		$imageUrl = $profileInfo['picture'];
	}

	return array("success" => true, "user" => array("name" => $name, "image" =>$imageUrl));
}
?>
