<?php
require_once("../include/syno_conf.php");

csSYNOPhotoMisc::PhotoCheckSynoToken();
csSYNOPhotoMisc::CheckAdminTimeOut();

switch ($_POST['action']) {
	case "get_setting":
		echo SYNOPHOTO_ADMIN_GetGeneralSettings();
		break;
	case "set_setting":
		echo SYNOPHOTO_ADMIN_SetGeneralSettings();
		break;
}

function SYNOPHOTO_ADMIN_GetPackageConfig($key, &$value)
{
	if (!isset($_SESSION[SYNOPHOTO_ADMIN_USER]['system_config']['pkgCfg'][$key])) {
		return false;
	}

	$value = $_SESSION[SYNOPHOTO_ADMIN_USER]['system_config']['pkgCfg'][$key];

	return true;
}

function GetDBConfigToResult(&$json, $section, $key, $default)
{
	$value = csSYNOPhotoMisc::GetConfigDB($section, $key, 'photo_config');
	if ($value == null || $value == '') {
		$value = $default;
	}
	$json[$key] = $value;
}

function SYNOPHOTO_ADMIN_GetGeneralSettings()
{
	GetDBConfigToResult($result['data'], 'global', 'lang_setting', '0');
	GetDBConfigToResult($result['data'], 'global', 'account_system', '0');

	$result['isHomeServiceEnable'] = false;
	if (isSet($_SESSION[SYNOPHOTO_ADMIN_USER]['system_config']['cfg']['userHomeEnable'])&&
		 'yes' == $_SESSION[SYNOPHOTO_ADMIN_USER]['system_config']['cfg']['userHomeEnable']) {
		$result['isHomeServiceEnable'] = true;
	}

	$result['data']['enable_personal_photo'] = 'off';
	if ($result['isHomeServiceEnable'] && isSet($_SESSION[SYNOPHOTO_ADMIN_USER]['system_config']['pkgCfg']['runpersonalphotostation']) &&
		'yes' == $_SESSION[SYNOPHOTO_ADMIN_USER]['system_config']['pkgCfg']['runpersonalphotostation']) {
		$result['data']['enable_personal_photo'] = 'on';
	}

	$result['data']['def_album_public'] = 'off';
	if (isSet($_SESSION[SYNOPHOTO_ADMIN_USER]['system_config']['pkgCfg']['albumdefpublic']) &&
		'yes' == $_SESSION[SYNOPHOTO_ADMIN_USER]['system_config']['pkgCfg']['albumdefpublic']) {
		$result['data']['def_album_public'] = 'on';
	}

	$pkgConfig = SYNOPHOTO_ADMIN_GET_PKG_CONF();
	$result['data']['hide_dsm_icon'] = 'off';
	if(isSet($pkgConfig['.url']['SYNO.SDS.PhotoStation']['allUsers'])) {
		$result['data']['hide_dsm_icon'] = $pkgConfig['.url']['SYNO.SDS.PhotoStation']['allUsers'] ? 'off':'on';
	}

	GetDBConfigToResult($result['data'], 'global', 'redirect_to_https', 'off');
	GetDBConfigToResult($result['data'], 'global', 'allow_search_engine_index', 'off');

	//external port
	$result['data']['external_dns_or_ip'] = '';
	if (isSet($_SESSION[SYNOPHOTO_ADMIN_USER]['system_config']['pkgCfg']['external_host_ip'])) {
		$result['data']['external_dns_or_ip'] = $_SESSION[SYNOPHOTO_ADMIN_USER]['system_config']['pkgCfg']['external_host_ip'];
	}
	$result['data']['external_port_photo_http'] = '';
	if (isSet($_SESSION[SYNOPHOTO_ADMIN_USER]['system_config']['pkgCfg']['external_port_photo_http'])) {
		$result['data']['external_port_photo_http'] = $_SESSION[SYNOPHOTO_ADMIN_USER]['system_config']['pkgCfg']['external_port_photo_http'];
	}
	$result['data']['external_port_photo_https'] = '';
	if (isSet($_SESSION[SYNOPHOTO_ADMIN_USER]['system_config']['pkgCfg']['external_port_photo_https'])) {
		$result['data']['external_port_photo_https'] = $_SESSION[SYNOPHOTO_ADMIN_USER]['system_config']['pkgCfg']['external_port_photo_https'];
	}

	// security settings
	$result['data']['no_iframe'] = 'off';
	if (isset($_SESSION[SYNOPHOTO_ADMIN_USER]['system_config']['pkgCfg']['no_iframe'])
			&& ($_SESSION[SYNOPHOTO_ADMIN_USER]['system_config']['pkgCfg']['no_iframe'] === 'yes')) {
		$result['data']['no_iframe'] = 'on';
	}
	$result['data']['white_list'] = '';
	if (isset($_SESSION[SYNOPHOTO_ADMIN_USER]['system_config']['pkgCfg']['white_list'])) {
		$result['data']['white_list'] = $_SESSION[SYNOPHOTO_ADMIN_USER]['system_config']['pkgCfg']['white_list'];
	}

	$result['success'] = TRUE;
	return json_encode($result);
}

function SYNOPHOTO_ADMIN_SetGeneralSettings()
{
	if ('yes' == $_SESSION[SYNOPHOTO_ADMIN_USER]['system_config']['cfg']['enable_demomode']) {
		return json_encode(array(
			'success' => false,
			'error' => __(photo_str_error_demo)
		));
	}

	csSYNOPhotoMisc::UpdateConfigDB("global", "lang_setting", $_POST['lang_setting'], "photo_config");
	if ('root' == SYNOPHOTO_ADMIN_USER) {
		csSYNOPhotoMisc::UpdateConfigDB("global", "account_system", $_POST['account_system'], "photo_config");
		$_SESSION[SYNOPHOTO_ADMIN_USER]['photo_config']['global']['account_system'] = $_POST['account_system'];
	}

	$newRunPPS = $_POST['enable_personal_photo']==='on'? 'yes':'no';
	csSYNOPhotoMisc::SetConfigFile('runpersonalphotostation', $newRunPPS);

	$oldRunPPS = 'no';
	SYNOPHOTO_ADMIN_GetPackageConfig('runpersonalphotostation', $oldRunPPS);
	if ($newRunPPS === 'yes' && $oldRunPPS === 'no') {
		// signal synoindexd to reload package index config for Personal Photo Station
		//@exec("/usr/syno/bin/synophoto_dsm_user --hupsynoindexd");
		csSYNOPhotoMisc::ExecCmd('/usr/syno/bin/synophoto_dsm_user', array('--hupsynoindexd'));
	}

	csSYNOPhotoMisc::SetConfigFile('albumdefpublic', $_POST['def_album_public']==='on'? 'yes':'no');
	csSYNOPhotoMisc::SetConfigFile('photo_hide_icon', $_POST['hide_dsm_icon']==='on'? 'yes':'no');

	csSYNOPhotoMisc::UpdateConfigDB("global", "redirect_to_https", $_POST['redirect_to_https'], "photo_config");

	$allow_search_engine_index = $_POST['allow_search_engine_index'] === 'on' ? 'on' : 'off';
	csSYNOPhotoMisc::UpdateConfigDB("global", "allow_search_engine_index", $allow_search_engine_index, "photo_config");

	//@exec('/usr/syno/bin/synophoto_config --show-icon '. ($_POST['hide_dsm_icon'] === 'on' ? 'off' : 'on'), $output, $ret);
	$output = '';
	$ret = csSYNOPhotoMisc::ExecCmd('/usr/syno/bin/synophoto_config', array('--show-icon', ($_POST['hide_dsm_icon'] === 'on' ? 'off' : 'on')), false, $output);

	csSYNOPhotoMisc::SetConfigFile('external_host_ip', $_POST['external_dns_or_ip']);
	csSYNOPhotoMisc::SetConfigFile('external_port_photo_http', $_POST['external_port_photo_http']);
	csSYNOPhotoMisc::SetConfigFile('external_port_photo_https', $_POST['external_port_photo_https']);

	// security settings
	csSYNOPhotoMisc::SetConfigFile('no_iframe', (($_POST['no_iframe'] === 'on') ? 'yes' : 'no'));
	csSYNOPhotoMisc::SetConfigFile('white_list', $_POST['white_list']);

	//@exec("/usr/syno/sbin/synorelayd -U > /dev/null 2>&1");
	csSYNOPhotoMisc::ExecCmdNoOutput('/usr/syno/sbin/synorelayd', array('-U'));

	csSYNOPhotoDB::GetDBInstance()->SetSessionCache(true);
	csSYNOPhotoDB::GetDBInstance()->SetSessionSystemConfigsFromFile();
	return SYNOPHOTO_ADMIN_GetGeneralSettings();
}

function SYNOPHOTO_ADMIN_GET_PKG_CONF()
{
	$confFile = SYNO_PKG_DIR.'/target/ui/config';
	if (!@file_exists($confFile)
			|| false === ($result = @file_get_contents($confFile))) {
			return null;
		}
		$result = json_decode($result, true);
		if (empty($result)) {
			return null;
		}
		return $result;
}
