<?php
require_once("../include/syno_conf.php");

if(isset($_GET['action']) && 'set_fb_token' == $_GET['action']) {
	echo SYNOPHOTO_ADMIN_SetFBToken();
	exit;
}

csSYNOPhotoMisc::PhotoCheckSynoToken();
csSYNOPhotoMisc::CheckAdminTimeOut();

switch ($_REQUEST['action']) {
	case "get_setting":
		echo SYNOPHOTO_ADMIN_GetPhotoSettings();
		break;
	case "set_setting":
		echo SYNOPHOTO_ADMIN_SetPhotoSettings();
		break;
	case "get_virtual_album_setting":
		echo SYNOPHOTO_ADMIN_GetVirtualAlbumSetting();
		break;
	case "set_virtual_album_setting":
		echo SYNOPHOTO_ADMIN_SetVirtualAlbumSetting();
		break;
	case "get_index_and_recog_status":
		echo SYNOPHOTO_ADMIN_GetIndexAndRecogStatus();
		break;
	case "do_reindex":
		echo SYNOPHOTO_ADMIN_DoReindex();
		break;
	case "do_face_recog":
		echo SYNOPHOTO_ADMIN_DoFaceRecog();
		break;
	case "stop_face_recog":
		echo SYNOPHOTO_ADMIN_StopFaceRecog();
		break;
	case "get_album_conversion":
		echo SYNOPHOTO_ADMIN_GetAlbumConversion();
		break;
	case "set_album_conversion":
		echo SYNOPHOTO_ADMIN_SetAlbumConversion();
		break;
}

function RemoveFaceRecogQueue()
{
	// Stop deamon -> Remove queue -> Re-start deamon
	//@exec("/usr/syno/bin/photostationd -k");
	csSYNOPhotoMisc::ExecCmd('/usr/syno/bin/photostationd', array('-k'));
	//@exec("/usr/syno/bin/photostationd -r");
	csSYNOPhotoMisc::ExecCmd('/usr/syno/bin/photostationd', array('-r'));
	//@exec("/usr/syno/bin/photostationd");
	csSYNOPhotoMisc::ExecCmd('/usr/syno/bin/photostationd', array());
}

function SYNOPHOTO_ADMIN_SetFBToken()
{
	$token = $_GET['token'];
	if (!preg_match('/^\w+$/', $token)) {
		// token is alphanumeric, example: CAACiUWZA9WY8BADcZAWkwzEHiwXA6RuzQSVFb9DWhNCkiAnZBBcdY8GHpYSZBIOZCabnBCx5RZBZB1IUfEr5gZA2tpTCRbQ28LuSSZCYdJJs4GmhQZC4428a8tqZCHrLYgZBFRv5bHKm2ZC7HzC0kRy9IJX4GSYzWCC7ZAZBoLU0Wmxf76yzWER6A65MM8fXGfFH7IHaa8Go04DMIgQQAAuizK382IJ
		$token = '';
	}
	$callback = $_GET['callback'];
	if (!preg_match('/^[_a-z]+[_\w]+$/i', $callback)) {
		// callback should be a valid JavaScript symbol
		$callback = '';
	}
	$uid = $_GET['uid'];
	if (!preg_match('/^\d+$/', $uid)) {
		// uid is numeric, example: 971296996255901
		$uid = '';
	}

	if (empty($callback)) {
		$token = csSYNOPhotoMisc::GetConfigDB("photo", "fb_token", "photo_config");
		if (isset($_GET['token']) && strcmp($token, $_GET['token'])) {
			csSYNOPhotoMisc::UpdateConfigDB("photo", "fb_token", $_GET['token'], "photo_config");
		}
	}

	if (empty($callback)) {
		$callback = "_onFacebookLogin";
	}

	$closeWindow = "
		<html>
		<head>
			<script>
			function loadHandler(){
				var callback = '$callback';
				var token = '$token';
				var uid = '$uid';
				if (callback) {
					eval('callback = window.opener.' + callback);
					callback(token, uid);
				}
				window.close();
			}
			</script>
		</head>
		<body onload='loadHandler()'></body>
		</html>";
	return $closeWindow;
}

function SetResult(&$json, $section, $key, $default)
{
	$value = csSYNOPhotoMisc::GetConfigDB($section, $key, 'photo_config');
	if ($value == null || $value == '') {
		$value = $default;
	}
	$json[$key] = $value;
}

function SetAlbumResult(&$json, $key, $default)
{
	SetResult($json, 'album', $key, $default);
}

function SYNOPHOTO_ADMIN_GetPhotoSettings()
{
	$result['data']['folder_sort_type'] = csSYNOPhotoMisc::GetConfigDB("album", "album_order_type_is_desc", "photo_config");
	if($result['data']['folder_sort_type'] == null || $result['data']['folder_sort_type'] == "") {
		$result['data']['folder_sort_type'] = "0";
	}

	$result['data']['thumb_sort_type'] = csSYNOPhotoMisc::GetConfigDB("album", "thumb_sort_type", "photo_config");
	if($result['data']['thumb_sort_type'] == null || $result['data']['thumb_sort_type'] == "") {
		$result['data']['thumb_sort_type'] = "0";
	}

	$result['data']['thumb_sort_order'] = csSYNOPhotoMisc::GetConfigDB("album", "thumb_sort_order", "photo_config");
	if($result['data']['thumb_sort_order'] == null || $result['data']['thumb_sort_order'] == "") {
		$result['data']['thumb_sort_order'] = "0";
	}
	SetAlbumResult($result['data'], 'folder_sort_only_name', 'off');

	$result['data']['use_album_explorer'] = csSYNOPhotoMisc::GetConfigDB("album", "use_album_explorer", "photo_config");
	if($result['data']['use_album_explorer'] == null || $result['data']['use_album_explorer'] == "") {
		$result['data']['use_album_explorer'] = "on";
	}

	$result['data']['paging_use_bar'] = csSYNOPhotoMisc::GetConfigDB("album", "paging_use_bar", "photo_config");
	if($result['data']['paging_use_bar'] == null || $result['data']['paging_use_bar'] == "") {
		$result['data']['paging_use_bar'] = "on";
	}

	$result['data']['paging_item_count'] = csSYNOPhotoMisc::GetConfigDB("album", "paging_item_count", "photo_config");
	if($result['data']['paging_item_count'] == null || $result['data']['thumb_sort_order'] == "") {
		$result['data']['paging_item_count'] = 50;
	}

	$result['data']['photo_style_type'] = csSYNOPhotoMisc::GetConfigDB("photo", "photo_style_type", "photo_config");
	if($result['data']['photo_style_type'] == null || $result['data']['photo_style_type'] == "") {
		$result['data']['photo_style_type'] = "default";
	}

	$result['data']['allow_user_download'] = csSYNOPhotoMisc::GetConfigDB("photo", "allow_user_download", "photo_config");
	if($result['data']['allow_user_download'] == null || $result['data']['allow_user_download'] == "") {
		$result['data']['allow_user_download'] = "off";
	}

	$result['data']['allow_guest_download'] = csSYNOPhotoMisc::GetConfigDB("photo", "allow_guest_download", "photo_config");
	if($result['data']['allow_guest_download'] == null || $result['data']['allow_guest_download'] == "") {
		$result['data']['allow_guest_download'] = "off";
	}

	$result['data']['hide_guest_lightbox_detail'] = csSYNOPhotoMisc::GetConfigDB("photo", "hide_guest_lightbox_detail", "photo_config");
	if($result['data']['hide_guest_lightbox_detail'] == null || $result['data']['hide_guest_lightbox_detail'] == "") {
		$result['data']['hide_guest_lightbox_detail'] = "off";
	}

	$result['data']['hide_user_lightbox_detail'] = csSYNOPhotoMisc::GetConfigDB("photo", "hide_user_lightbox_detail", "photo_config");
	if($result['data']['hide_user_lightbox_detail'] == null || $result['data']['hide_user_lightbox_detail'] == "") {
		$result['data']['hide_user_lightbox_detail'] = "off";
	}

	$result['data']['allow_root_folder_public'] = csSYNOPhotoMisc::GetConfigDB("photo", "allow_root_folder_public", "photo_config");
	if($result['data']['allow_root_folder_public'] == null || $result['data']['allow_root_folder_public'] == "") {
		$result['data']['allow_root_folder_public'] = "off";
	}

    $result['data']['allow_user_comment'] = csSYNOPhotoMisc::GetConfigDB("photo", "allow_user_comment", "photo_config");
	if($result['data']['allow_user_comment'] == null || $result['data']['allow_user_comment'] == "") {
		$result['data']['allow_user_comment'] = "off";
	}

    $result['data']['allow_guest_comment'] = csSYNOPhotoMisc::GetConfigDB("photo", "allow_guest_comment", "photo_config");
	if($result['data']['allow_guest_comment'] == null || $result['data']['allow_guest_comment'] == "") {
		$result['data']['allow_guest_comment'] = "off";
	}

	$result['data']['hide_search'] = csSYNOPhotoMisc::GetConfigDB("photo", "hide_search", "photo_config");
	if($result['data']['hide_search'] == null || $result['data']['hide_search'] == "") {
		$result['data']['hide_search'] = "off";
	}

    /*
	$result['data']['hide_rss_feed'] = csSYNOPhotoMisc::GetConfigDB("photo", "hide_rss_feed", "photo_config");
	if($result['data']['hide_rss_feed'] == null || $result['data']['hide_rss_feed'] == "") {
		$result['data']['hide_rss_feed'] = "off";
	}
    */

	$result['data']['photo_page_title'] = trim(csSYNOPhotoMisc::GetConfigDB("photo", "photo_page_title", "photo_config"));
	if($result['data']['photo_page_title'] == null || $result['data']['photo_page_title'] == "") {
		$result['data']['photo_page_title'] = __(photo_str_ap_name_6);
	}

	$result['data']['photo_dispaly_size'] = csSYNOPhotoMisc::GetConfigDB("photo", "photo_dispaly_size", "photo_config");
	if($result['data']['photo_dispaly_size'] == null || $result['data']['photo_dispaly_size'] == "") {
		$result['data']['photo_dispaly_size'] = 0;
	}

	$result['data']['disable_right_button'] = csSYNOPhotoMisc::GetConfigDB("photo", "disable_right_button", "photo_config");
	if ($result['data']['disable_right_button'] == null || $result['data']['disable_right_button'] == "") {
		$result['data']['disable_right_button'] = "off";
	}

	$result['data']['show_album_hit'] = csSYNOPhotoMisc::GetConfigDB("photo", "show_album_hit", "photo_config");
	if ($result['data']['show_album_hit'] == null || $result['data']['show_album_hit'] == "") {
		$result['data']['show_album_hit'] = "on";
	}

	$result['data']['excluding_index_format'] = csSYNOPhotoMisc::GetConfigDB("photo", "excluding_index_format", "photo_config");
	if ($result['data']['excluding_index_format'] == null) {
		$result['data']['excluding_index_format'] = "";
	}

	$result['data']['def_album_disable_conversion'] = csSYNOPhotoMisc::GetConfigDB("photo", "def_album_disable_conversion", "photo_config");
	if ($result['data']['def_album_disable_conversion'] !== "on") {
		$result['data']['def_album_disable_conversion'] = "off";
	}

	$result['data']['enable_auto_face_recognition'] = csSYNOPhotoMisc::GetConfigDB("photo", "enable_face_recognition", "photo_config");
	if ($result['data']['enable_auto_face_recognition'] == null || $result['data']['enable_auto_face_recognition'] == "") {
		$result['data']['enable_auto_face_recognition'] = "off";
	}

	$result['data']['hide_gps_from_normal_user'] = csSYNOPhotoMisc::GetConfigDB("photo", "hide_gps_from_normal_user", "photo_config");
	if ($result['data']['hide_gps_from_normal_user'] == null || $result['data']['hide_gps_from_normal_user'] == "") {
		$result['data']['hide_gps_from_normal_user'] = "off";
	}

	$result['data']['allow_face_recognition'] = 'off';
	if (isSet($_SESSION[SYNOPHOTO_ADMIN_USER]['system_config']['pkgCfg']['runfacerecognition']) &&
		'yes' == $_SESSION[SYNOPHOTO_ADMIN_USER]['system_config']['pkgCfg']['runfacerecognition']) {
		$result['data']['allow_face_recognition'] = 'on';
	} else {
		$result['data']['enable_auto_face_recognition'] = "off";
	}

	$result['data']['set_orientation_to_metadata'] = csSYNOPhotoMisc::GetConfigDB("photo", "set_orientation_to_metadata", "photo_config");
	if ($result['data']['set_orientation_to_metadata'] == null || $result['data']['set_orientation_to_metadata'] == "") {
		$result['data']['set_orientation_to_metadata'] = "off";
	}

	$result['data']['collapse_left_panel'] = csSYNOPhotoMisc::GetConfigDB("photo", "collapse_left_panel", "photo_config");
	if ($result['data']['collapse_left_panel'] == null || $result['data']['collapse_left_panel'] == "") {
		$result['data']['collapse_left_panel'] = "off";
	}

	SetResult($result['data'], 'photo', 'show_lightbox_information', 'off');

	$result['data']['use_pop_window_to_edit_desc'] = csSYNOPhotoMisc::GetConfigDB("photo", "use_pop_window_to_edit_desc", "photo_config");
	if ($result['data']['use_pop_window_to_edit_desc'] == null || $result['data']['use_pop_window_to_edit_desc'] == "") {
		$result['data']['use_pop_window_to_edit_desc'] = "off";
	}
	$result['success'] = TRUE;
	return json_encode($result);
}

function SYNOPHOTO_ADMIN_GetVirtualAlbumSetting()
{
	$result['data']['recent_photo'] = csSYNOPhotoMisc::GetConfigDB("photo", "recent_photo", "photo_config");
	if($result['data']['recent_photo'] == null || $result['data']['recent_photo'] == "") {
		$result['data']['recent_photo'] = "off";
	}

	$result['data']['recent_video'] = csSYNOPhotoMisc::GetConfigDB("photo", "recent_video", "photo_config");
	if($result['data']['recent_video'] == null || $result['data']['recent_video'] == "") {
		$result['data']['recent_video'] = "off";
	}

	$result['data']['recent_photo_num'] = csSYNOPhotoMisc::GetConfigDB("photo", "recent_photo_num", "photo_config");
	if($result['data']['recent_photo_num'] == null || $result['data']['recent_photo_num'] == "") {
		$result['data']['recent_photo_num'] = "20";
	}

	$result['data']['recent_video_num'] = csSYNOPhotoMisc::GetConfigDB("photo", "recent_video_num", "photo_config");
	if($result['data']['recent_video_num'] == null || $result['data']['recent_video_num'] == "") {
		$result['data']['recent_video_num'] = "20";
	}

	$result['data']['recent_commented_photo'] = csSYNOPhotoMisc::GetConfigDB("photo", "recent_commented_photo", "photo_config");
	if($result['data']['recent_commented_photo'] == null || $result['data']['recent_commented_photo'] == "") {
		$result['data']['recent_commented_photo'] = "off";
	}

	$result['data']['recent_commented_video'] = csSYNOPhotoMisc::GetConfigDB("photo", "recent_commented_video", "photo_config");
	if($result['data']['recent_commented_video'] == null || $result['data']['recent_commented_video'] == "") {
		$result['data']['recent_commented_video'] = "off";
	}

	$result['data']['recent_commented_photo_num'] = csSYNOPhotoMisc::GetConfigDB("photo", "recent_commented_photo_num", "photo_config");
	if($result['data']['recent_commented_photo_num'] == null || $result['data']['recent_commented_photo_num'] == "") {
		$result['data']['recent_commented_photo_num'] = "20";
	}

	$result['data']['recent_commented_video_num'] = csSYNOPhotoMisc::GetConfigDB("photo", "recent_commented_video_num", "photo_config");
	if($result['data']['recent_commented_video_num'] == null || $result['data']['recent_commented_video_num'] == "") {
		$result['data']['recent_commented_video_num'] = "20";
	}

	$result['data']['general_label_album'] = csSYNOPhotoMisc::GetConfigDB("photo", "general_label_album", "photo_config");
	if($result['data']['general_label_album'] == null || $result['data']['general_label_album'] == "") {
		$result['data']['general_label_album'] = "off";
	}

	$result['data']['place_label_album'] = csSYNOPhotoMisc::GetConfigDB("photo", "place_label_album", "photo_config");
	if($result['data']['place_label_album'] == null || $result['data']['place_label_album'] == "") {
		$result['data']['place_label_album'] = "off";
	}

	$result['data']['person_label_album'] = csSYNOPhotoMisc::GetConfigDB("photo", "person_label_album", "photo_config");
	if($result['data']['person_label_album'] == null || $result['data']['person_label_album'] == "") {
		$result['data']['person_label_album'] = "off";
	}

	$result['success'] = TRUE;
	return json_encode($result);
}

function SYNOPHOTO_ADMIN_SetPhotoSettings()
{
	csSYNOPhotoMisc::UpdateConfigDB("album", "album_order_type_is_desc", $_POST['folder_sort_type'], "photo_config");
	csSYNOPhotoMisc::UpdateConfigDB("album", "thumb_sort_type", $_POST['thumb_sort_type'], "photo_config");
	csSYNOPhotoMisc::UpdateConfigDB("album", "thumb_sort_order", $_POST['thumb_sort_order'], "photo_config");
	csSYNOPhotoMisc::UpdateConfigDB("album", "folder_sort_only_name", $_POST['folder_sort_only_name'], "photo_config");
	csSYNOPhotoMisc::UpdateConfigDB("album", "use_album_explorer", $_POST['use_album_explorer'], "photo_config");
	csSYNOPhotoMisc::UpdateConfigDB("album", "paging_use_bar", $_POST['paging_use_bar'], "photo_config");

	$paging_item_count = $_POST['paging_item_count'];
	if($paging_item_count === null || $paging_item_count === "" || $paging_item_count < 50) {
		$paging_item_count = 50;
	} else if($paging_item_count > 500) {
		$paging_item_count = 500;
	}
	$paging_item_count = floor($paging_item_count);
	csSYNOPhotoMisc::UpdateConfigDB("album", "paging_item_count", $paging_item_count, "photo_config");
	csSYNOPhotoMisc::UpdateConfigDB("photo", "photo_style_type", $_POST['photo_style_type'], "photo_config");
	csSYNOPhotoMisc::UpdateConfigDB("photo", "allow_user_download", $_POST['allow_user_download'], "photo_config");
	csSYNOPhotoMisc::UpdateConfigDB("photo", "allow_guest_download", $_POST['allow_guest_download'], "photo_config");
	csSYNOPhotoMisc::UpdateConfigDB("photo", "hide_guest_lightbox_detail", $_POST['hide_guest_lightbox_detail'], "photo_config");
	csSYNOPhotoMisc::UpdateConfigDB("photo", "hide_user_lightbox_detail", $_POST['hide_user_lightbox_detail'], "photo_config");
	csSYNOPhotoMisc::UpdateConfigDB("photo", "allow_root_folder_public", $_POST['allow_root_folder_public'], "photo_config");
    csSYNOPhotoMisc::UpdateConfigDB("photo", "allow_user_comment", $_POST['allow_user_comment'], "photo_config");
    csSYNOPhotoMisc::UpdateConfigDB("photo", "allow_guest_comment", $_POST['allow_guest_comment'], "photo_config");
	csSYNOPhotoMisc::UpdateConfigDB("photo", "hide_search", $_POST['hide_search'], "photo_config");
	csSYNOPhotoMisc::UpdateConfigDB("photo", "hide_gps_from_normal_user", $_POST['hide_gps_from_normal_user'], "photo_config");

	csSYNOPhotoMisc::UpdateConfigDB("photo", "photo_dispaly_size", $_POST['photo_dispaly_size'], "photo_config");
	csSYNOPhotoMisc::UpdateConfigDB("photo", "disable_right_button", $_POST['disable_right_button'], "photo_config");
	csSYNOPhotoMisc::UpdateConfigDB("photo", "show_album_hit", $_POST['show_album_hit'], "photo_config");

	$oldFormats = csSYNOPhotoMisc::ParseExcludeFormats(csSYNOPhotoMisc::GetConfigDB("photo", "excluding_index_format", "photo_config"));
	$newFormats = csSYNOPhotoMisc::ParseExcludeFormats($_POST['excluding_index_format']);
	$addedFormats = array_diff($newFormats, $oldFormats);
	$removedFormats = array_diff($oldFormats, $newFormats);
	csSYNOPhotoMisc::UpdateConfigDB("photo", "excluding_index_format", implode(",", $newFormats), "photo_config");

	if (count($addedFormats)) {
		$cond = $sqlParam = array();

		foreach ($addedFormats as $format) {
			$cond[] = "lower(path) LIKE ? " . csSYNOPhotoDB::GetDBInstance()->escapeStr;
			$sqlParam[] = "%." . csSYNOPhotoDB::EscapeLikeParam($format);
		}

		$cond = implode(" OR ", $cond);

		$query = "UPDATE photo_image SET disabled = 't' WHERE $cond";
		PHOTO_DB_Query($query, $sqlParam);
		$query = "UPDATE video SET disabled = 't' WHERE $cond";
		PHOTO_DB_Query($query, $sqlParam);
	}

	if (count($removedFormats)) {
		$cond = $sqlParam = array();

		foreach ($removedFormats as $format) {
			$cond[] = "lower(path) LIKE ? " . csSYNOPhotoDB::GetDBInstance()->escapeStr;
			$sqlParam[] = "%." . csSYNOPhotoDB::EscapeLikeParam($format);
		}

		$cond = implode(" OR ", $cond);

		$query = "UPDATE photo_image SET disabled = 'f' WHERE $cond";
		PHOTO_DB_Query($query, $sqlParam);
		$query = "UPDATE video SET disabled = 'f' WHERE $cond";
		PHOTO_DB_Query($query, $sqlParam);

		//@exec("/usr/syno/bin/synoindex -A " . escapeshellarg(SYNOPHOTO_SERVICE_REAL_DIR));
		csSYNOPhotoMisc::ExecCmd('/usr/syno/bin/synoindex', array('-A', SYNOPHOTO_SERVICE_REAL_DIR));
	}

	csSYNOPhotoMisc::UpdateConfigDB("photo", "def_album_disable_conversion", $_POST['def_album_disable_conversion'], "photo_config");

	csSYNOPhotoMisc::UpdateConfigDB("photo", "enable_face_recognition", $_POST['enable_auto_face_recognition'] == 'on'? 'on':'off', "photo_config");
	csSYNOPhotoMisc::UpdateConfigDB("photo", "set_orientation_to_metadata", $_POST['set_orientation_to_metadata'] == 'on'? 'on':'off', "photo_config");

	csSYNOPhotoMisc::UpdateConfigDB("photo", "collapse_left_panel", $_POST['collapse_left_panel'] === 'on' ? 'on' : 'off', "photo_config");
	csSYNOPhotoMisc::UpdateConfigDB("photo", "show_lightbox_information", $_POST['show_lightbox_information'] === 'on' ? 'on' : 'off', "photo_config");
	csSYNOPhotoMisc::UpdateConfigDB("photo", "use_pop_window_to_edit_desc", $_POST['use_pop_window_to_edit_desc'] === 'on' ? 'on' : 'off', "photo_config");

	$allow = $_POST['allow_face_recognition']==='on'? 'yes':'no';
	csSYNOPhotoMisc::SetConfigFile('runfacerecognition', $allow);
	if ($allow === 'no') {
		RemoveFaceRecogQueue();
	}

	$photo_page_title = trim($_POST['photo_page_title']);
	if (__(photo_str_ap_name_6) == $photo_page_title) {
		$photo_page_title = "";
	}
	csSYNOPhotoMisc::UpdateConfigDB("photo", "photo_page_title", $photo_page_title, "photo_config");

	csSYNOPhotoDB::GetDBInstance()->SetSessionCache(true);
	csSYNOPhotoDB::GetDBInstance()->SetSessionSystemConfigsFromFile();
	return SYNOPHOTO_ADMIN_GetPhotoSettings();
}

function SYNOPHOTO_ADMIN_SetVirtualAlbumSetting()
{
	csSYNOPhotoMisc::UpdateConfigDB("photo", "recent_photo", $_POST['recent_photo'], "photo_config");
	csSYNOPhotoMisc::UpdateConfigDB("photo", "recent_video", $_POST['recent_video'], "photo_config");
	csSYNOPhotoMisc::UpdateConfigDB("photo", "recent_photo_num", $_POST['recent_photo_num'], "photo_config");
	csSYNOPhotoMisc::UpdateConfigDB("photo", "recent_video_num", $_POST['recent_video_num'], "photo_config");
	csSYNOPhotoMisc::UpdateConfigDB("photo", "recent_commented_photo", $_POST['recent_commented_photo'], "photo_config");
	csSYNOPhotoMisc::UpdateConfigDB("photo", "recent_commented_video", $_POST['recent_commented_video'], "photo_config");
	csSYNOPhotoMisc::UpdateConfigDB("photo", "recent_commented_photo_num", $_POST['recent_commented_photo_num'], "photo_config");
	csSYNOPhotoMisc::UpdateConfigDB("photo", "recent_commented_video_num", $_POST['recent_commented_video_num'], "photo_config");

	csSYNOPhotoMisc::UpdateConfigDB("photo", "general_label_album", $_POST['general_label_album'], "photo_config");
	csSYNOPhotoMisc::UpdateConfigDB("photo", "place_label_album", $_POST['place_label_album'], "photo_config");
	csSYNOPhotoMisc::UpdateConfigDB("photo", "person_label_album", $_POST['person_label_album'], "photo_config");

	csSYNOPhotoDB::GetDBInstance()->SetSessionCache(true);
	$result['success'] = TRUE;
	return json_encode($result);
}

function SYNOPHOTO_ADMIN_GetIndexAndRecogStatus()
{
	$result['indexing'] = '';
	$result['recognizing'] = '';
	$result['can_stop_recog'] = '';
	$result['find'] = 'F:'.SYNOPHOTO_SERVICE_REAL_DIR;

	if (file_exists(SYNOPHOTO_INDEX_QUEUE) || file_exists(SYNOPHOTO_INDEX_QUEUE_TMP)) {
		$result['indexing'] = 'indexing';
	}
	if (file_exists(SYNOPHOTO_DAEMON_QUEUE_TMP) || file_exists(SYNOPHOTO_DAEMON_QUEUE)) {
		$result['recognizing'] = 'recognizing';

		// Only root photo station admin can stop all recognition jobs.
		if (isset($_SESSION[SYNOPHOTO_ADMIN_USER]['admin_syno_user']) && 'root' == SYNOPHOTO_ADMIN_USER) {
			$result['can_stop_recog'] = 'can_stop_recog';
		}
	}
	return json_encode($result);
}

function SYNOPHOTO_ADMIN_DoReindex()
{
	$result['success'] = false;
	$cmd = '/usr/syno/bin/synoindex -P PhotoStation -R photo';
	//@exec($cmd, $output, $retVal);
	$retVal = csSYNOPhotoMisc::ExecCmd('/usr/syno/bin/synoindex', array('-P', 'PhotoStation', '-R', 'photo'));
	if (0 == $retVal) {
		$result['success'] = true;
	}
	return json_encode($result);
}

function SYNOPHOTO_ADMIN_StopFaceRecog()
{
	RemoveFaceRecogQueue();
	$result['success'] = true;
	return json_encode($result);
}

function SYNOPHOTO_ADMIN_DoFaceRecog()
{
	$result['success'] = false;
	$query = "delete from photo_image_label where status = ?";
	$sqlParam = array('f');
	PHOTO_DB_Query($query, $sqlParam);

	//$cmd = SYNOPHOTO_DAEMON.' -a F:'.SYNOPHOTO_SERVICE_REAL_DIR;
	//@exec($cmd, $output, $retVal);
	$retVal = csSYNOPhotoMisc::ExecCmd(SYNOPHOTO_DAEMON, array('-a',
		'F:' . SYNOPHOTO_SERVICE_REAL_DIR));

	if (0 == $retVal) {
		$result['success'] = true;
	}
	return json_encode($result);
}

function SYNOPHOTO_ADMIN_GetAlbumConversion()
{
	$all = array();

	//get root album
	$query = "SELECT shareid, conversion FROM photo_share WHERE sharename = '/'";
	$db_result = PHOTO_DB_Query($query);

	if (!$row = PHOTO_DB_FetchRow($db_result)) {
		return json_encode(array('all' => $all));
	}

	$rootId = $row['shareid'];
	$all[] = array(
		'_id' => $rootId,
		'_parent' => null,
		'_level' => 1,
		'_lft' => 1,
		'_is_leaf' => false,
		'child_id' => array(),
		'name' => __(photo_str_category_albums),
		'conversion' => PHOTO_DB_IsTrue($row['conversion']),
		'conversion_orig' => PHOTO_DB_IsTrue($row['conversion'])
	);

	//get 1st level album
	$query = "SELECT shareid, sharename, conversion FROM photo_share WHERE is_subdir = 'f' AND sharename <> '/' ORDER BY sharename ASC";
	$db_result = PHOTO_DB_Query($query);

	while($row = PHOTO_DB_FetchRow($db_result)) {
		$all[] = array(
			'_id' => $row['shareid'],
			'_parent' => $rootId,
			'_level' => 1,
			'_lft' => 1,
			'_is_leaf' => true,
			'child_id' => null,
			'name' => $row['sharename'],
			'conversion' => PHOTO_DB_IsTrue($row['conversion']),
			'conversion_orig' => PHOTO_DB_IsTrue($row['conversion'])
		);

		$all[0]['child_id'][] = $row['shareid'];
	}

	$all[0]['child_id'] = json_encode($all[0]['child_id']);

	return json_encode(array('all' => $all));
}

function SYNOPHOTO_ADMIN_SetAlbumConversion()
{
	$result['success'] = false;
	$enableShareIds = $disableShareIds = array();

	foreach(explode(',', $_POST['enable_shareid']) as $id) {
		if (!empty($id)) {
			$enableShareIds[] = $id;
		}
	}

	foreach(explode(',', $_POST['disable_shareid']) as $id) {
		if (!empty($id)) {
			$disableShareIds[] = $id;
		}
	}

	$enableCount = count($enableShareIds);
	$disableCount = count($disableShareIds);
	if (!$enableCount && !$disableCount) {
		return json_encode($result);
	}

	$modifiedPaths = array();
	if ($enableCount) {
		$query = "SELECT shareid, sharename FROM photo_share WHERE conversion = 'f' AND shareid IN (" . str_repeat("?,", $enableCount - 1) . "?)";
		$db_result = PHOTO_DB_Query($query, $enableShareIds);

		$modifiedIds = array();
		while ($row = PHOTO_DB_FetchRow($db_result)) {
			$modifiedIds[] = $row['shareid'];
			$modifiedPaths[] = $row['sharename'];
		}

		$modifiedCount = count($modifiedIds);
		if ($modifiedCount) {
			$query = "UPDATE photo_share SET conversion = 't' WHERE shareid IN (" . str_repeat("?,", $modifiedCount - 1) . "?)";
			$db_result = PHOTO_DB_Query($query, $modifiedIds);
		}
	}

	if ($disableCount) {
		$query = "SELECT shareid FROM photo_share WHERE conversion = 't' AND shareid IN (" . str_repeat("?,", $disableCount - 1) . "?)";
		$db_result = PHOTO_DB_Query($query, $disableShareIds);

		$modifiedIds = array();
		while ($row = PHOTO_DB_FetchRow($db_result)) {
			$modifiedIds[] = $row['shareid'];
		}

		$modifiedCount = count($modifiedIds);
		if ($modifiedCount) {
			$query = "UPDATE photo_share SET conversion = 'f' WHERE shareid IN (" . str_repeat("?,", $modifiedCount - 1) . "?)";
			$db_result = PHOTO_DB_Query($query, $modifiedIds);
		}
	}

	foreach ($modifiedPaths as $path) {
		if ("/" === $path) {
			//@exec("/usr/syno/bin/synomkthumb -a " . escapeshellarg(SYNOPHOTO_SERVICE_REAL_DIR));
			csSYNOPhotoMisc::ExecCmd('/usr/syno/bin/synomkthumb', array('-a', SYNOPHOTO_SERVICE_REAL_DIR));
			//@exec("/usr/syno/bin/synomkflv -a " . escapeshellarg(SYNOPHOTO_SERVICE_REAL_DIR));
			csSYNOPhotoMisc::ExecCmd('/usr/syno/bin/synomkflv', array('-a', SYNOPHOTO_SERVICE_REAL_DIR));
		} else {
			//@exec("/usr/syno/bin/synoindex -P PhotoStation -R " . escapeshellarg(SYNOPHOTO_SERVICE_REAL_DIR . "/" . $path));
			csSYNOPhotoMisc::ExecCmd('/usr/syno/bin/synoindex', array('-P', 'PhotoStation', '-R',
				SYNOPHOTO_SERVICE_REAL_DIR . '/' . $path));
			syslog(LOG_ERR, 'PhotoStation: Re-index triggered [synoindex -P PhotoStation -R '.SYNOPHOTO_SERVICE_REAL_DIR.'/'.$path.']');
		}
	}

	$result['success'] = true;

	return json_encode($result);
}
