<?php
require_once("include/syno_conf.php");
require_once("include/blog/module.php");

if (csSYNOPhotoMisc::checkRedirectToHttps()) {
	csSYNOPhotoMisc::RedirectToHttps();
	exit();
}
SYNOBLOG_MODULE_CheckModuleExistence();

$isNSM = csSYNOPhotoMisc::IsNSM();

$LANGUAGE = $_SESSION[SYNOPHOTO_ADMIN_USER]['lang'];
$DEBUG = isset($_GET['jsDebug']);
$PAGE_TITLE = "Photo Station 6";
$blDemoMode = 'false';
$isDemoMode = csSYNOPhotoMisc::GetConfigFile(SYNO_CNF_FILE, 'enable_demomode');
if ('yes' === $isDemoMode['enable_demomode']) {
    $blDemoMode = 'true';
}

require_once('include/content_security_policy.php');
require_once('include/x_frame_options.php');
?>
<!DOCTYPE html>
<html>
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
	<meta http-equiv="X-UA-Compatible" content="IE=11" />

	<!-- javascript -->
<?php
	$debugTrueParameter = ($DEBUG === true) ? "&debug=true" : "";
	$jsFiles = array(
		"js_php/prevent_iframe.js.php",
		"scripts/uistrings.php?ln=$LANGUAGE",
		"scripts/ext-3/adapter/ext/ext-base.js",
		"scripts/ext-3/ext-all.js",
		"scripts/ext-3/ux/ux-all.js",
		"scripts/scrollbar/flexcroll.js",
		"include/client_string.php?ln=$LANGUAGE",
		"tinymce/jscripts/tiny_mce/tiny_mce.js",
		"js_php/index.js.php?language=$LANGUAGE&demo_mode=false$debugTrueParameter",

		"photo_new/syno_photo_setting.js"
	);

	foreach ($jsFiles as $item) {
		printf(
			"\t" . '<script type="text/javascript" src="%s%s"></script>' . "\n",
			csSynoPhotoMisc::GetFileWithMtime($item), ($DEBUG === true) ? '&_dc='.time() : ''
		);
	}
?>
	<!-- for blog setting -->
<?php
	$blogJS = glob("blog/modules/*.js");
	foreach ($blogJS as $item) {
		printf(
			"\t" . '<script type="text/javascript" src="%s%s"></script>' . "\n",
			csSynoPhotoMisc::GetFileWithMtime($item), ($DEBUG === true) ? '&_dc='.time() : ''
		);
	}
?>

	<!-- style sheet -->
<?php
	$cssFiles = array(
		"scripts/ext-3/resources/css/ext-all.css",
		"scripts/ext-3/resources/css/xtheme-gray.css",
		"scripts/ext-3/ux/ux-all-default.css",
		"photo_new/css/style.css",
		"photo_new/css/style_image_chooser.css",
		"css/treegrid.css"
	);

	foreach ($cssFiles as $item) {
		printf(
			"\t" . '<link rel="stylesheet" type="text/css" href="%s%s" />' . "\n",
			csSynoPhotoMisc::GetFileWithMtime($item), ($DEBUG === true) ? '&_dc='.time() : ''
		);
	}
?>

	<link rel="shortcut icon" href="favicon.ico">

	<title><?php echo $PAGE_TITLE ?></title>
</head>
<body>
	<iframe id="login_iframe" name="login_iframe" width="0" height="0" frameborder="0"></iframe>
	<form id="login_form" class="login_form" method="POST" action="webapi/auth.php" target="login_iframe" style="filter: Alpha(opacity=0); opacity: 0;">
		<input type="text" id="login_api" name="api" class="sbox-text login-input" />
		<input type="text" id="login_method" name="method" class="sbox-text login-input" />
		<input type="text" id="login_version" name="version" class="sbox-text login-input" />
		<input type="text" id="login_username" name="username" class="sbox-text login-input" />
		<input type="password" id="login_password" name="password" class="sbox-text login-input" autocomplete="off"/>
		<input type="hidden" id="enable_syno_token" name="enable_syno_token" value="true" />
		<input type="submit" style="display: none;">
	</form>
	<form id="history-form" class="x-hidden">
		<input type="hidden" id="x-history-field" />
		<iframe id="x-history-frame"></iframe>
	</form>
</body>
</html>
