<?php
require_once("include/syno_conf.php");
require_once(SYNOPHOTO_FB_UTILS);

define("FBSYNCING_LIST_FILE", '/tmp/fbsyncing');
define("FBSYNCING_LIST_FILELOCK", '/tmp/fbsyncing.lck');

csSYNOPhotoMisc::PhotoCheckSynoToken();

if (preg_match('/^(setSyncWithFb)$/', $_POST['action'])) {
	csSYNOPhotoMisc::CheckAdminTimeOut();
}
if (preg_match('/^(get_album|upload|setSyncWithFb|get_user)$/', $_POST['action'])) {
	if ('setSyncWithFb' != $_POST['action'] || 'true' == $_POST['enable']) {
		if (null == ($fb_utils = FBPhotoUtils::CheckFbTokenValid($_POST['token']))) {
			$result['success'] = false;
			$result['msg'] = __(photo_str_fb_token_invalid);
			echo json_encode($result);
			exit;
		}
	}
}

switch ($_POST['action']) {
case "get_album":
	echo SYNOPHOTO_FB_GetAlbum();
	break;
case "upload_new":
	echo SYNOPHOTO_FB_DoUpload_New();
	break;
case "get_upload_status":
	echo SYNOPHOTO_FB_GetUploadStatus();
	break;
case 'cancel_upload':
	echo SYNOPHOTO_FB_CancelUpload();
	break;
case 'get_user':
	echo SYNOPHOTO_FB_GetUser();
	break;
}

function SYNOPHOTO_FB_GetUser()
{
	global $fb_utils;
	$result['success'] = true;
	$result['user'] = $fb_utils->getUser();
	return json_encode($result);
}

function SYNOPHOTO_FB_GetAlbum()
{
	global $fb_utils;
	$result['albums'] = array();
	$albums = $fb_utils->getAlbums();
	foreach ($albums as $item) {
		if (200 > $item['count']) {
			$result['albums'][] = $item;
		}
	}
	return json_encode($result);
}

function SYNOPHOTO_FB_DoUpload_New()
{
	$result['success'] = false;

	if (!csSYNOPhotoMisc::IsAllowedSocialUploadIdentity()) {
		return json_encode($result);
	}

	$list_file = SYNOPHOTO_FB_GetNameList_new($_POST['albumName'], $_POST['photoList'], $_POST['prog_id'], $_POST['message']);
	//$progressId = escapeshellarg($_POST['prog_id']);
	//$token = escapeshellarg($_POST['token']);
	$useOrig = (csSYNOPhotoMisc::GetConfigDB("photo", "share_upload_orig", "photo_config") == 'on')? '-o':'';

	$arg = array($useOrig,
		'-t', $_POST['token'],
		'-p', $_POST['prog_id']);
	if ('0' == $_POST['type']) {
		//$commend = "/usr/syno/bin/synophoto_sns_utils $useOrig -t $token -p $progressId -n " . escapeshellarg($_POST['newAlbumName']);
		$arg[] = '-n';
		$arg[] = $_POST['newAlbumName'];
	} else {
		//$commend = "/usr/syno/bin/synophoto_sns_utils $useOrig -t $token -p $progressId -a " . escapeshellarg($_POST['albumId']);
		$arg[] = '-a';
		$arg[] = $_POST['albumId'];
	}

	csSYNOPhotoMisc::ExecCmdNoOutput('/usr/syno/bin/synophoto_sns_utils', $arg);
	$result['success'] = TRUE;
	return json_encode($result);
}

function SYNOPHOTO_FB_CancelUpload()
{
	$list_file = SYNOPHOTO_FB_UPLOAD_PROGRESS_FILE.".".$_POST['prog_id'].".list";
	if (@file_exists($list_file)) {
		@unlink($list_file);
	}
	$result['success'] = TRUE;
	return json_encode($result);
}

function SYNOPHOTO_FB_GetNameList_new ($albumName, $photoList, $prog_id, $message)
{
	$id_litst = explode(",", $photoList);

	$result['files'] = array();
	foreach ($id_litst as $id) {
		$arr = explode('_', $id);
		$name = @pack('H*', $arr[2]);
		$title = empty($message) ? $name : $message;
		$real_path = realpath(SYNOPHOTO_SERVICE_REAL_DIR . "/" . @pack('H*', $arr[1]) . "/" . $name);
		if (FALSE == @stat($real_path)) {
			continue;
		}
		if (!csSYNOPhotoMisc::CheckPathAccessible($real_path)) {
			continue;
		}
		$item = array();
		$item['file'] = $real_path;
		$item['message'] = $title;
		$result['files'][] = $item;
	}
	$list_file = SYNOPHOTO_FB_UPLOAD_PROGRESS_FILE . "." . $prog_id . ".list";
	$handle = @fopen($list_file, "w");
	@fwrite($handle, json_encode($result));
	fclose($handle);
	return $list_file;
}

function SYNOPHOTO_FB_GetUploadStatus()
{
	$result = array();
	$result['success'] = 'uploading';
	$result['name'] = __(photo_str_init);
	$result['percent'] = 0;

	$listFile = SYNOPHOTO_FB_UPLOAD_PROGRESS_FILE.".".$_POST['prog_id'].".list";
	if (!file_exists($listFile)) {
		$result['success'] = 'canceling';
		return json_encode($result);
	}
	$progressFile = SYNOPHOTO_FB_UPLOAD_PROGRESS_FILE.".".$_POST['prog_id'];
	$handle = @fopen($progressFile, "r");
	if ($handle) {
		$content = fread($handle, 8192);
		fclose($handle);
		$json = json_decode($content);
		$result['success'] = 'uploading';
		if ($json->{'success'}) {
			$result['success'] = 'finish';
		} else {
			$result['name'] = basename($json->{'file'});
			$result['percent'] = $json->{'progress'} / $json->{'total'};
		}
	}
	return json_encode($result);
}

?>
