<?php

class Cache {
	private $cache = array();

	/**
	 * Check key exists in cache or not.
	 *
	 * @param string
	 *   Cache key.
	 *
	 * @return bool
	 *   Return cache exists or not.
	 */
	public function check($cache_key)
	{
		return array_key_exists($cache_key, $this->cache);
	}

	/**
	 * Get cache value.
	 *
	 * @param string
	 *   Cache key.
	 *
	 * @return mixed
	 *   Return cached value if exists, else return null.
	 */
	public function get($cache_key)
	{
		if ($this->check($cache_key)) {
			return $this->cache[$cache_key];
		}

		return null;
	}

	/**
	 * Set cache value.
	 *
	 * @param string
	 *   Cache key.
	 * @param mixed
	 *   Value to cache.
	 */
	public function set($cache_key, $value)
	{
		$this->cache[$cache_key] = $value;
	}

	/**
	 * Delete cache
	 *
	 * @param string
	 *   Cache key.
	 */
	public function delete($cache_key)
	{
		if ($this->check($cache_key)) {
			unset($this->cache[$cache_key]);
		}
	}
}


