<?php
require_once("syno_conf.php");
require_once("photo/synophoto_csPhotoAcl.php");

set_time_limit(0);
csSYNOPhotoMisc::PhotoSessionStart();

$_SESSION[SYNOPHOTO_ADMIN_USER]['security_identifier'] = csSYNOPhotoMisc::GetSessionIdentifier();

if (isset($_REQUEST['session'])) {
	csSYNOPhotoMisc::RestoreSession();
}

// Bug #16541: Update new upload rights information in current session.
csSYNOPhotoDB::GetDBInstance()->SetSessionCache(true);

$conf = csSYNOPhotoMisc::GetConfigFile(SYNO_CNF_FILE, "enable_demomode");
if ("yes" == $conf["enable_demomode"]) {
	SYNOPHOTO_UPLOAD_HandleResponseError(__(photo_str_error_demo));
}

if (!IsLogin()) {
	exit;
}

switch ($_REQUEST['action']) {
case 'check_subfolder':
	if (isSet($_REQUEST['path']) && $_REQUEST['path'] != "") {
		$result = SYNOPHOTO_UPLOAD_CheckSubFolder();
	} else {
		$result['success'] = true;
	}
	echo json_encode($result);
	exit;
case 'getshares':
	if ('fm_root' == $_POST['node']) {
		echo SYNOPHOTO_UPLOAD_GetUserValidShare();
	} else {
		echo SYNOPHOTO_UPLOAD_EnumUserValidDir();
	}
	exit;
case 'getfiles':
	$files = GetDSMPhotoVideoFile($_POST['target']);
	echo json_encode($files);
	exit;
case 'get_dsm_files':
	$files = GetDSMPhotoVideoFile($_POST['current_dir']);
	echo json_encode($files);
	exit;
}

if (!isset($_REQUEST['overwrite'])) {
	SYNOPHOTO_UPLOAD_HandleResponseError(__(photo_str_error_unknown_desc));
}

if (isset($_REQUEST['MultiPowUpload'])) {
	//flash upload
	$Filedata = $_FILES['Filedata'];
} else if (isset($_REQUEST['HTML5Upload'])) {
	//html5 upload
	$Filedata = $_FILES['upload'];
} else {
	$Filedata = pos($_FILES);
}

if (!isset($Filedata) || !is_uploaded_file($Filedata['tmp_name'])) {
	SYNOPHOTO_UPLOAD_HandleResponseError(__(photo_str_error_unknown_desc));
}

if ($Filedata['size'] > 2 * 1024 * 1024 * 1024) {
	SYNOPHOTO_UPLOAD_HandleResponseError(__(photo_str_upload_size_error));
}

if (!csSYNOPhotoMisc::IsPhotoFile($Filedata['name']) && !csSYNOPhotoMisc::IsVideoFile($Filedata['name'])) {
	SYNOPHOTO_UPLOAD_HandleResponseError(__(photo_str_upload_file_format_unsupport));
}

if (!csSYNOPhotoMisc::CheckAlbumUploadable($_REQUEST['path'])) {
	SYNOPHOTO_UPLOAD_HandleResponseError(__('photo_permission_denied'));
}

if (!SYNOPHOTO_UPLOAD_SubFolderCreate()) {
	SYNOPHOTO_UPLOAD_HandleResponseError(__('photo_permission_denied'));
}

$isThumbnailFile = false;
if (strstr($Filedata['name'], $_REQUEST['thumbnailName'])) {
	if ($_REQUEST['overwrite'] == "2") {
		SYNOPHOTO_UPLOAD_HandleResponseError('Currently not support upload thumbnail on rename mode');
	}
	$isThumbnailFile = true;
}

if ($isThumbnailFile) {
	$eaDir = SYNOPHOTO_SERVICE_DIR."/".$_REQUEST['path']."/".$_REQUEST['create_subfolder']."/".SYNOPHOTO_EADIR."/".$_REQUEST['originalFileName'];
	@mkdir($eaDir, 0777, true);
	$destination_path = $eaDir."/".$_REQUEST['thumbnailName'].".jpg";
} else {
	// Create @eaDir when got the original file.
	$eaDir = SYNOPHOTO_SERVICE_DIR."/".$_REQUEST['path']."/".$_REQUEST['create_subfolder']."/".SYNOPHOTO_EADIR."/".$Filedata['name'];
	@mkdir($eaDir, 0777, true);
	$destination_path = SYNOPHOTO_SERVICE_DIR."/".$_REQUEST['path']."/".$_REQUEST['create_subfolder']."/".$Filedata['name'];
}

if (file_exists($destination_path)) {
	if ($_REQUEST['overwrite'] == "0") {//ingnore
		SYNOPHOTO_UPLOAD_HandleResponseError(__(photo_str_upload_skip_file));
	} else if ($_REQUEST['overwrite'] == "2") {//rename
		$dir = pathinfo($destination_path, PATHINFO_DIRNAME);
		$name = pathinfo($destination_path, PATHINFO_FILENAME);
		$ext = pathinfo($destination_path, PATHINFO_EXTENSION);

		$rename_suffix = 0;
		$rename_path = $destination_path;

		while (file_exists($rename_path)) {
			$rename_path = $dir.'/'.$name.'_'.(++$rename_suffix).'.'.$ext;
		}

		$destination_path = $rename_path;
	}
}

if (!csSYNOPhotoAcl::QuotaChown($Filedata['tmp_name'], GetLoginUsername())) {
	SYNOPHOTO_UPLOAD_HandleResponseError(__(photo_str_error_unknown_desc));
}
if (!@move_uploaded_file($Filedata['tmp_name'], $destination_path)) {
	SYNOPHOTO_UPLOAD_HandleResponseError(__(photo_str_error_unknown_desc));
}

$path_parts = pathinfo($rename_path ? $rename_path : $Filedata['name']);

@chmod($destination_path, 0777);
if (!$isThumbnailFile) {
	csSYNOPhotoAcl::Apply($destination_path, GetLoginUsername());

	if (isSet($_POST['fileModificationDate']) && $_POST['fileModificationDate'] !== "") {
		@touch($destination_path, $_POST['fileModificationDate']/1000);
	}

	if (!isSet($_REQUEST['create_subfolder']) || $_REQUEST['create_subfolder'] == "") {
		$partial_path = $_REQUEST['path']."/".$path_parts['basename'];
	} else {
		$partial_path = $_REQUEST['path']."/".$_REQUEST['create_subfolder']."/".$path_parts['basename'];
	}
	SYNOPHOTO_UPLOAD_DoIndex($destination_path, trim($partial_path, "/"), $path_parts);
}

$return["success"] = true;

if (isset($_REQUEST['form_id'])) {
	$return["form_id"] = $_REQUEST['form_id'];
}

$return["result"] = "success";
$return['name'] = $Filedata['name'];

$user = "admin";
if (isset($_SESSION[SYNOPHOTO_ADMIN_USER]['reg_syno_user'])) {
	$user = $_SESSION[SYNOPHOTO_ADMIN_USER]['reg_syno_user'];
}

if (!$isThumbnailFile) {
	PhotoLog::Add("{$Filedata['name']} was uploaded to /photo/{$_REQUEST['path']}/{$_REQUEST['create_subfolder']} successfully.", true, $user);
}

echo json_encode($return);

//end of execution, exit
exit;

function SYNOPHOTO_UPLOAD_HandleResponseError($error_msg) {
	$return["success"] = true;
	$return["result"] = "fail";
	$return['error'] = $error_msg;
	$return['name'] = $Filedata['name'];

	echo json_encode($return);
	exit;
}

function SYNOPHOTO_UPLOAD_SubFolderCreate()
{
	if (!isSet($_REQUEST['create_subfolder']) || $_REQUEST['create_subfolder'] == "") {
		return TRUE;
	}

	$path = SYNOPHOTO_SERVICE_DIR."/".$_REQUEST['path']."/".$_REQUEST['create_subfolder'];
	if (file_exists($path)) {
		if (csSYNOPhotoMisc::CheckAlbumUploadable($_REQUEST['path']."/".$_REQUEST['create_subfolder'])) {
			return TRUE;
		}
		return FALSE;
	}

	if (!($result = @mkdir($path, 0777, true))) {
		return FALSE;
	}

	csSYNOPhotoAcl::Apply($path, GetLoginUsername());

	SYNOPHOTO_UPLOAD_AddFolderToDB($_REQUEST['path'],  trim($_REQUEST['path']."/".$_REQUEST['create_subfolder'], "/"));
	return TRUE;
}

function SYNOPHOTO_UPLOAD_AddFolderToDB($parent_album, $album)
{
	$real_path = SYNOPHOTO_SERVICE_REAL_DIR."/".$album;

	$def_allow_comment = 'f';

	$arr = explode("/", $album);
	if (count($arr) > 2) {
		return;
	}

	if ("" != $parent_album) {
		$is_subdir = "t";

		$query = "Select public, shareid from photo_share where sharename = ?;";
		$db_result = PHOTO_DB_Query($query, array($parent_album));
		if ($row = PHOTO_DB_FetchRow($db_result)) {
			$parent_public = PHOTO_DB_ConvertBool($row[0]);
			$parent_shareid = $row[1];
		} else {
			return;
		}
	} else {
		$is_subdir = "f";

		if ($_REQUEST['privilege'] == "0") {
			$parent_public = 't';
		} else {
			$parent_public = 'f';
		}
		if (csSYNOPhotoMisc::GetConfigDB("photo", "album_def_allow_comment", "photo_config") === 'on') {
			$def_allow_comment = 't';
		}
	}

	$query = "Select shareid from photo_share order by shareid desc limit 1;";
	$db_result = PHOTO_DB_Query($query);
	$row = PHOTO_DB_FetchRow($db_result);
	$new_shareid = $row[0] + 1;

	$privilege_sharename = csSYNOPhotoMisc::GetRefSharename($album);
	if ($privilege_sharename == $album) {
		$ref_shareid = $new_shareid;
	} else {
		$temp = csSYNOPhotoDB::GetDBInstance()->getPhotoShareByShareName($privilege_sharename);
		$ref_shareid = $temp['shareid'];
	}

	$query = "Insert into photo_share (shareid, sharename, public, is_subdir, comment, ref_shareid) values (?, ?, ?, ?, ?, ?);";
	$db_result = PHOTO_DB_Query($query, array($new_shareid, $album, $parent_public, $is_subdir, $def_allow_comment, $ref_shareid));

	if (!isSet($_REQUEST['privilege']) || $_REQUEST['privilege'] == "1") {
		csSYNOPhotoDB::GetDBInstance()->inheritAlbumPrivilege($parent_shareid, $new_shareid);
	}

	if ($_REQUEST['privilege'] == "2") { // Set password
		$query = "Update photo_share set password = ? where shareid = ?;";
		$db_result = PHOTO_DB_Query($query, array(md5($_REQUEST['password']), $new_shareid));
	}

	csSYNOPhotoMisc::ExecCmdNoOutput('/usr/syno/bin/synoindex', array('-a', $real_path));
	csSYNOPhotoMisc::ExecCmdNoOutput(SYNO_PHOTOIO, array('-a', $real_path));
}

function SYNOPHOTO_UPLOAD_DoIndex($path, $partial_path, $path_parts)
{
	csSYNOPhotoMisc::ExecCmdNoOutput('/usr/syno/bin/synoindex', array('-a', $path));
	csSYNOPhotoMisc::ExecCmdNoOutput(SYNO_PHOTOIO, array('-a', $path));

	if (preg_match('/\/~[^\/]+/', $_SERVER['REQUEST_URI'], $matches)) {
		$destination_path = $partial_path;
	} else {
		$destination_path = SYNOPHOTO_SERVICE_REAL_DIR_PATH.$partial_path;
	}

	$disabled = 'f';
	if (csSYNOPhotoMisc::IsExcludeFormats($destination_path)) {
		$disabled = 't';
	}

	if (csSYNOPhotoMisc::IsPhotoFile($path)) {
		$query = "Insert into photo_image (path, name, title, disabled) values (?,?,?,?);";
		PHOTO_DB_Query($query, array($destination_path, $path_parts['basename'], $path_parts['filename'], $disabled));

		$albumName = str_replace(basename($partial_path), "", $partial_path);
		$arr = explode("/", trim($albumName, "/"));
		if (1 < count($arr)) {
			$albumName = $arr[0]."/".$arr[1];
		} else {
			$albumName = $arr[0];
		}
	} else {
		// Todo: Insert into mediaserver?
	}
}

function SYNOPHOTO_UPLOAD_GetUserValidShare()
{
	$result = array();

	$shareList = SYNOPHOTO_UPLOAD_GetUserValidShareList();
	foreach ($shareList as $share) {
		$item = array();
		if ("photo" == strtolower($share['shareName']) && 'root' == SYNOPHOTO_ADMIN_USER) {
			continue;
		}
		$item['text'] = htmlspecialchars($share['shareName']);
		$item['id'] = $share['path'];
		$result[] = $item;
	}
	return json_encode($result);
}

function SYNOPHOTO_UPLOAD_GetUserValidShareList()
{
	$result = array();

	if ($_SESSION[SYNOPHOTO_ADMIN_USER]['use_dsm_account'] &&
		isset($_SESSION[SYNOPHOTO_ADMIN_USER]['reg_syno_user'])) {
		$username = $_SESSION[SYNOPHOTO_ADMIN_USER]['reg_syno_user'];
	} else if (isset($_SESSION[SYNOPHOTO_ADMIN_USER]['admin_syno_user'])) {
		$username = ('root' == SYNOPHOTO_ADMIN_USER)? 'admin':SYNOPHOTO_ADMIN_NAME;
	} else {
		return $result;
	}

	//$command = "/usr/syno/bin/synophoto_dsm_user --getshare ".escapeshellarg($username);
	//@exec($command, $output, $retval);
	$output = '';
	$retval = csSYNOPhotoMisc::ExecCmd('/usr/syno/bin/synophoto_dsm_user', array('--getshare', $username), false, $output);

	foreach ($output as $line) {
		$data = explode("\t", $line);
		if (2 > count($data)) {
			continue;
		}
		$item = array();
		$item['shareName'] = trim($data[0], "\n");
		$item['path'] = trim($data[1], "\n");
		$result[] = $item;
	}
	return $result;
}

function SYNOPHOTO_UPLOAD_EnumUserValidDir()
{
	$currpath = getcwd();
	$result = array();

	if ("1" !== csSYNOPhotoMisc::GetConfigDB("global", "account_system", "photo_config") && !$_SESSION[SYNOPHOTO_ADMIN_USER]['admin_syno_user']) {
		return json_encode($result);
	}

	//$command = "/usr/syno/bin/synophoto_dsm_user --listshare ";
	$user = '';
	if (isset($_SESSION[SYNOPHOTO_ADMIN_USER]['reg_syno_user'])) {
		//$command .= escapeshellarg($_SESSION[SYNOPHOTO_ADMIN_USER]['reg_syno_user']);
		$user = $_SESSION[SYNOPHOTO_ADMIN_USER]['reg_syno_user'];
	} else if (isset($_SESSION[SYNOPHOTO_ADMIN_USER]['admin_syno_user'])) {
		//$command .= escapeshellarg(("root" === SYNOPHOTO_ADMIN_USER)? "admin" : SYNOPHOTO_ADMIN_NAME);
		$user = ("root" === SYNOPHOTO_ADMIN_USER) ? "admin" : SYNOPHOTO_ADMIN_NAME;
	}
	//$command .= " ".escapeshellarg($_POST['node'])." dir";
	//@exec($command, $output, $retval);
	$output = '';
	$retval = csSYNOPhotoMisc::ExecCmd('/usr/syno/bin/synophoto_dsm_user', array('--listshare', $user, $_POST['node'], 'dir'), false, $output);

	foreach ($output as $fullfile) {
		// skip photo in remote mount (cifs) or read-only mount (iso9660)
		if (csSYNOPhotoMisc::isSkipPhotoDev($_POST['node'].'/'.$fullfile, $_SESSION[SYNOPHOTO_ADMIN_USER]['mount_dev_list'])
			|| !csSYNOPhotoMisc::IsUtf8($fullfile)) {
			continue;
		}
		if ("@eaDir" == $fullfile || $fullfile == '.' || $fullfile == '..') {
			continue;
		}
		$path = $_POST['node']."/".$fullfile;
		if ($path == SYNOPHOTO_SERVICE_REAL_DIR) {
			continue;
		}
		$item = array();
		$item['text'] = htmlspecialchars($fullfile);
		$item['id'] = $path;
		$result[] = $item;
	}
	chdir($currpath);
	return json_encode($result);
}

function GetDSMPhotoVideoFile($dir)
{
	$files['files'] = array();
	$currPath = getcwd();

	if ("1" !== csSYNOPhotoMisc::GetConfigDB("global", "account_system", "photo_config") && !$_SESSION[SYNOPHOTO_ADMIN_USER]['admin_syno_user']) {
		return $files;
	}

	//$command = "/usr/syno/bin/synophoto_dsm_user --listshare ";
	$user = '';
	if (isset($_SESSION[SYNOPHOTO_ADMIN_USER]['reg_syno_user'])) {
		//$command .= escapeshellarg($_SESSION[SYNOPHOTO_ADMIN_USER]['reg_syno_user']);
		$user = $_SESSION[SYNOPHOTO_ADMIN_USER]['reg_syno_user'];
	} else if (isset($_SESSION[SYNOPHOTO_ADMIN_USER]['admin_syno_user'])) {
		//$command .= escapeshellarg(("root" === SYNOPHOTO_ADMIN_USER)? "admin" : SYNOPHOTO_ADMIN_NAME);
		$user = ("root" === SYNOPHOTO_ADMIN_USER) ? "admin" : SYNOPHOTO_ADMIN_NAME;
	}
	//$command .= " ".escapeshellarg($dir)." file";
	//@exec($command, $output, $retval);
	$output = '';
	$retval = csSYNOPhotoMisc::ExecCmd('/usr/syno/bin/synophoto_dsm_user', array('--listshare', $user, $dir, 'file'), false, $output);

	$i = 0;
	foreach ($output as $fullfile) {
		$path = $dir . '/' . $fullfile;
		if (!csSYNOPhotoMisc::IsPhotoFile($path) && !csSYNOPhotoMisc::IsVideoFile($path)) {
			continue;
		}
		$type = 0;
		if (csSYNOPhotoMisc::IsVideoFile($path)) {
			$type = 1;
		}
		$item = array();
		$item['dir'] = htmlspecialchars($dir);
		$item['name'] = htmlspecialchars($fullfile);
		$item['item_id'] = htmlspecialchars($path);
		$item['dispaly_info'] = htmlspecialchars($path);
		$item['thumb_width'] = 50;
		$item['thumb_height'] = 50;
		if (!$type) {
			$item['type'] = 'photo';
			$item['url'] = './webapi/thumb.php?api=SYNO.PhotoStation.Thumb&method=get_dsm_thumb&version=1&path='.urlencode($path);
			$item['src'] = './webapi/thumb.php?api=SYNO.PhotoStation.Thumb&method=get_dsm_thumb&version=1&path='.urlencode($path);
		} else {
			$item['type'] = 'video';
			$item['url'] = './photo_new/images/Window/image_default_video_dark.png';
			$item['src'] = './photo_new/images/Window/image_default_video_dark.png';
		}
		$files['files'][$i] = $item;
		$i++;
	}
	@chdir($currPath);
	return $files;
}

function SYNOPHOTO_UPLOAD_CheckSubFolder()
{
	if (!isSet($_REQUEST['create_subfolder']) || $_REQUEST['create_subfolder'] == "") {
		$result['success'] = FALSE;
		$result['error'] = __(photo_str_error_unknown_desc);
		return $result;
	}

	$path = SYNOPHOTO_SERVICE_DIR."/".$_REQUEST['path']."/".$_REQUEST['create_subfolder'];
	if (file_exists($path)) {
		if (csSYNOPhotoMisc::CheckAlbumUploadable($_REQUEST['path']."/".$_REQUEST['create_subfolder'])) {
			$result['success'] = TRUE;
			return $result;
		}
		$result['success'] = FALSE;
		$result['error'] = __(photo_permission_denied);
		return $result;
	}
	$result['success'] = TRUE;
	return $result;
}

function SYNOPHOTO_UPLOAD_CheckPathIsInValidShare($fullPath)
{
	if (!csSYNOPhotoMisc::CheckPathValid($fullPath)) {
		return false;
	}

	$shareList = SYNOPHOTO_UPLOAD_GetUserValidShareList();

	foreach ($shareList as $share) {
		if (0 == strncmp($fullPath, $share['path'], strlen($share['path']))) {
			return true;
		}
	}
	return false;
}

?>
