<?php
require_once(dirname(__FILE__).'/../syno_conf.php');
require_once SYNOPHOTO_INCLUDE_EA;

function IsExiv2SupportWriteMode($path)
{
	$supported = array("jpg", "jpeg", "jpe", "png", "tiff", "tif", "cr2", "nef", "pef", "orf", "dng");

	$ext = pathinfo($path, PATHINFO_EXTENSION);

	return in_array(strtolower($ext), $supported);
}

function SYNOPHOTO_ROTATE_PIC_DoRotation($angle, $path)
{
	$result['success'] = FALSE;
	if (!isSet($angle) || !isSet($path) || !is_numeric($angle)) {
		return json_encode($result);
	}

	$dPath = substr($path, strlen(SYNOPHOTO_SERVICE_REAL_DIR_PREFIX));
	$query = "Select id, path from photo_image where path = ?";
	$db_result = PHOTO_DB_Query($query, array($dPath));
	if($row = PHOTO_DB_FetchRow($db_result)) {
		$path = SYNOPHOTO_SERVICE_REAL_DIR_PREFIX.$row['path'];
		$image_id = $row['id'];
	} else {
		return json_encode($result);
	}

	$dir_name = substr($path, 0, strlen($path) - strlen(basename($path)) - 1);

	if(SYNOPHOTO_ROTATE_PIC_ThumbLackCheck($path)) {
		$result['msg'] = __(photo_str_thumbing_wait_msg);
		return json_encode($result);
	}

	$rotate_list = array();
	$rotate_list[] = csSYNOPhotoMisc::GetThumbPathFromFullPath($path, SYNOPHOTO_THUMBSMALL, false);
	$rotate_list[] = csSYNOPhotoMisc::GetThumbPathFromFullPath($path, SYNOPHOTO_THUMBBIG, false);
	$rotate_list[] = csSYNOPhotoMisc::GetThumbPathFromFullPath($path, SYNOPHOTO_THUMBSMALLMEDIUM, false);
	$rotate_list[] = csSYNOPhotoMisc::GetThumbPathFromFullPath($path, SYNOPHOTO_THUMBMEDIUM, false);
	$rotate_list[] = csSYNOPhotoMisc::GetThumbPathFromFullPath($path, SYNOPHOTO_THUMBLARGE, false);
	$rotate_list[] = csSYNOPhotoMisc::GetThumbPathFromFullPath($path, SYNOPHOTO_THUMBXLARGE, false);

	SYNOPHOTO_ROTATE_PIC_UpdatePersonLabel($image_id, $path, $angle);

	$isSetToMetadata = csSYNOPhotoDB::GetDBInstance()->GetConfig('photo', 'set_orientation_to_metadata');

	if (('on' === $isSetToMetadata || true === $isSetToMetadata) && IsExiv2SupportWriteMode($path)) {
		update_exif_orientation($path, $angle);
	}

	SYNOPHOTO_ROTATE_PIC_ThumbRotate($angle, $rotate_list);
	SYNOPHOTO_ROTATE_PIC_UpdatePhotoVersion($path, $angle);
	$result['label'] = SYNOPHOTO_LABEL_UTIL_GetPhotoLabels($image_id);
	$result['success'] = TRUE;
	return json_encode($result);
}

function SYNOPHOTO_ROTATE_PIC_UpdatePersonLabel($image_id, $path, $angle)
{
	$data = SYNOPHOTO_LABEL_UTIL_GetPhotoLabels($image_id);

	for ($i = 0; $i < count($data['person']); $i++) {
		$info = json_decode($data['person'][$i]['info']);
		$new_info = SYNOPHOTO_ROTATE_PIC_GetNewInfo($path, $info, $angle);
		if (null != $info->face) {
			$new_info['face'] = SYNOPHOTO_ROTATE_PIC_GetNewInfo($path, $info->face, $angle);
		}
		$query = 'update photo_image_label set info_new = ? WHERE id = ?';
		$sqlParam = array(json_encode($new_info), $data['person'][$i]['id']);
		$db_result = PHOTO_DB_Query($query, $sqlParam);
	}
}

function SYNOPHOTO_ROTATE_PIC_GetNewInfo($path, $info, $angle)
{
	switch ($angle) {
	case 90:
		$result['x'] = floatval(1 - $info->height - $info->y);
		$result['y'] = floatval($info->x);
		$result['width'] = floatval($info->height);
		$result['height'] = floatval($info->width);
		break;
	case 270:
		$result['x'] = floatval($info->y);
		$result['y'] = floatval(1 - $info->width - $info->x);
		$result['width'] = floatval($info->height);
		$result['height'] = floatval($info->width);
		break;
	case 180:
		$result['x'] = floatval(1 - $info->width - $info->x);
		$result['y'] = floatval(1 - $info->height - $info->y);
		$result['width'] = floatval($info->width);
		$result['height'] = floatval($info->height);
		break;
	}
	return $result;
}

function SYNOPHOTO_ROTATE_PIC_UpdatePhotoVersion($path, $angle)
{
	$path = substr($path, strlen(SYNOPHOTO_SERVICE_REAL_DIR_PREFIX));
	$query = "Select version from photo_image where path = ?";
	$db_result = PHOTO_DB_Query($query, array($path));
	$row = PHOTO_DB_FetchRow($db_result);
	$old_version = $row[0];
	$offset = 1;
	if ($angle == 180) {
		$offset = 2;
	}
	$new_version = $old_version + $offset;
	$query = "UPDATE photo_image SET version = ? WHERE path = ?";
	$db_result = PHOTO_DB_Query($query, array($new_version, $path));

	/* search db cacher, update version */
	foreach($_SESSION[SYNOPHOTO_ADMIN_USER][DBCACHER_SESSION_ID] as $key => $cacheTuple) {
		if (!is_array($cacheTuple[DBCACHER_TUPLE_DATA])) {
			continue;
		}
		$key1 = $key;
		foreach ($cacheTuple[DBCACHER_TUPLE_DATA] as $sub_key => $dbTuple) {
			if ($path == $dbTuple['path']) {
				$key2 = $sub_key;
			}
		}
	}
	$_SESSION[SYNOPHOTO_ADMIN_USER][DBCACHER_SESSION_ID][$key1][DBCACHER_TUPLE_DATA][$key2]['version'] = $new_version;
}

function SYNOPHOTO_ROTATE_PIC_ThumbRotate($angle=0, $rotate_list)
{
	for($i = 0; $i < count($rotate_list); $i++) {
		if(!@file_exists($rotate_list[$i])) {
			continue;
		}
		$thumb_list = array_merge(array($rotate_list[$i], $rotate_list[$i] . '.bak'), glob($rotate_list[$i] . '.*.watermark'));
		foreach ($thumb_list as $thumb) {
			$rotated = $thumb . '.rotated';
			//$command = "/usr/bin/convert"
			//		." ".escapeshellarg($thumb)
			//		." -rotate ". escapeshellarg($angle)
			//		. " " . escapeshellarg($rotated);
			//@system($command);
			csSYNOPhotoMisc::ExecCmdNoOutput('/usr/bin/convert', array($thumb, '-rotate', $angle, $rotated));

			@unlink($thumb);
			@rename($rotated, $thumb);
		}
	}
}

function SYNOPHOTO_ROTATE_PIC_ThumbLackCheck($path)
{
	$thumbCheckList = array(
		SYNOPhotoEA::FILE_THUMB_XL,
		SYNOPhotoEA::FILE_THUMB_M
	);

	$eaDir = SYNOPhotoEA::getEADirPath($path);
	foreach ($thumbCheckList as $thumbType) {
		$exists = SYNOPhotoEA::checkFilePath($path, $thumbType, $eaPath);
		if (!$exists) {
			return true;
		}
	}
	return false;
}

function update_exif_orientation ($path, $degree)
{
	$normal_rotation = array(1,6,3,8,1,6,3,8);
	$flip_rotation = array(2,7,4,5,2,7,4,5);

	$angles = array(0, 90, 180, 270);

	$shift = array_search($degree, $angles);

	$orien_num = get_exif_orientation($path);

	$index = array_search($orien_num, $normal_rotation);
	$rotation_cycle = $normal_rotation;

	if (false === $index) {
		$index = array_search($orien_num, $flip_rotation);
		$rotation_cycle = $flip_rotation;
	}

	//@exec(sprintf("%s -M 'set Exif.Image.Orientation %d' %s", SYNO_EXIFTOOL_FILE, $rotation_cycle[$index+$shift], escapeshellarg($path)));
	csSYNOPhotoMisc::ExecCmd(SYNO_EXIFTOOL_FILE, array('-M',
		'set Exif.Image.Orientation ' . $rotation_cycle[$index + $shift],
		$path));

	csSYNOPhotoMisc::ExecCmd('/usr/syno/bin/synoindex', array('-P', 'SynologyMoments', '-R', $path));
}

#ex: exiv2 -Pkvt image.jpg | grep Orientation
#	Exif.Image.Orientation                        1  top, left
#	Xmp.tiff.Orientation                          1  top, left
function get_exif_orientation($path)
{
	$default = 1;	#top, left
	$exif= 0;
	$xmp = 0;

	$output = '';
	csSYNOPhotoMisc::ExecCmd(SYNO_EXIFTOOL_FILE, array('-Pkvt', $path), false, $output);

	foreach($output as $line) {
		preg_match("/(Exif\.Image\.Orientation|Xmp\.tiff\.Orientation)\s*(\d+)\s*.*/", $line, $matches);
		$key = $matches[1];
		$value = $matches[2];
		if ('Exif.Image.Orientation' === $key && $value) {
			$exif = $value;
		} else if ('Xmp.tiff.Orientation' === $key && $value) {
			$xmp = $value;
		}
	}
	return $exif ? $exif : ($xmp ? $xmp : $default);
}
?>
