<?php
require_once(SYNOPHOTO_INCLUDE_DIR."/syno_defines.php");
require_once(SYNOPHOTO_INCLUDE_DIR."/photo/synophoto_csPhotoMisc.php");
define('SYNOPHOTO_ACL_BIN', '/usr/syno/bin/synophoto_acl');

/*!
 * static misc function
 */
class csSYNOPhotoAcl {
	private static $aclEnabled = null;
	private static $aclSupport = null;

	static function IsAclEnabled() {
		$param = array("--check");

		if (is_bool(self::$aclEnabled)) {
			return self::$aclEnabled;
		}

		if (SYNOPHOTO_IS_PPS){
			array_push($param, SYNOPHOTO_ADMIN_NAME);
		}

		$result = csSYNOPhotoMisc::ExecCmd(SYNOPHOTO_ACL_BIN, $param);

		if (0 === $result) {
			self::$aclEnabled = true;
		} else {
			self::$aclEnabled = false;
		}

		if (2 === $result) {
			self::$aclSupport = false;
		} else {
			self::$aclSupport = true;
		}

		return self::$aclEnabled;
	}

	static function IsAclSupport() {
		if (!is_bool(self::$aclSupport)) {
			self::IsAclEnabled();
		}

		return self::$aclSupport;
	}

	static function Apply($path, $user) {
		if (SYNOPHOTO_IS_PPS) {
			if (0 === csSYNOPhotoMisc::ExecCmd(SYNOPHOTO_ACL_BIN, array('--apply_pps', $path, SYNOPHOTO_ADMIN_NAME))) {
				return true;
			}
		} else {
			if (isset($_SESSION[SYNOPHOTO_ADMIN_USER]) && true !== $_SESSION[SYNOPHOTO_ADMIN_USER]['use_dsm_account']) {
				$user = 'PhotoStation';
			}

			if (0 === csSYNOPhotoMisc::ExecCmd(SYNOPHOTO_ACL_BIN, array('--apply', $path, $user))) {
				return true;
			}
		}

		return false;
	}

	static function QuotaChown($path, $user) {
		if (SYNOPHOTO_IS_PPS) {
			if (0 === csSYNOPhotoMisc::ExecCmd(SYNOPHOTO_ACL_BIN, array('--pps_quota_chown', $path, SYNOPHOTO_ADMIN_NAME))) {
				return true;
			}
		} else {
			if (isset($_SESSION[SYNOPHOTO_ADMIN_USER]) && true !== $_SESSION[SYNOPHOTO_ADMIN_USER]['use_dsm_account']) {
				return true;
			}

			if (0 === csSYNOPhotoMisc::ExecCmd(SYNOPHOTO_ACL_BIN, array('--quota_chown', $path, $user))) {
				return true;
			}
		}

		return false;
	}
}
?>
