<?php
require_once(dirname(__FILE__).'/syno_conf.php');
require_once dirname(__FILE__).'/../vendor/autoload.php';

// For Photo Station 5
function SYNOPHOTO_SEND_MAIL_SendCommentMailToAdmin($comment_id = -1, $article_id = -1)
{
	$commentInfo = array();
	if ($comment_id == -1 && $article_id == -1) {
		$name = basename($_POST['path']);
		$commentInfo['title'] = $name;
		$dir = substr(str_replace("/".$name, "", $_POST['path']), strlen(SYNOPHOTO_SERVICE_REAL_DIR."/"));
		$commentInfo['albumTitle'] = $dir;
		$commentInfo['albumUrl'] = "?dir=".bin2hex($dir);
		$commentInfo['photoUrl'] = "?dir=".bin2hex($dir)."&name=".bin2hex($name);
	}

	$commentInfo['name'] = $_POST['name'];
	$commentInfo['email'] = $_POST['mail'];
	$commentInfo['comment'] = $_POST['comment'];

	SYNOPHOTO6_SEND_MAIL_SendCommentMailToAdmin($comment_id, $article_id, $commentInfo);
}

/**
 *	For Photo Station 6
 *	@param	comment_id	blog comment id
 *	@param	article_id	blog article_id
 *	@param	comment		photo comment params
 */
function SYNOPHOTO6_SEND_MAIL_SendCommentMailToAdmin($comment_id = -1, $article_id = -1, $comment) {
	//$command = '/usr/syno/bin/synophoto_config --get-mail';
	//@exec($command, $output, $ret);
	$output = '';
	$ret = csSYNOPhotoMisc::ExecCmd('/usr/syno/bin/synophoto_config_root', array('--get-mail'), false, $output);
	if ($ret !== 0) {
		return;
	}
	try {
		$mailConfig = json_decode($output[0], true);
	} catch (Exception $e) { return; }

	$sender_mail = $mailConfig["sender_mail"] ? $mailConfig["sender_mail"] : $mailConfig["mail"][0];
	$to = $mailConfig["mail"];

	$apName = __(photo_str_ap_name_6);
	$photoUrlPath = "/photo/";
	$albumUrlPath = "/photo/";

	$sender_name = $apName." Comment";
	$subject = '['.$apName.'] '.__(photo_str_email_comment_subject);

	$server_ip = csSYNOPhotoMisc::GetServerHost();

	$message = __(photo_str_email_comment_body1).",<br><br>";
	$message = $message.__(photo_str_email_comment_body2)."<br><br>";
	if ($comment_id == -1 && $article_id == -1) {
		$title = htmlspecialchars($comment['title']);
		$albumTitle = htmlspecialchars($comment['albumTitle']);
		if(isset($comment['photoUrl']) && isset($comment['albumUrl'])) {
			$photoUrl = $comment['photoUrl'];
			$albumUrl = $comment['albumUrl'];
			$message = $message.__(photo_str_photoalbum).": <a href='{$server_ip}".SYNOPHOTO_URL_PREFIX.$albumUrlPath.$albumUrl."'>".__(photo_str_photoalbum)."/".$albumTitle."</a><br>";
			$message = $message.__(photo_str_photoalbum_title).": <a href='{$server_ip}".SYNOPHOTO_URL_PREFIX.$photoUrlPath.$photoUrl."'>".$title."</a><br>";
		} else {
			$message = $message.__(photo_str_photoalbum).": ".__(photo_str_photoalbum)."/".$albumTitle."<br>";
			$message = $message.__(photo_str_photoalbum_title).": ".$title."<br>";
		}
	} else {
		$query = "Select * from blog_comment where comment_id = ?";
		$db_result = PHOTO_DB_Query($query, array($comment_id));
		if(!($row = PHOTO_DB_FetchRow($db_result))) {
			return;
		}
		$query = "Select title from blog_article where article_id = ?;";
		$db_result = PHOTO_DB_Query($query, array($row[1]));
		$row_2 = PHOTO_DB_FetchRow($db_result);
		$message = $message.__(photo_str_photoalbum_title).": <a href='".$server_ip.SYNOPHOTO_URL_PREFIX."/blog/#param=id_".$row[1]."'>".$row_2[0]."</a><br>";
	}
	$message = $message.__(photo_str_log_date_time).": ".date('Y/m/d H:i:s')."<br>";
	$message = $message.__(photo_str_comment_name).": ".htmlspecialchars($comment['name'])."<br>";
	$message = $message.__(photo_str_comment_email).": ".htmlspecialchars($comment['email'])."<br>";
	$message = $message.__(photo_str_comment).": <br><br>".nl2br(htmlspecialchars($comment['comment']))."<br>";

	$message = $message."<br><br>Sincerely,<br>".$apName;

	$mail = new PHPMailer;
	$mail->isMail(); // use mail() to send
	$mail->CharSet = 'UTF-8';
	$mail->setFrom($sender_mail, $sender_name);

	if ('root' == SYNOPHOTO_ADMIN_USER || 'admin' == SYNOPHOTO_ADMIN_NAME) {
		if (!$to || ('' == $to[0] && '' == $to[1])) {
			return;
		}
		$mail->addAddress($to[0]);
		$mail->addCC($to[1]);
	} else {
		$user_email = csSYNOPhotoMisc::GetSynoUserEmail(SYNOPHOTO_ADMIN_NAME);
		if ('' == $user_email) {
			return;
		}
		$mail->addAddress($user_email);
	}

	$query = "Select author from blog_article where article_id = ?;";
	$db_result = PHOTO_DB_Query($query, array($article_id));
	$row = PHOTO_DB_FetchRow($db_result);
	if($row[0] != 'admin') {
		$query = "Select email from photo_user where username = ?;";
		$db_result = PHOTO_DB_Query($query, array($row[0]));
		if(($row = PHOTO_DB_FetchRow($db_result))) {
			if($row[0] != null && $row[0] != "") {
				$mail->addBCC($row[0]);
			}
		}
	}

	$mail->Subject = $subject;
	$mail->isHTML();
	$mail->msgHTML($message);
	@$mail->send();
}
