<?php
function PHOTO_DB_Close() {
	$GLOBALS['dbconn_photo'] = null;
	csSYNOPhotoAlbum::DestroyAlbumInstance();
	SmartAlbum::DestroySmartAlbumInstance();
	csSYNOPhotoDB::DestroyDBInstance();
}

function PHOTO_DB_GetType(){
	if (!$GLOBALS['db_type']) {
		$GLOBALS['db_type'] = $GLOBALS['dbconn_photo']->getAttribute(constant("PDO::ATTR_DRIVER_NAME"));
	}
	return $GLOBALS['db_type'];
}

//sqlite should defind escape char for each LIKE
function PHOTO_DB_GetEscape(){
	$db_type = PHOTO_DB_GetType();
	if ('sqlite' == $db_type) {
			return "ESCAPE '\'";
	}
	return '';
}

function DB_Query($dbconn, $query, $param = array())
{
	$stmt = $dbconn->prepare($query);
	$rs = $stmt->execute($param);
	if ($rs === false) {
		return false;
	}
	return $stmt;
}

function PHOTO_DB_Query($query, $param=array())
{
	return DB_Query($GLOBALS['dbconn_photo'], $query, $param);
}

function PHOTO_DB_FetchRow($stmt)
{
	if (false === $stmt) {
		return false;
	}
	$row = $stmt->fetch();
	return $row;
}

function PHOTO_DB_FetchAll($stmt)
{
	if (false === $stmt) {
		return false;
	}
	$rows = $stmt->fetchAll();
	return $rows;
}

//query must use count()
function PHOTO_DB_QueryCount($dbconn, $query, $param=array())
{
	$stmt = $dbconn->prepare($query);
	$rs = $stmt->execute($param);
	$row = $stmt->fetch();
	return $row[0];
}

//just for insert, delete, update
function PHOTO_DB_AffectedRows($stmt)
{
	$count = $stmt->rowCount();
	return $count;
}

//for pgsql, sqlite boolean type is different
function PHOTO_DB_IsTrue($var)
{
	return ($var == 't' || $var === true);
}

//convert boolean True/False to 't'/'f'
function PHOTO_DB_ConvertBool($var)
{
	return ($var === true || $var == 't') ? 't' : 'f';
}

function PHOTO_DB_EscapForLike($val){
	$val = str_replace('\\', '\\\\', $val);
	$val = str_replace('_', '\\_', $val);
	$val = str_replace('%', '\\%', $val);
	return $val;
}

function PHOTO_DB_BeginTransaction() {
	return $GLOBALS['dbconn_photo']->beginTransaction();
}

function PHOTO_DB_Commit() {
	return $GLOBALS['dbconn_photo']->commit();
}

function PHOTO_DB_RollBack() {
	return $GLOBALS['dbconn_photo']->rollBack();
}

function PHOTO_DB_lastInsertId($table='') {
	return $GLOBALS['dbconn_photo']->lastInsertId($table);
}

// for compatible with pgsql, sqlite limit offset
function PHOTO_DB_GetLimitOffsetString($limit, $offset = 0)
{
	$limit = (int) $limit;
	$offset = (int) $offset;

	$db_type = PHOTO_DB_GetType();
	if ($limit < 0) {
		$limitString = "sqlite" === $db_type ? "LIMIT -1" : "";
	} else {
		$limitString = "LIMIT $limit";
	}
	$offsetString = $offset ? "OFFSET $offset" : '';

	return "$limitString $offsetString";
}

function PHOTO_DB_IsAdminUid($uid)
{
	return $uid === 0 || $uid === '0';
}

