<?php
require_once("include/syno_conf.php");
require_once('webapi/authutil.php');

if (!isSet($_GET['sid']) && !isSet($_GET['usr']) && !isSet($_GET['url']) && !isSet($_GET['albumName']) && !isSet($_GET['password'])) {
	header("HTTP/1.1 301 Moved Permanently");
	header('location: ' . SYNOPHOTO_URL_PREFIX . '/photo/');
	exit;
}

if (isSet($_GET['sid']) && isSet($_GET['usr'])) {
    $isDemoMode = csSYNOPhotoMisc::GetConfigFile(SYNO_CNF_FILE, 'enable_demomode');
	// need these params first
	if (('yes' !== $isDemoMode['enable_demomode']) && ('root' != SYNOPHOTO_ADMIN_USER || $_SESSION[SYNOPHOTO_ADMIN_USER]['use_dsm_account'] || strtoupper($_GET['usr']) == "ADMIN") &&
		// leave when not personal and not dsm account and not admin
		 (
			(isSet($_SESSION[SYNOPHOTO_ADMIN_USER]['reg_syno_user']) && $_SESSION[SYNOPHOTO_ADMIN_USER]['reg_syno_user'] == $_GET['usr']) ||
			((strtoupper($_GET['usr']) == "ADMIN" || strtoupper($_GET['usr']) == strtoupper(SYNOPHOTO_ADMIN_NAME)) &&
				!isSet($_SESSION[SYNOPHOTO_ADMIN_USER]['reg_syno_user']) && isSet($_SESSION[SYNOPHOTO_ADMIN_USER]['admin_syno_user']) &&
				$_SESSION[SYNOPHOTO_ADMIN_USER]['admin_syno_user'] == SYNOPHOTO_ADMIN_PASS) ||
					loginFromDsm($_GET['usr'], $_GET['sid'], $_GET['SynoToken'])
		// user alredy login or loginFromDsm() return true, we done.
		)) {
		header("HTTP/1.1 301 Moved Permanently");
		header('location: ' . SYNOPHOTO_URL_PREFIX . '/photo/#fromDsm');
		exit;
	}
}

if (isSet($_GET['sid'])) {
	// not login from dsm.
	header("HTTP/1.1 301 Moved Permanently");
	header('location: ' . SYNOPHOTO_URL_PREFIX . '/photo/');
	exit;
}

$LANGUAGE = $_SESSION[SYNOPHOTO_ADMIN_USER]['lang'];

require_once('include/content_security_policy.php');
?>
<!DOCTYPE html>
<html>
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
	<link rel="shortcut icon" href="images/ps_icon.png">
	<!-- GC -->
<?php
	$cssFiles = array(
		"scripts/ext-3/resources/css/ext-all.css",
		"scripts/ext-3/resources/css/xtheme-gray.css",
		"css/dsm_resources/css/desktop.css",
		"css/common.css",
		"css/photo_style.css"
	);

	foreach ($cssFiles as $item) {
		printf(
			"\t" . '<link rel="stylesheet" type="text/css" href="%s" />' . "\n",
			csSynoPhotoMisc::GetFileWithMtime($item)
		);
	}
?>
	<!-- LIBS -->
<?php
	$jsFiles = array(
		"js_php/prevent_iframe.js.php",
		"scripts/uistrings.php?ln=$LANGUEGE",
		"scripts/ext-3/adapter/ext/ext-base.js",
		"scripts/ext-3/ext-all.js",
		"scripts/ext-3/ux/ux-all.js",
		"include/client_string.php?ln=$LANGUEGE",

		"javascripts/synophoto_common.js"
	);

	foreach ($jsFiles as $item) {
		printf(
			"\t" . '<script type="text/javascript" src="%s%s"></script>' . "\n",
			csSynoPhotoMisc::GetFileWithMtime($item), ($DEBUG === true) ? '&_dc='.time() : ''
		);
	}
?>

	<style type="text/css">
		html, body {height: 100%}
	</style>
</head>
<body>
<div class="login-div" id="syno_login_dialog">
	<div class="header"> <span class="ap-name">Photo station</span> <span class="close-btn" id="syno_login_close"></span></div>
	<iframe name="login_iframe" width="0" height="0" frameborder="0"></iframe>
		<form id="login_form" class="login_form" method="GET" action="photo_login.php" target="login_iframe">
		<input type="hidden" id="login_action" name="action" value="login" />
		<input type="text" id="login_username" name="username" class="sbox-text login-input" />
		<input type="password" id="login_passwd" name="passwd" class="sbox-text login-input" autocomplete="off"/>
		<input type="submit" id="login_submit" name="submit" style="display: none;">
	</form>
	<div class="login-btn" id="syno_login_enter"></div>
	<div class="login-status login_error" id="login_status"></div>
</div>
<script src="<?php echo csSynoPhotoMisc::GetFileWithMtime("js_php/login.js.php"); ?>&url=<?php echo rawurlencode($_GET['url']); ?><?php if (isset($_GET['password'])) { echo '&albumName=' . rawurlencode($_GET['albumName']); } ?>"></script>
</body>
</html>
<?php
function loginFromDsm ($user, $session_id, $synotoken)
{
	$login_status = false;

	$enable_demomode = false;
	$conf = csSYNOPhotoMisc::GetConfigFile(SYNO_CNF_FILE, 'enable_demomode');
	if ('yes' == $conf['enable_demomode']) {
		$enable_demomode = true;
	}

	AuthAPIUtil::SYNOPHOTO_LOGIN_AddEnv();
	$ip = AuthAPIUtil::SYNOPHOTO_LOGIN_GetRemoteIP();

	if (AuthAPIUtil::SYNOPHOTO_LOGIN_AutoBlockIsDeniedIP($ip)) {
		return $login_status;
	}

	//$command = "/usr/syno/bin/synophoto_dsm_user --current ".escapeshellarg($user)." ".escapeshellarg($session_id)." ".escapeshellarg($ip);
	//@exec($command, $isValidUser, $retval);
	$isValidUser = '';
	if (empty($synotoken)) {
		$synotoken = '';
	}
	$retval = csSYNOPhotoMisc::ExecCmd('/usr/syno/bin/synophoto_dsm_user', array('--current', $user, $session_id, $ip, $synotoken), false, $isValidUser);

	if (0 === $retval) {
		$login_status = true;
	} else {
		PhotoLog::Add("Failed to get user data.", false, $user);
		return $login_status;
	}

	if (false == $login_status) {
		if ($enable_demomode) {
			PhotoLog::Add($user." failed to log in from "."[xxx.xxx.xxx.xxx].", false, $user);
		} else {
			PhotoLog::Add($user." failed to log in from "."[".$ip."].", false, $user);
		}
		return $login_status;
	}

	// get user info
	$user_info = array();
	//$command = "/usr/syno/bin/synophoto_dsm_user --getinfo ".escapeshellarg($user);
	//@exec($command, $pUser, $retval);
	$pUser = '';
	$retval = csSYNOPhotoMisc::ExecCmd('/usr/syno/bin/synophoto_dsm_user', array('--getinfo', $user), false, $pUser);
	$user_info = SYNOPHOTO_LoginUserDataPaser($pUser, $user, $ip);
	if (0 != $retval) {
		if ($enable_demomode) {
			PhotoLog::Add($user." failed to log in from "."[xxx.xxx.xxx.xxx].", false, $user);
		} else {
			PhotoLog::Add($user." failed to log in from "."[".$ip."].", false, $user);
		}
		return 0;
	}

	//login act
	unset($_SESSION[SYNOPHOTO_ADMIN_USER]);
	csSYNOPhotoMisc::PhotoSessionStart();
	csSYNOPhotoDB::GetDBInstance()->SetSessionSystemConfigsFromFile();

	if (strtoupper($user) == "ADMIN" || strtoupper($user_info[0]) == strtoupper(SYNOPHOTO_ADMIN_NAME) ) {// admin
		$_SESSION[SYNOPHOTO_ADMIN_USER]['admin_syno_user'] = SYNOPHOTO_ADMIN_PASS;
	} else {// user
		$_SESSION[SYNOPHOTO_ADMIN_USER]['reg_syno_userid'] = $user_info[2];
		$_SESSION[SYNOPHOTO_ADMIN_USER]['reg_syno_user'] = $user_info[0];
		$_SESSION[SYNOPHOTO_ADMIN_USER]['use_dsm_account'] = true;
		$_SESSION[SYNOPHOTO_ADMIN_USER]['reg_syno_groupid'] = $user_info['groups'];
		if ($user_info[10]) {
			$_SESSION[SYNOPHOTO_ADMIN_USER]['admin_syno_user'] = SYNOPHOTO_ADMIN_PASS;
		}
	}

	// user coming from DSM must use syno_token
	$_SESSION[SYNOPHOTO_ADMIN_USER]['enable_syno_token'] = true;

	AuthAPIUtil::SYNOPHOTO_LOGIN_AutoBlockResetIP($ip);
	if ($enable_demomode) {
		PhotoLog::Add($user." logged in from "."[xxx.xxx.xxx.xxx].", true, strtolower($user));
	} else {
		PhotoLog::Add($user." logged in from "."[".$ip."].", true, strtolower($user));
		PhotoLog::RecordUserAgent();
	}
	return $login_status;

}

function SYNOPHOTO_LoginUserDataPaser($pUser, $user, $ip)
{
	global $SYNOPHOTO_DSM_USER_INFO;
	$result = array();
	if (!is_array($pUser)) {
		return null;
	}
	$i = 0;
	$groups = array();
  foreach ($pUser as $item) {
    if (preg_match('/^Member\sOf:\s+\[(.+)\]$/', $item, $match)) {
      $groups = array();
      $groups_size = $match[1];
    }
		if (!preg_match('/([\w\s]*)\:/', $item, $match_val) && preg_match('/\((\d+)\)/', $item, $match)) {
			$groups[] = $match[1];
		}

		if (!preg_match('/(^\w+\s?\w+)\s*\:/', $item, $match) || !preg_match('/\[(.*)\]/', $item, $match_val)) {
			continue;
		}

    if (false !== $index = array_search($match[1], $SYNOPHOTO_DSM_USER_INFO)) {
      if (isset($result[$index])) {
        PhotoLog::Add($user." try to attack the platform... "."[".$ip."].", false, strtolower($user));
        exit(0);
      }
			$result[$index] = $match_val[1];
		}
  }
  if(sizeof($groups) != $groups_size){
    PhotoLog::Add($user." wants to access secret pictures... "."[".$ip."].", false, strtolower($user));
    exit(0);
  }
	$result['groups'] = implode(',', $groups);
	return $result;
}
?>
