<?php
require_once("../include/syno_conf.php");

if (csSYNOPhotoMisc::checkRedirectToHttps()) {
	csSYNOPhotoMisc::RedirectToHttps();
	exit();
}

// force clear cache when user refresh browser
csSYNOPhotoDB::GetDBInstance()->SetSessionCache(true);

$LANGUEGE = $_SESSION[SYNOPHOTO_ADMIN_USER]['lang'];
$DEBUG = isset($_GET['jsDebug']);
$PAGE_TITLE = csSYNOPhotoMisc::GetConfigDB("photo", "photo_page_title", "photo_config");
if (empty($PAGE_TITLE)) {
	$PAGE_TITLE = "Photo Station 6";
}
$PAGE_TITLE = htmlentities($PAGE_TITLE);
$blDemoMode = 'false';
$isDemoMode = csSYNOPhotoMisc::GetConfigFile(SYNO_CNF_FILE, 'enable_demomode');
if ('yes' === $isDemoMode['enable_demomode']) {
    $blDemoMode = 'true';
}
$photo_config_theme = $_SESSION[SYNOPHOTO_ADMIN_USER]['photo_config']['theme'];
$SHARE_DATA = GetShareData();

require_once('../include/content_security_policy.php');
require_once('../include/x_frame_options.php');
?>
<!DOCTYPE html>
<html>
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
	<meta http-equiv="X-UA-Compatible" content="IE=11" />
	<meta name="viewport" content="width=device-width, initial-scale=1.0001, minimum-scale=1.0001, maximum-scale=1.0001, user-scalable=no">
	<?php echo csSYNOPhotoMisc::GetMetaRobots(); ?>

	<!-- Facebook sharing meta tags -->
	<meta property="og:type" content="<?php echo $SHARE_DATA['type'] ?>" />
	<meta property="og:title" content="<?php echo $SHARE_DATA['title'] ?>" />
	<meta property="og:description" content="<?php echo $SHARE_DATA['description'] ?>" />
	<meta property="og:image" content="<?php echo $SHARE_DATA['img'] ?>" />
	<meta property="og:url" content="<?php echo $SHARE_DATA['url'] ?>" />
	<!-- Google+ sharing meta tags -->
	<meta itemprop="name" content="<?php echo $SHARE_DATA['title'] ?>" />
	<meta itemprop="description" content="<?php echo $SHARE_DATA['description'] ?>" />
	<meta itemprop="image" content="<?php echo $SHARE_DATA['img'] ?>">
	<!-- SEO -->
	<!-- javascript -->
<?php
	$debugTrueParameter = ($DEBUG === true) ? "&debug=true" : "";
	$jsFiles = array(
		"../js_php/prevent_iframe.js.php",
		"../scripts/uistrings.php?ln=$LANGUEGE",
		"../photo_new/jquery-1.11.0.min.js",
		"../photo_new/flux.min.js",
		"../scripts/ext-3/adapter/ext/ext-base.js",
		"../scripts/ext-3/ext-all.js",
		"../scripts/ext-3/ux/ux-all.js",
		"../scripts/scrollbar/flexcroll.js",
		"../include/client_string.php?ln=$LANGUEGE",
		"../jwplayer/jwplayer.js",
		"../js_php/index.js.php?language=$LANGUEGE&demo_mode=false$debugTrueParameter",

		"../photo_new/syno_photo_mobile.js",
	);

	foreach ($jsFiles as $item) {
		printf(
			"\t" . '<script type="text/javascript" src="%s%s"></script>' . "\n",
			csSynoPhotoMisc::GetFileWithMtime($item), ($DEBUG === true) ? '&_dc='.time() : ''
		);
	}
?>

	<!-- style sheet -->
<?php
	$cssFiles = array(
		"../scripts/ext-3/resources/css/ext-all.css",
		"../scripts/ext-3/resources/css/xtheme-gray.css",
		"../scripts/ext-3/ux/ux-all-default.css",
		"../photo_new/css/style.css",
		"../photo_new/css/style_mobile.css",
	);

	foreach ($cssFiles as $item) {
		printf(
			"\t" . '<link rel="stylesheet" type="text/css" href="%s%s" />' . "\n",
			csSynoPhotoMisc::GetFileWithMtime($item), ($DEBUG === true) ? '&_dc='.time() : ''
		);
	}
?>
	<link rel="shortcut icon" href="favicon.ico">

	<title><?php echo $PAGE_TITLE ?></title>
</head>
<body>
	<iframe id="login_iframe" name="login_iframe" width="0" height="0" frameborder="0"></iframe>
	<form id="login_form" class="login_form" method="POST" action="<?php echo SYNOPHOTO_URL_PREFIX."/photo/" ?>webapi/auth.php" target="login_iframe" style="filter: Alpha(opacity=0); opacity: 0;">
		<input type="text" id="login_api" name="api" class="sbox-text login-input" />
		<input type="text" id="login_method" name="method" class="sbox-text login-input" />
		<input type="text" id="login_version" name="version" class="sbox-text login-input" />
		<input type="text" id="login_username" name="username" class="sbox-text login-input" />
		<input type="password" id="login_password" name="password" class="sbox-text login-input" autocomplete="off"/>
		<input type="checkbox" id="login_remember_me" name="remember_me" />
		<input type="hidden" id="enable_syno_token" name="enable_syno_token" value="true" />
		<input type="submit" style="display: none;">
	</form>
	<form id="history-form" class="x-hidden">
		<input type="hidden" id="x-history-field" />
		<iframe id="x-history-frame"></iframe>
	</form>
</body>
</html>
<?php

function GetShareData()
{
	$data = false;

	//parse token
	$token = '';
	if (isset($_GET['_escaped_fragment_'])) {
		$token = $_GET['_escaped_fragment_'];
	} else if (isset($_REQUEST['t'])) {
		$token = $_REQUEST['t'];
	}
	$tokenParts = explode('/', $token);
	$id = $tokenParts[count($tokenParts) - 1];
	$idParts = explode('_', $id);
	$count = count($idParts);

	if (2 === $count) {
		if ('album' === $idParts[0]) {
			$data = GetAlbumShareData($idParts[1]);
		} else if ('smart' === $idParts[0]) {
			$data = GetSmartShareData($idParts[1]);
		} else if ('tag' === $idParts[0]) {
			$data = GetTagShareData($idParts[1]);
		} else if ('category' === $idParts[0]) {
			$data = GetCategoryShareData($idParts[1]);
		}
	} else if (3 === $count) {
		if ('photo' === $idParts[0] || 'video' === $idParts[0]) {
			$data = GetPhotoVideoShareData($idParts[1], $idParts[2]);
		}
	}

END:
	if (false === $data) {
		$data = GetDefaultShareData();
	}
	return FormData($data, "/photo/" . ($token ? "?t=$token#$token" : ""));
}

function GetAlbumShareData($album)
{
	$albumName = @pack('H*', $album);

	if (!csSYNOPhotoMisc::CheckAlbumAccessible($albumName)) {
		return false;
	}

	$albums = Album::GetBySharename(array($albumName));
	$albumInfo = $albums[$albumName];

	$result = csSYNOPhotoAlbum::GetAlbumInstance()->GetAlbumCover($albumName);

	if (empty($result['coverPath'])) {
		$img = $result['cover']['src'];
	} else {
		$img = GetThumbUrl('album_' . $album);
	}

	return array(
		'type' => 'album',
		'title' => $albumInfo['title'],
		'desc' => $albumInfo['description'],
		'img' => $img
	);
}

function GetSmartShareData($smart)
{
	$smartName = @pack('H*', $smart);
	$cover = SmartAlbum::GetSmartAlbumInstance()->GetCoverOfSmartAlbumByName($smartName);

	if (!$cover['success']) {
		return false;
	};

	return array(
		'type' => 'album',
		'title' => $smartName,
		'desc' => '',
		'img' => GetThumbUrl('smart_' . $smart)
	);
}

function GetTagShareData($tag)
{
	require_once('include/label.php');
	$tags = Label::GetByIds(array($tag));
	if (!$tags[$tag]) {
		return false;
	}
	$title = $tags[$tag]['name'];

	return array(
		'type' => 'album',
		'title' => $title,
		'desc' => '',
		'img' => GetThumbUrl('tag_' . $tag)
	);
}

function GetCategoryShareData($category)
{
	global $photo_config_theme;

	//admin-check is totally unnecessary, because social network will nerver login as admin
	$isAdmin = isset($_SESSION[SYNOPHOTO_ADMIN_USER]['admin_syno_user']);
	$hidden = csSYNOPhotoDB::GetDBInstance()->IsCategoryAccessible($category);
	if (false === $isAdmin && true === $hidden) {
		return false;
	}

	$objs = Category::GetByIds(array($category));
	$dbCategory = $objs[$category];
	if (!$dbCategory) {
		return false;
	}

	return array(
		'type' => 'album',
		'title' => $dbCategory['name'],
		'desc' => '',
		'img' => "/photo/photo_new/images/" . (($photo_config_theme['template'] === 'Black') ? 'Black' : 'White') . '/logo_ps6.png'
	);
}

function GetPhotoVideoShareData($album, $file)
{
	$albumName = @pack('H*', $album);
	$fileName = @pack('H*', $file);

	$path = realpath(SYNOPHOTO_SERVICE_REAL_DIR . "/" . $albumName . "/" . $fileName);

	if (0 !== strncmp($path, SYNOPHOTO_SERVICE_REAL_DIR . "/", strlen(SYNOPHOTO_SERVICE_REAL_DIR) + 1)) {
		return false;
	}
	if (!@file_exists($path)) {
		return false;
	}
	if (!csSYNOPhotoMisc::CheckAlbumAccessible($albumName)) {
		return false;
	}

	$isPhoto = csSYNOPhotoMisc::IsPhotoFile($path);
	$dbPath = SYNOPHOTO_SERVICE_REAL_DIR_PATH. $albumName . "/" . $fileName;

	if ($isPhoto) {
		$type = 'album';
		$items = File::GetPhotoByDBPath(array($dbPath));
		$info = $items[$dbPath];
	} else {
		$type = 'movie';
		$items = File::GetVideoByDBPath(array($dbPath));
		$info = $items[$dbPath];
	}

	return array(
		'type' => $type,
		'title' => $info['title'],
		'desc' => $info['description'],
		'img' => GetThumbUrl(($isPhoto ? 'photo_' : 'video_') . $album . '_' . $file)
	);
}

function GetDefaultShareData()
{
	global $PAGE_TITLE, $photo_config_theme;

	$desc = csSYNOPhotoDB::GetDBInstance()->GetConfig('main', 'main_page_desc');
	if (empty($desc) || $desc === __(photo_str_add_description)) {
		$desc = '';
	}

	return array(
		'type' => 'album',
		'title' => $PAGE_TITLE,
		'desc' => $desc,
		'img' => "/photo/photo_new/images/" . (($photo_config_theme['template'] === 'Black') ? 'Black' : 'White') . '/logo_ps6.png'
	);
}

function GetThumbUrl($id)
{
	return '/photo/webapi/thumb.php?' . http_build_query(
		array(
			'api' => 'SYNO.PhotoStation.Thumb',
			'version' => 1,
			'method' => 'get',
			'id' => $id,
			'size' => 'small'
		),
		'',
		'&'
	);
}

function FormData($data, $url)
{
	$urlPrefix = csSYNOPhotoMisc::GetServerHost().SYNOPHOTO_URL_PREFIX;

	return array(
		'type' => htmlspecialchars($data['type']),
		'title' => htmlspecialchars($data['title']),
		'description' => htmlspecialchars($data['desc']),
		'img' => $urlPrefix . $data['img'],
		'url' => $urlPrefix . $url
	);
}

?>
