<?php
chdir('/var/packages/PhotoStation/target/photo/webapi/');
require_once('authutil.php');

if ($_GET['action'] == "logout") {
	unset($_SESSION[SYNOPHOTO_ADMIN_USER]);
	if ($_GET['redirect'] == "photo") {
		header("Location: ".SYNOPHOTO_URL_PREFIX."/photo/index.php");
	} else {
		header("Location: ".SYNOPHOTO_URL_PREFIX."/blog/index.php");
	}
	exit;
}

if ($_POST['action'] == "login") {
	$user_name = csSYNOPhotoMisc::UserLoginNameConvert($_POST['username']);
	$auth_result = '';

	AuthAPIUtil::SYNOPHOTO_LOGIN_AddEnv();

	if (strtoupper($_POST['username']) == "ADMIN" || strtoupper($user_name) == strtoupper(SYNOPHOTO_ADMIN_NAME)) {
		//if username is ADMIN
		$ret = AuthAPIUtil::SYNOPHOTO_LOGIN_ValidateAdmin($auth_result);
		if(1 == $ret) {
			$login_result['success'] = TRUE;
		} else {
			$login_result['success'] = 'login_error';
		}
	//user is not admin
	} else {
		if ("0" == $_SESSION[SYNOPHOTO_ADMIN_USER]['photo_config']['global']['account_system'] || 'root' != SYNOPHOTO_ADMIN_USER){
			$ret = AuthAPIUtil::SYNOPHOTO_LOGIN_ValidateUser();
		} else {
			//DSM account system and not personal photo station
			$ret = AuthAPIUtil::SYNOPHOTO_LOGIN_ValidateDsmUser($auth_result);
		}

		if ($ret == -1) {
			$login_result['success'] = 'disable_account';
		} else if ($ret == -4) {
			$login_result['success'] = 'login_noprivilege';
		} else if ($ret == -5) {
			$login_result['success'] = 'max_tries';
		} else if ($ret == 1) {
			$login_result['success'] = TRUE;
		} else {
			$login_result['success'] = 'login_error';
			$login_result['not_photo_user'] = ($ret == -2);
		}
	}

	if (1 != $ret && !empty($auth_result)) {
		if ("-3" == $auth_result) {
			$login_result['success'] = 'login_noprivilege';
		} else if ("-8" == $auth_result) {
			$login_result['success'] = 'max_tries';
		}
	}

	if (1 === $ret) {
		csSYNOPhotoMisc::RegenSessionId();
	}

	$login_result['run_photo'] = csSYNOPhotoMisc::checkServiceEnabled() && file_exists(SYNOPHOTO_SERVICE_DIR);
	$login_result['has_photo_root_path'] = (SYNOPHOTO_SERVICE_REAL_DIR != false);
	echo json_encode($login_result);
}
function SYNOPHOTO_LOGIN_Is_DSM()
{
	$result = csSYNOPhotoMisc::GetConfigDB("global", "account_system", "photo_config");
	if ($result == null || $result == "") {
		$result = "0";
	}
	return ($result == "0") ? FALSE : TRUE;
}

function SYNOPHOTO_LOGIN_USERDATA_PARSER($pUser)
{
	global $SYNOPHOTO_DSM_USER_INFO;
	$result = array();
	if (!is_array($pUser)) {
		return null;
	}
	$i = 0;
	$groups = array();
	foreach ($pUser as $item) {
    if (preg_match('/^Member\sOf:\s+\[(.+)\]$/', $item, $match)) {
      $groups = array();
      $groups_size = $match[1];
    }
    if (!preg_match('/([\w\s]*)\:/', $item, $match_val) && preg_match('/\((\d+)\)/', $item, $match)) {
			$groups[] = $match[1];
		}

		if (!preg_match('/(^\w+\s?\w+)\s*\:/', $item, $match) || !preg_match('/\[(.*)\]/', $item, $match_val)) {
			continue;
		}

    if (false !== $index = array_search($match[1], $SYNOPHOTO_DSM_USER_INFO)) { // $key = 2;
      if (isset($result[$index])) {
        // someone try to overwrite field
        exit(0);
      }
			$result[$index] = $match_val[1];
		}
	}
  if(sizeof($groups) != $groups_size){
    // extract groups size not match group member size
    exit(0);
  }
  $result['groups'] = implode(',', $groups);
	return $result;
}

?>
