<?php
require_once("include/syno_conf.php");

header('Content-Type: application/rss+xml');
csSYNOPhotoDB::GetDBInstance()->SetSessionCache(true);

$is_for_dir = 0;
if(isset($_GET['dir']) && $_GET['dir'] != "") {
	if (!csSYNOPhotoMisc::CheckAlbumAccessible($albumName = @pack('H*', $_GET['dir']))) {
		header("Location: index.php");
		exit;
	}
	$is_for_dir = 1;
}

$is_for_smart_album = 0;
$is_for_virtual_album = 0;
$smartType = 0;
$virtualType = '';
if(isset($_GET['smart_album']) && $_GET['smart_album'] != "") {
	$is_for_smart_album = 1;
	$smartType = intval($_GET['smart_album']);
} else if (isset($_GET['virtual_album']) && $_GET['virtual_album'] != "") {
	$is_for_virtual_album = 1;
	$virtualType = $_GET['virtual_album'];
}

$labelId = null;
$label = null;
if ('' !== $virtualType) {
	if (isSet($_GET['id'])) {
		$labelId = intval($_GET['id']);
		if ($labelId === -1 || false === ($res = SYNOPHOTO_LABEL_UTIL_GetLabelById($labelId))) {
			$labelId = null;
		}
	}
}


$is_for_cooliris = 0;
if(isset($_GET['for_cooliris']) && $_GET['for_cooliris'] != "") {
	$is_for_cooliris = 1;
}

$urlprefix = SYNOPHOTO_RSS_GetURLPrefix();

$allow_orig = 0;
if (csSYNOPhotoDB::GetDBInstance()->GetConfig('photo', 'piclens_use_orig') == 'on' &&
	csSYNOPhotoMisc::CheckAllowDownload()) {
	$allow_orig = 1;
}

$serverHost = csSYNOPhotoMisc::GetServerHost();
$syno_token = session_id();

echo "<?xml version=\"1.0\" encoding=\"utf-8\" standalone=\"yes\"?>\n";
echo "<rss version=\"2.0\" xmlns:media=\"http://search.yahoo.com/mrss/\" xmlns:atom=\"http://www.w3.org/2005/Atom\">\n";
echo "<channel>\n";

if($is_for_dir) {
	SYNOPHOTO_RSS_GetPicLensRSS();
} else if ($is_for_smart_album) {
	SYNOPHOTO_RSS_GetSmartAlbumRSS($smartType);
} else if($is_for_virtual_album) {
	SYNOPHOTO_RSS_GetVirtualAlbumRSS($virtualType, $labelId);
} else {
	SYNOPHOTO_RSS_GetRootRSS();
}

echo "</channel>\n";
echo "</rss>\n";

function getConvertPhpUrl($bname, $suffix, $dir, $name, $type)
{
	global $serverHost;
	global $syno_token;

	$query_string = sprintf(
		"SynoToken=%s&dir=%s&name=%s&type=%s",
		urlencode($syno_token), urlencode($dir), urlencode($name), urlencode($type)
	);
	$encoded_name = urlencode($bname.$suffix);
	return $serverHost.SYNOPHOTO_URL_PREFIX."/photo/convert.php/{$encoded_name}?{$query_string}";
}

function getAlbumRootLink($category)
{
	global $serverHost;

	return $serverHost.SYNOPHOTO_URL_PREFIX. "/photo/index.php#!$category";
}

function SYNOPHOTO_RSS_GetRootRSS()
{
	$hostname = gethostname();
	$album_link = getAlbumRootLink('Albums');
	echo "<atom:icon>images/White/logo_ps6.png</atom:icon>\n";
	echo "<title>". htmlspecialchars($hostname) . "</title>\n";
	echo "<link>$album_link</link>";

	$title = csSYNOPhotoDB::GetDBInstance()->GetConfig("photo", "photo_page_title");
	if($title === false || $title == "") {
		$title = __(photo_str_ap_name_6);
	}
	echo "<description>".htmlspecialchars($title)."</description>\n\n";

	$photoList = csSYNOPhotoBrowse::GetBrowseInstance()->GetThumbListAll('', NULL, false, false, SYNOPHOTO_DEFAULT_THUMBSMALL_SIZE, false, true, true);

	foreach($photoList['items'] as $item) {
		if ($item['itemType'] == 1) {
			SYNOPHOTO_RSS_GetOneItem($item, $album_link);
		} else if ($item['itemType'] == 2) {
			SYNOPHOTO_RSS_GetVideoItem($item, $album_link);
		}
	}
}
function SYNOPHOTO_RSS_GetPicLensRSS()
{
	$album = @pack('H*', $_GET['dir']);
	$album_prefix = getAlbumRootLink('Albums');
	if ('' !== $album){
		$albums = explode('/', $album);
		$path = '';
		$token = '';
		foreach($albums as $name) {
			$token = $token . bin2hex($name);
			$path = $path . '/album_' . $token;
			$token = $token.'2f';
		}
		$album_link = $album_link . $path;
	}


	echo "<atom:icon>images/White/logo_ps6.png</atom:icon>\n";
	echo "<title>". htmlspecialchars($album) . "</title>\n";
	echo "<link>$album_prefix.$album_link</link>";

	$title = csSYNOPhotoDB::GetDBInstance()->GetConfig("photo", "photo_page_title");
	if($title === false || $title == "") {
		$title = __(photo_str_ap_name_6);
	}
	echo "<description>".htmlspecialchars($title)."</description>\n\n";

	$photoList = csSYNOPhotoBrowse::GetBrowseInstance()->GetThumbListAll($album, NULL, false, false, SYNOPHOTO_DEFAULT_THUMBSMALL_SIZE, false, true, true);

	foreach($photoList['items'] as $item) {
		if ($item['itemType'] == 1) {
			SYNOPHOTO_RSS_GetOneItem($item, $album_prefix);
		} else if ($item['itemType'] == 2) {
			SYNOPHOTO_RSS_GetVideoItem($item, $album_prefix);
		}
	}
}

function SYNOPHOTO_RSS_GetVirtualAlbumRSS($type, $labelId = null)
{
	$hostname = gethostname();

	$album_prefix = getAlbumRootLink('SmartAlbums');
	$album_link = "{$album_prefix}/defaultsmart_{$type}/tag_{$labelId}";

	echo "<atom:icon>images/logo_ps6.png</atom:icon>\n";
	echo "<title>".htmlspecialchars($hostname)."'s Photo</title>\n";
	echo "<link>$album_link</link>\n";

	$title = csSYNOPhotoDB::GetDBInstance()->GetConfig("photo", "photo_page_title");
	if($title === false || $title == "") {
		$title = __(photo_str_ap_name_6);
	}
	echo "<description>".htmlspecialchars($title)."</description>\n\n";

	$category = ('People' === $type) ? 4 : ('Location' === $type) ? 5 : 6;
	switch($category) {
	case 0:
		$photoList = csSYNOPhotoBrowse::GetBrowseInstance()->GetMostRecentThumbList('photo');
		break;
	case 1:
		$photoList = csSYNOPhotoBrowse::GetBrowseInstance()->GetMostRecentThumbList('video');
		break;
	case 2:
		$photoList = csSYNOPhotoBrowse::GetBrowseInstance()->GetMostRecentThumbList('photo', true);
		break;
	case 3:
		$photoList = csSYNOPhotoBrowse::GetBrowseInstance()->GetMostRecentThumbList('video', true);
		break;
	case 4:
	case 5:
	case 6:
		$photoList = csSYNOPhotoBrowse::GetBrowseInstance()->GetLabelAlbumRSSList($category, $labelId);
		break;
	}

	$GLOBALS['printed_items_count'] = 0;
	foreach($photoList['items'] as $item) {
		if($item['itemType'] == 2) {
			SYNOPHOTO_RSS_GetVideoItem($item, $album_link);
		} else {
			SYNOPHOTO_RSS_GetOneItem($item, $album_link);
		}
		$GLOBALS['printed_items_count']++;
	}
}

function SYNOPHOTO_RSS_GetSmartAlbumRSS($smartType)
{
	$album = @pack('H*', $_GET['smart_album']);
	$album_prefix = getAlbumRootLink('SmartAlbums');
	$album_link = "{$album_prefix}/smart_".$_GET['smart_album'];

	echo "<atom:icon>images/White/logo_ps6.png</atom:icon>\n";
	echo "<title>".htmlspecialchars($album)."</title>\n";
	echo "<link>$album_link</link>";

	$title = csSYNOPhotoDB::GetDBInstance()->GetConfig("photo", "photo_page_title");
	if($title === false || $title == "") {
		$title = __(photo_str_ap_name_6);
	}
	echo "<description>".htmlspecialchars($title)."</description>\n\n";

	$photoList = csSYNOPhotoBrowse::GetBrowseInstance()->GetSmartAlbumItemList(@pack('H*', $_GET['smart_album']), 1, -1);

	foreach($photoList['items'] as $item) {
		if ($item['itemType'] == 1) {
			SYNOPHOTO_RSS_GetOneItem($item, $album_link);
		} else if ($item['itemType'] == 2) {
			SYNOPHOTO_RSS_GetVideoItem($item, $album_link);
		}
		$GLOBALS['printed_items_count']++;
	}
}

function SYNOPHOTO_RSS_GetURLPrefix() {
	if(!$_SERVER['HTTP_HOST']) {
		return "";
	}
	$ht = $_SERVER["HTTPS"] ? "https":"http";
	return $ht . '://' . $_SERVER['HTTP_HOST'];
}

function SYNOPHOTO_RSS_UrlEncode($url)
{
	return str_replace(
		array('%', '"', '#', '&', "'", '+', '/', '?'),
		array('%25', '%22', '%23', '%26', '%27', '%2B', '%2F', '%3F'), $url);
}

function SYNOPHOTO_RSS_GetOneItem($data, $album_prefix, $isNewPhoto = false)
{
	global $allow_orig, $is_for_cooliris, $is_for_virtual_album, $is_for_smart_album;

	$path = $data['path'];
	$dirLength = strlen($path) - strlen(SYNOPHOTO_SERVICE_REAL_DIR."/") - strlen(basename($path)) - 1;
	if ($dirLength > 0) {
		$dir = bin2hex(substr($path, strlen(SYNOPHOTO_SERVICE_REAL_DIR."/"), $dirLength));
	} else {
		$dir = '';
	}
	$bname = basename($path);
	$name = bin2hex($bname);
	$have_thumb = csSYNOPhotoMisc::IsPhotoFileWithThumb($bname);

	$bname = SYNOPHOTO_RSS_UrlEncode($bname);
	$thumb_type  = $have_thumb ? '4' : '2';
	$thumbnail = getConvertPhpUrl($bname, '', $dir, $name, $thumb_type);

	$thumbType = 'jpeg';
	if (!$have_thumb) {
		$path = strtolower($bname);
		$path_parts = pathinfo($path);
		$thumbType = $path_parts['extension'];
	}

	$thumb_type = ($allow_orig || !$have_thumb) ? '2' : '1';
	$content = getConvertPhpUrl($bname, '', $dir, $name, $thumb_type);
	$file_size = $data['size'];

	$title = $data['title'];
	$link = $album_prefix;
	$albums = explode('/', @pack('H*', $dir));
	if (!$is_for_virtual_album && !$is_for_smart_album && '' !== $dir) {
		$token = '';
		foreach($albums as $albumParent) {
			$token = $token.bin2hex($albumParent);
			$link = $link."/album_".$token;
			$token = $token.'2f';
		}
	}
	if ('' === $dir) {
		$dir = '2f';
	}
	$link = $link.'/photo_'.$dir.'_'.$name;

	$description = $is_for_cooliris ? '' : "<img src=\"{$thumbnail}\"/><br/>".$data['desc'];
	if ($isNewPhoto) {
		$description = $is_for_cooliris ? '' : "<img src=\"{$thumbnail}\"/><br/>".$data['description'];
	}

	echo "<item>\n";
	echo "<title>".htmlspecialchars($title)."</title>\n";
	echo "<link>".htmlspecialchars($link)."</link>\n";
	echo "<description>".htmlspecialchars($description)."</description>\n";
	echo "<media:thumbnail url=\"".htmlspecialchars($thumbnail)."\"/>\n";
	echo "<media:content url=\"".htmlspecialchars($content)."\"/>\n";
	echo "<enclosure url=\"".htmlspecialchars($content)."\" type=\"image/{$thumbType}\" length=\"{$file_size}\"/>";
	echo "</item>\n";
}

function SYNOPHOTO_RSS_GetVideoItem($data, $album_prefix)
{
	global $is_for_cooliris, $is_for_virtual_album, $is_for_smart_album;

	$path = $data['path'];
	$dirLength = strlen($path) - strlen(SYNOPHOTO_SERVICE_REAL_DIR."/") - strlen(basename($path)) - 1;
	if ($dirLength > 0) {
		$dir = bin2hex(substr($path, strlen(SYNOPHOTO_SERVICE_REAL_DIR."/"), $dirLength));
	} else {
		$dir = '';
	}
	$bname = basename($path);

	if (!empty($data['video']['flv_src'])) {
		$type = 'x-flv';
		$typeNumber = 3;
	} else if (!empty($data['video']['mp4_orig_src'])) {
		$type = 'mp4';
		$typeNumber = 13;
	} else if (!empty($data['video']['mp4_H_src'])) {
		$type = 'mp4';
		$typeNumber = 6;
	} else if (!empty($data['video']['mp4_M_src'])) {
		$type = 'mp4';
		$typeNuber = 7;
	} else if (!empty($data['video']['mp4_L_src'])) {
		$type = 'mp4';
		$typeNumber = 8;
	} else {
		return ;
	}

	$name = bin2hex($bname);

	$bname = SYNOPHOTO_RSS_UrlEncode($bname);
	if($is_for_cooliris) {
		// Bug #14000, to fix filename problem in Cooliris
		$bname = rawurlencode($bname);
	}

	$thumbnail = getConvertPhpUrl($bname, '_thumb.jpg', $dir, $name, '1');
	if ('x-flv' === $type) {
		$content = getConvertPhpUrl($bname, '.flv', $dir, $name, $typeNumber);
	} else {
		$content = getConvertPhpUrl($bname, '', $dir, $name, $typeNumber);
	}
	$file_size = $data['size'];

	$link = $album_prefix;
	$albums = explode('/', @pack('H*', $dir));
	if (!$is_for_virtual_album && !$is_for_smart_album && '' !== $dir) {
		$token = '';
		foreach($albums as $albumParent) {
			$token = $token.bin2hex($albumParent);
			$link = $link."/album_".$token;
			$token = $token.'2f';
		}
	}
	if ('' === $dir) {
		$dir = '2f';
	}
	$link = $link.'/video_'.$dir.'_'.$name;
	$title = $data['title'];
	$description = $data['desc'];
	$description = $is_for_cooliris ? '' : "<img src='{$thumbnail}'/><br/>{$description}";
	echo "<item>\n";
	echo "<title>".htmlspecialchars($title)."</title>\n";
	echo "<link>".htmlspecialchars($link)."</link>\n";
	echo "<description>".htmlspecialchars($description)."</description>\n";
	echo "<media:thumbnail url=\"".htmlspecialchars($thumbnail)."\"/>\n";
	echo "<media:content url=\"".htmlspecialchars($content)."\" type=\"video/".$type."\"/>\n";
	echo "<enclosure url=\"".htmlspecialchars($content)."\" type=\"video/".$type."\" length=\"{$file_size}\"/>";
	echo "</item>\n";
}
?>
