<?php
require_once("include/syno_conf.php");
require 'twitter/tmhOAuth.php';
require 'twitter/tmhUtilities.php';

define('TWITTER_PHP', '/var/packages/PhotoStation/target/photo/twitter/twitter.php');
//define('PHP_CMD', '/usr/bin/php -n -d extension_dir=/lib/php/modules -d extension=syno_compiler.so -d extension=curl.so -d extension=bz2.so -d extension=hash.so -d extension=json.so');
class TwitterUtil {
	public static $PHP_ARG = array('-n',
		'-d', 'extension_dir=/lib/php/modules',
		'-d', 'extension=syno_compiler.so',
		'-d', 'extension=curl.so',
		'-d', 'extension=bz2.so',
		'-d', 'extension=hash.so',
		'-d', 'extension=json.so');
}

if(isset($_GET['action']) && 'start_twitter_oauth' == $_GET['action']) {
	echo SYNOPHOTO_TWITTER_StartOAuth();
	exit;
}

if(isset($_GET['action']) && 'set_twitter_token' == $_GET['action']) {
	echo SYNOPHOTO_TWITTER_SetToken();
	exit;
}

switch ($_POST['action']) {
case 'get_user':
	echo SYNOPHOTO_TWITTER_GetUser();
	break;
case 'upload':
	echo SYNOPHOTO_TWITTER_Upload();
	break;
case 'upload_new':
	echo SYNOPHOTO_TWITTER_Upload_new();
	break;
}

function SYNOPHOTO_TWITTER_StartOAuth()
{
	if ("on" === strtolower($_SERVER['HTTPS'])) {
		$callback = 'https:';
	} else {
		$callback = 'http:';
	}
	$callback .= '//' . $_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'] . '?action=set_twitter_token';

	$res = '';
	$val = csSYNOPhotoMisc::ExecCmd('/bin/php', array_merge(TwitterUtil::$PHP_ARG, array(
		TWITTER_PHP,
		'-a', 'get_token',
		'-c', $callback)), false, $res);
	$res = $res[count($res) - 1];
	if ($val == 0) {
		$resArray = json_decode($res, true);
		$_SESSION['twitter_oauth'] = $resArray['twitter_oauth'];
		$authurl = $resArray['auth_url'];
		header("Location: {$authurl}");
	} else {
		echo $res;
	}
}

//twitter callback
function SYNOPHOTO_TWITTER_SetToken()
{
	$res = '';
	$val = csSYNOPhotoMisc::ExecCmd('/bin/php', array_merge(TwitterUtil::$PHP_ARG, array(
		TWITTER_PHP,
		'-a', 'set_token',
		'-t', $_SESSION['twitter_oauth']['oauth_token'],
		'-s', $_SESSION['twitter_oauth']['oauth_token_secret'],
		'-v', $_GET['oauth_verifier'])), false, $res);
	$res = $res[count($res) - 1];

	if ($val == 0) {
		$resArray = json_decode($res, true);
		$callback = '_onTwitterLogin';
		$token = $resArray['oauth_token'];
		$secret = $resArray['oauth_token_secret'];
		$uid = $resArray['user_id'];
		$screen_name = $resArray['screen_name'];
		$closeWindow = "
			<html>
			<head>
				<script>
				function loadHandler(){
					var callback = '$callback';
					var token = '$token';
					var secret = '$secret';
					var uid = '$uid';
					var screen_name = '$screen_name';
					if (callback) {
						eval('callback = window.opener.' + callback);
						callback(token, secret, uid, screen_name);
					}
					window.close();
				}
				</script>
			</head>
			<body onload='loadHandler()'></body>
			</html>";
		return $closeWindow;
	} else {
		echo $resArray['error'];;
	}
	unset($_SESSION['twitter_oauth']);
}

function SYNOPHOTO_TWITTER_GetUser()
{
	$result['success'] = false;
	if (!isSet($_POST['token']) || !isSet($_POST['secret'])) {
		return json_encode($result);
	}

	//$cmd = sprintf(
	//	"%s %s -a %s -t %s -s %s",
	//	PHP_CMD, TWITTER_PHP,
	//	'get_user',
	//	escapeshellarg($_POST['token']),
	//	escapeshellarg($_POST['secret'])
	//);
	//$res = exec($cmd, $output, $val);
	$res = '';
	$val = csSYNOPhotoMisc::ExecCmd('/bin/php', array_merge(TwitterUtil::$PHP_ARG, array(
		TWITTER_PHP,
		'-a', 'get_user',
		'-t', $_POST['token'],
		'-s', $_POST['secret'])), false, $res);
	$res = $res[count($res) - 1];

	if ($val == 0) {
		$resp = json_decode($res, true);
		$result['user'] = array();
		$result['user']['name'] = $resp['screen_name'];
		$result['user']['profile_image_url'] = $resp['profile_image_url'];
		$result['success'] = true;
	} else {
		$result['user'] = null;
	}
	return json_encode($result);
}

function SYNOPHOTO_TWITTER_Upload()
{
	$result['success'] = false;

	// #2220 - remove old entry for safety in passing
	return json_encode($result);

	if (!isSet($_POST['path']) || !isSet($_POST['token']) || !isSet($_POST['secret'])) {
		return json_encode($result);
	}

	$path = $_POST['path'];

	$photoInfo = csSYNOPhotoDB::GetDBInstance()->GetPhotoInfo($path);
	$image = csSYNOPhotoMisc::GetThumbPathFromFullPath($path, SYNOPHOTO_THUMBXLARGE, false);
	if (!file_exists($image)) {
		$image = $path;// upload original file
	}

	//$cmd = sprintf(
	//	"%s %s -a %s -t %s -s %s -f %s -m %s",
	//	PHP_CMD, TWITTER_PHP,
	//	'upload_photo',
	//	escapeshellarg($_POST['token']),
	//	escapeshellarg($_POST['secret']),
	//	escapeshellarg($image),
	//	escapeshellarg($_POST['message'])
	//);
	//$res = exec($cmd, $output, $val);
	$val = csSYNOPhotoMisc::ExecCmd('/bin/php', array_merge(TwitterUtil::$PHP_ARG, array(
		TWITTER_PHP,
		'-a', 'upload_photo',
		'-t', $_POST['token'],
		'-s', $_POST['secret'],
		'-f', $image,
		'-m', $_POST['message'])));

	if ($val == 0) {
		$result['success'] = true;
	}
	return json_encode($result);
}

function SYNOPHOTO_TWITTER_Upload_new()
{
	$result['success'] = false;
	if (!isSet($_POST['id']) || !isSet($_POST['token']) || !isSet($_POST['secret'])) {
		return json_encode($result);
	}

	if (!csSYNOPhotoMisc::IsAllowedSocialUploadIdentity()) {
		return json_encode($result);
	}

	$idarr = explode('_', $_POST['id']);
	$path = realpath(SYNOPHOTO_SERVICE_REAL_DIR . "/" . @pack('H*', $idarr[1]) . "/" . @pack('H*', $idarr[2]));
	$photoInfo = csSYNOPhotoDB::GetDBInstance()->GetPhotoInfo($path);

	if (!csSYNOPhotoMisc::CheckPathAccessible($path)) {
		return json_encode($result);
	}

	$useOrig = csSYNOPhotoMisc::GetConfigDB("photo", "share_upload_orig", "photo_config") == 'on';

	$image = $path;
	//3MB is limit for twitter
	if(!$useOrig || !isset($photoInfo) || 3*1024*1024 < $photoInfo['size']) {
		if (SYNOPhotoEA::checkFilePath($path, SYNOPhotoEA::FILE_THUMB_XL, $thumbPath)) {
			$image = $thumbPath;
		} else if (SYNOPhotoEA::checkFilePath($path, SYNOPhotoEA::FILE_THUMB_LARGE_PREVIEW, $thumbPath)) {
			$image = $thumbPath;
		}
	}

	//$cmd = sprintf(
	//	"%s %s -a %s -t %s -s %s -f %s -m %s",
	//	PHP_CMD, TWITTER_PHP,
	//	'upload_photo',
	//	escapeshellarg($_POST['token']),
	//	escapeshellarg($_POST['secret']),
	//	escapeshellarg($image),
	//	escapeshellarg($_POST['message'])
	//);
	//$res = exec($cmd, $output, $val);
	$val = csSYNOPhotoMisc::ExecCmd('/bin/php', array_merge(TwitterUtil::$PHP_ARG, array(
		TWITTER_PHP,
		'-a', 'upload_photo',
		'-t', $_POST['token'],
		'-s', $_POST['secret'],
		'-f', $image,
		'-m', $_POST['message'])));

	if ($val == 0) {
		$result['success'] = true;
	}
	return json_encode($result);
}
?>
