<?PHP

require_once('acl.inc.php');

class AclAPI extends WebAPI {
	function __construct() {
		parent::__construct(SZ_WEBAPI_API_DESCRIPTION_PATH);
	}

	protected function Process() {
		if (!strcasecmp($this->method, "get")) {
			$this->Get();
		} else if (!strcasecmp($this->method, "set")) {
			$this->Set();
		}
	}

	private function Set() {
		if (true === SYNOPHOTO_IS_PPS) {
			$this->SetError(PHOTOSTATION_ACL_NOT_SUPPORT);
		} else {
			$ret = csSYNOPhotoMisc::ExecCmd("/var/packages/PhotoStation/target/bin/synophoto_acl", array("--background_convert"));

			if (0 === $ret) {
				$this->SetResponse(null);
			} else {
				$this->SetError(PHOTOSTATION_ACL_CONVERT_FAIL);
			}
		}
	}

	private function Get() {
		$resp = array();

		// convert status:
		// disabled - file system doesn't support acl
		// ready -- manual start
		// running -- converting
		// finish -- convert finish

		if (!csSYNOPhotoAcl::IsAclEnabled()) {
			if (csSYNOPhotoAcl::IsAclSupport()) {
				$resp["convert"] = "ready";
			} else {
				$resp["convert"] = "disabled";
			}
		} else {
			$convert = csSYNOPhotoMisc::GetConfigFile(SYNO_PKG_CNF_FILE, "convertphotoacl");
			if (empty($convert)) {
				$resp["convert"] = "ready";
			} else if ("required" == $convert["convertphotoacl"]) {
				$resp["convert"] = "ready";
			} else {
				$resp["convert"] = $convert["convertphotoacl"];
			}
		}

		$this->SetResponse($resp);
	}
}

$api = new AclAPI();
$api->Run();

?>
