<?php
require_once('app_privilege.inc.php');

class AppPrivilegeAPI extends WebAPI
{
	function __construct()
	{
		parent::__construct(SZ_WEBAPI_API_DESCRIPTION_PATH);
	}

	protected function Process() 
	{
		if (!strcasecmp($this->method, "check")) {
			$this->CheckAppPrivilege();
			return;
		} else if (!strcasecmp($this->method, "seenmoments")) {
			$this->HaveSeenMomentsIntroOnce();
			return;
		}
	}

	private function HaveSeenMomentsIntroOnce()
	{
		$user = $this->GetUser();

		$resp = array();
		if(csSYNOPhotoMisc::ExecCmd('/usr/syno/bin/synophoto_dsm_user', array('--isadmin', $user), false) === 0) {
			$output = '';
			$ret = csSYNOPhotoMisc::ExecCmd('/usr/syno/bin/synophoto_config_root', array('--get', 'haveseenmomentsintro_once_'.$user), false, $outputs);

			if ($ret === 0 && count($outputs) > 0) {
				$value = $outputs[count($outputs) - 1];
			} else {
				$value = 'no';
			}

			if($value !== 'yes') {
				csSYNOPhotoMisc::ExecCmd('/usr/syno/bin/synophoto_config_root', array('--set', 'haveseenmomentsintro_once_'.$user, '--value', 'yes'), false);
			}
			$resp[haveSeenMomentsIntroOnce] = $value;
		} else {
			$resp[haveSeenMomentsIntroOnce] = 'noPrivilege';
		}
		$this->SetResponse($resp);
	End:
		return;
	}

	private function CheckAppPrivilege()
	{
		if (isset($_REQUEST['isPPS'])) {
			$isPPS = $_REQUEST['isPPS'] === 'true' ? true : false;
		} else {
			$isPPS = false;
		}

		$user = $this->GetUser();
		if (!$user) {
            $this->SetError(WEBAPI_ERR_BAD_REQUEST);
			goto End;
		}

		if (!isset($_SESSION[SYNOPHOTO_ADMIN_USER]['security_identifier'])) {
            $this->SetError(WEBAPI_ERR_BAD_REQUEST);
			goto End;
		}
		$identifier = $_SESSION[SYNOPHOTO_ADMIN_USER]['security_identifier'];

		$output = '';
		$retval = csSYNOPhotoMisc::ExecCmd('/usr/syno/bin/synophoto_dsm_user', array('--appprivilege', $user, $identifier), false, $output);

		if(0 !== $retval) {
            $this->SetError(WEBAPI_ERR_UNKNOWN);
			goto End;
		}

		$resp = array();
		$resp[havePrivilege] = $output[0];
		if($output[0] === 'true' || $output[0] === 'null') {
			$resp[haveSeenMomentsIntro] = $this->HaveSeenMomentsIntro($isPPS, $user);
		}
		$this->SetResponse($resp);
	End:
		return;
	}

	private function GetUser()
	{
		$user = false;

		if (isset($_SESSION[SYNOPHOTO_ADMIN_USER]['reg_syno_user'])) {
			$user = $_SESSION[SYNOPHOTO_ADMIN_USER]['reg_syno_user'];
		} else if (isset($_SESSION[SYNOPHOTO_ADMIN_USER]['admin_syno_user'])) {
			$user = ("root" === SYNOPHOTO_ADMIN_USER)? "admin" : SYNOPHOTO_ADMIN_NAME;
		}

		return $user;
	}

	private function HaveSeenMomentsIntro($isPPS, $user)
	{
		$ret = $isPPS ? csSYNOPhotoMisc::ExecCmd('/usr/syno/bin/synophoto_config_root', array('--personal', SYNOPHOTO_ADMIN_NAME, '--get', 'haveseenmomentsintro'), false, $outputs)
			 : csSYNOPhotoMisc::ExecCmd('/usr/syno/bin/synophoto_config_root', array('--get', 'haveseenmomentsintro_'.$user), false, $outputs);
		
		if ($ret === 0 && count($outputs) > 0) {
			$value = $outputs[count($outputs) - 1];
		} else {
			$value = 'no';
		}

		if ($value !== 'yes') {
			$isPPS ? csSYNOPhotoMisc::ExecCmd('/usr/syno/bin/synophoto_config_root', array('--personal', SYNOPHOTO_ADMIN_NAME, '--set', 'haveseenmomentsintro', '--value', 'yes'), false)
				: csSYNOPhotoMisc::ExecCmd('/usr/syno/bin/synophoto_config_root', array('--set', 'haveseenmomentsintro_'.$user, '--value', 'yes'), false);
		}
		return $value;
	}
}

$api = new AppPrivilegeAPI();
$api->Run();

?>
