<?php

require_once('auth.inc.php');

class AuthAPIUtil {
    static function SYNOPHOTO_LOGIN_USERDATA_PARSER($pUser, $user)
    {
        global $SYNOPHOTO_DSM_USER_INFO;
        $result = array();
        if (!is_array($pUser)) {
            return null;
        }
        $i = 0;
		$groups = array();
        foreach ($pUser as $item) {
          if (preg_match('/^Member\sOf:\s+\[(.+)\]$/', $item, $match)) {
            $groups = array();
            $groups_size = $match[1];
          }
			if (!preg_match('/([\w\s]*)\:/', $item, $match_val) && preg_match('/\((\d+)\)/', $item, $match)) {
				$groups[] = $match[1];
			}

            if (!preg_match('/(^\w+\s?\w+)\s*\:/', $item, $match) || !preg_match('/\[(.*)\]/', $item, $match_val)) {
                continue;
            }

            if (false !== $index = array_search($match[1], $SYNOPHOTO_DSM_USER_INFO)) { // $key = 2;
                if (isset($result[$index])) {
                  PhotoLog::Add($user." try to attack the platform...", false, strtolower($user));
                  exit(0);
                }
                $result[$index] = $match_val[1];
                $result[$SYNOPHOTO_DSM_USER_INFO[$index]] = $match_val[1];
            }
        }
        if(sizeof($groups) != $groups_size){
          PhotoLog::Add($user." wants to access secret pictures...", false, strtolower($user));
          exit(0);
        }
		$result['groups'] = implode(',', $groups);
        return $result;
    }

    static function SYNOPHOTO_LOGIN_AddLog($username, $success)
    {
        $ip = $_SERVER['REMOTE_ADDR'];
        $conf = csSYNOPhotoMisc::GetConfigFile(SYNO_CNF_FILE, 'enable_demomode');
        if ('yes' == $conf['enable_demomode']) {
            $ip = 'xxx.xxx.xxx.xxx';
        }

        if ($success) {
            PhotoLog::Add($username." logged in from "."[".$ip."].", true, strtolower($username));
			PhotoLog::RecordUserAgent();
            return;
        }
        PhotoLog::Add($username." failed to log in from "."[".$ip."].", false, strtolower($username));
    }

	static function SYNOPHOTO_LOGIN_DoAuthCmd($user, $pass, $result)
	{
		putenv("SYNO_PHOTO_STATION_AUTH_PASSWORD=$pass");
		$retval = csSYNOPhotoMisc::ExecCmd('/usr/syno/bin/synophoto_dsm_user', array('--auth', $user), false, $result);
		if (is_array($result)) {
			$result = $result[0];
		}
		return $retval;
	}

    /*
     *  return
     *    1 - success
     *    0 - fail
     */
    static function SYNOPHOTO_LOGIN_ValidateAdmin(&$result)
    {
        $user = ('root' == SYNOPHOTO_ADMIN_USER)? 'admin':SYNOPHOTO_ADMIN_NAME;

        if (isset($_REQUEST['password'])) {
            $pass = $_REQUEST['password'];
        } else if (isset($_REQUEST['passwd'])) {
            $pass = $_REQUEST['passwd'];
        } else {
            $pass = '';
        }

        $result = '';
		$retval = self::SYNOPHOTO_LOGIN_DoAuthCmd($user, $pass, $result);

        if (0 == $retval) {
            unset($_SESSION[SYNOPHOTO_ADMIN_USER]);
			csSYNOPhotoMisc::PhotoSessionStart();

            csSYNOPhotoDB::GetDBInstance()->SetSessionSystemConfigsFromFile();
            $_SESSION[SYNOPHOTO_ADMIN_USER]['admin_syno_user'] = SYNOPHOTO_ADMIN_PASS;
            self::SYNOPHOTO_LOGIN_AddLog($_REQUEST['username'], true);
            return 1;
        }
        self::SYNOPHOTO_LOGIN_AddLog($_REQUEST['username'], false);
        return 0;
    }

    /*
     *  return
     *    1 - success
     *    0 - fail
     *   -1 - disable user (Photo Station Account System)
     *   -2 - not photo station user (Photo Station Account System)
     *   -3 - guest account is not allowed to login (DSM Account System)
     */
    static function SYNOPHOTO_LOGIN_ValidateDsmUser(&$result)
    {
        if (!strcasecmp($_REQUEST['username'], 'guest')) {
            return -3;
        }

		$user = $_REQUEST['username'];

        if (isset($_REQUEST['password'])) {
            $pass = $_REQUEST['password'];
        } else if (isset($_REQUEST['passwd'])) {
            $pass = $_REQUEST['passwd'];
        } else {
            $pass = '';
        }

        $result = '';
		$auth_retval = self::SYNOPHOTO_LOGIN_DoAuthCmd($user, $pass, $result);

        $user_info = array();
        if (0 == $auth_retval) {
            //$command = "/usr/syno/bin/synophoto_dsm_user --getinfo ".escapeshellarg($_REQUEST['username']);
            //@exec($command, $pUser, $retval);
            $pUser = '';
            csSYNOPhotoMisc::ExecCmd('/usr/syno/bin/synophoto_dsm_user', array('--getinfo', $_REQUEST['username']), false, $pUser);
            $user_info = self::SYNOPHOTO_LOGIN_USERDATA_PARSER($pUser, $user);
        } else {
            self::SYNOPHOTO_LOGIN_AddLog($_REQUEST['username'], false);
            return 0;
        }

        if ($user_info) {
            unset($_SESSION[SYNOPHOTO_ADMIN_USER]);
			csSYNOPhotoMisc::PhotoSessionStart();

            csSYNOPhotoDB::GetDBInstance()->SetSessionSystemConfigsFromFile();
            $_SESSION[SYNOPHOTO_ADMIN_USER]['reg_syno_userid'] = $user_info[2];
            $_SESSION[SYNOPHOTO_ADMIN_USER]['reg_syno_user'] = $user_info[0];
            $_SESSION[SYNOPHOTO_ADMIN_USER]['use_dsm_account'] = true;
			$_SESSION[SYNOPHOTO_ADMIN_USER]['reg_syno_groupid'] = $user_info['groups'];

            if ($user_info[10]) {
                $_SESSION[SYNOPHOTO_ADMIN_USER]['admin_syno_user'] = SYNOPHOTO_ADMIN_PASS;
            }
            self::SYNOPHOTO_LOGIN_AddLog($_SESSION[SYNOPHOTO_ADMIN_USER]['reg_syno_user'], true);
            return 1;
        }
        self::SYNOPHOTO_LOGIN_AddLog($_REQUEST['username'], false);
        return 0;
    }

    static function SYNOPHOTO_LOGIN_AddEnv()
    {
        $cgi_env = array(
            "HTTP_HOST",
            "REDIRECT_STATUS",
            "REMOTE_ADDR",
            "REMOTE_PORT",
            "SERVER_ADDR",
            "SERVER_NAME",
            "SERVER_PORT",
            "SERVER_PROTOCOL",
            "HTTP_QUICKCONNECT_TOKEN",
            "HTTP_X_FORWARDED_PROTO",
            "HTTP_X_FORWARDED_FOR",
            "HTTP_X_FORWARDED_BY",
            "HTTP_X_FORWARDED_HOST",
            "HTTP_X_FORWARDED_PORT",
            "HTTP_CLIENT_IP"
        );

        foreach ($cgi_env as $key) {
            if (isset($_SERVER[$key])) {
                putenv($key."=".$_SERVER[$key]);
            }
        }
    }

    static function SYNOPHOTO_LOGIN_GetRemoteIP()
    {
        //@exec("/var/packages/PhotoStation/target/bin/synophoto_autoblock --remote", $result, $retval);
        $result = '';
        $retval = csSYNOPhotoMisc::ExecCmd('/var/packages/PhotoStation/target/bin/synophoto_autoblock', array('--remote'), false, $result);
        if (0 == $retval && is_array($result)) {
            $ip = $result[0];
        } else {
            $ip = $_SERVER["REMOTE_ADDR"];
        }

        return $ip;
    }

    static function SYNOPHOTO_LOGIN_AutoBlockIsDeniedIP($ip)
    {
        //@system("/var/packages/PhotoStation/target/bin/synophoto_autoblock --denied ".escapeshellarg($ip), $retval);
        $retval = -1;
        csSYNOPhotoMisc::ExecCmdNoOutput('/var/packages/PhotoStation/target/bin/synophoto_autoblock', array('--denied', $ip), $retval);
        return $retval;
    }

    static public function SYNOPHOTO_LOGIN_AutoBlockAddAttemptIP($ip)
    {
        //@system("/var/packages/PhotoStation/target/bin/synophoto_autoblock --attempt ".escapeshellarg($ip), $retval);
        $retval = -1;
        csSYNOPhotoMisc::ExecCmdNoOutput('/var/packages/PhotoStation/target/bin/synophoto_autoblock', array('--attempt', $ip), $retval);
        return $retval;
    }

    static public function SYNOPHOTO_LOGIN_AutoBlockResetIP($ip)
    {
        //@system("/usr/syno/bin/synoautoblock --reset ".escapeshellarg($ip), $retval);
        $retval = -1;
        csSYNOPhotoMisc::ExecCmdNoOutput('/usr/syno/bin/synoautoblock', array('--reset', $ip), $retval);
        return $retval;
    }

    /*
     * return
     *   1 - success
     *   0 - fail
     *  -1 - disable user (Photo Station Account System)
     *  -2 - not photo station user (Photo Station Account System)
     *  -3 - guest account is not allowed to login (DSM Account System)
     *  -4 - PHOTOSTATION_AUTH_LOGIN_NOPRIVILEGE
     *  -5 - PHOTOSTATION_AUTH_LOGIN_MAX_TRIES
     */
    static function SYNOPHOTO_LOGIN_ValidateUser()
    {
        $ip = self::SYNOPHOTO_LOGIN_GetRemoteIP();

        if (self::SYNOPHOTO_LOGIN_AutoBlockIsDeniedIP($ip)) {
            return -4;
        }

        $escape = PHOTO_DB_GetEscape();
        $query_usr = "Select count(*) from photo_user where lower(username) like ? $escape";
        $sqlParam = array(PHOTO_DB_EscapForLike(strtolower($_REQUEST['username'])));
        $count = PHOTO_DB_QueryCount($GLOBALS['dbconn_photo'], $query_usr, $sqlParam);

        if ($count == 0) {
            // user is not photo station user
            self::SYNOPHOTO_LOGIN_AutoBlockAddAttemptIP($ip);
            return -2;
        }

        if (isset($_REQUEST['password'])) {
            $pass = $_REQUEST['password'];
        } else if (isset($_REQUEST['passwd'])) {
            $pass = $_REQUEST['passwd'];
        } else {
            $pass = '';
        }

        $query = "Select * from photo_user where lower(username) like ? $escape and password = '".md5($pass)."'";
        $sqlParam = array(PHOTO_DB_EscapForLike(strtolower($_REQUEST['username'])));
        $result = PHOTO_DB_Query($query, $sqlParam);

        $user_info = PHOTO_DB_FetchRow($result);
        if ($user_info) {
            if(PHOTO_DB_ConvertBool($user_info[4]) == 't') {
                //disabled
                return -1;
            }

            unset($_SESSION[SYNOPHOTO_ADMIN_USER]);
			csSYNOPhotoMisc::PhotoSessionStart();

            csSYNOPhotoDB::GetDBInstance()->SetSessionSystemConfigsFromFile();
            $_SESSION[SYNOPHOTO_ADMIN_USER]['reg_syno_userid'] = $user_info[0];
            $_SESSION[SYNOPHOTO_ADMIN_USER]['reg_syno_user'] = $user_info[1];
            $_SESSION[SYNOPHOTO_ADMIN_USER]['use_dsm_account'] = false;

			/* set user's belonging groups */
			$query = "SELECT groupid FROM " . PHOTO_USER_GROUP_TABLE . " WHERE userid = $user_info[0]";
			$db_result = PHOTO_DB_Query($query);
			$_SESSION[SYNOPHOTO_ADMIN_USER]['reg_syno_groupid'] = '';
			$groups = array();
			while ($row = PHOTO_DB_FetchRow($db_result)) {
				$groups[] = $row['groupid'];
			}
			$_SESSION[SYNOPHOTO_ADMIN_USER]['reg_syno_groupid'] = implode(',', $groups);

            if (PHOTO_DB_ConvertBool($user_info[6]) == 't') {
                $_SESSION[SYNOPHOTO_ADMIN_USER]['admin_syno_user'] = SYNOPHOTO_ADMIN_PASS;
            }
            self::SYNOPHOTO_LOGIN_AddLog($_SESSION[SYNOPHOTO_ADMIN_USER]['reg_syno_user'], true);
            self::SYNOPHOTO_LOGIN_AutoBlockResetIP($ip);
            return 1;
        }
        self::SYNOPHOTO_LOGIN_AddLog($_REQUEST['username'], false);
        self::SYNOPHOTO_LOGIN_AutoBlockAddAttemptIP($ip);
        return 0;
    }

	static function SYNOPHOTO_LOGIN_UpdateUserSession($username) {
		if (null == $username) {
			return;
		}
		// PhotoStation User
		if ("0" == $_SESSION[SYNOPHOTO_ADMIN_USER]['photo_config']['global']['account_system'] || 'root' != SYNOPHOTO_ADMIN_USER){
			$isAdmin = 'f';
			$query = "SELECT userid, admin, disabled FROM photo_user WHERE username = ?";
			$db_result = PHOTO_DB_Query($query, array($username));
			while ($row = PHOTO_DB_FetchRow($db_result)) {
				if (PHOTO_DB_IsTrue($row['disabled'])) {
					unset($_SESSION[SYNOPHOTO_ADMIN_USER]);
					return false;
				}
				$userid = $row['userid'];
				$isAdmin = $row['admin'];
			}
			if('t' === PHOTO_DB_ConvertBool($isAdmin) || (('root' === SYNOPHOTO_ADMIN_USER) ? 'admin' : substr(SYNOPHOTO_ADMIN_USER, 1)) === $username) {
				$_SESSION[SYNOPHOTO_ADMIN_USER]['admin_syno_user'] = SYNOPHOTO_ADMIN_PASS;
			} else {
				unset($_SESSION[SYNOPHOTO_ADMIN_USER]['admin_syno_user']);
			}

			$query = "SELECT groupid FROM photo_user_group WHERE userid = ?";
			$db_result = PHOTO_DB_Query($query, array($userid));
			$_SESSION[SYNOPHOTO_ADMIN_USER]['reg_syno_groupid'] = '';
			$groups = array();
			while ($row = PHOTO_DB_FetchRow($db_result)) {
				$groups[] = $row['groupid'];
			}
			$_SESSION[SYNOPHOTO_ADMIN_USER]['reg_syno_groupid'] = implode(',', $groups);
		// DSM User
		} else {
			//$command = "/usr/syno/bin/synophoto_dsm_user --getinfo ".escapeshellarg($username);
			//@exec($command, $pUser, $retval);
            $pUser = '';
            csSYNOPhotoMisc::ExecCmd('/usr/syno/bin/synophoto_dsm_user', array('--getinfo', $username), false, $pUser);
			$user_info = self::SYNOPHOTO_LOGIN_USERDATA_PARSER($pUser, $username);
			if (!$user_info || $user_info['Expired'] !== "false") {
				unset($_SESSION[SYNOPHOTO_ADMIN_USER]);
				return false;
			}
			$_SESSION[SYNOPHOTO_ADMIN_USER]['reg_syno_groupid'] = $user_info['groups'];
			if ($user_info[10]) {
				$_SESSION[SYNOPHOTO_ADMIN_USER]['admin_syno_user'] = SYNOPHOTO_ADMIN_PASS;
			} else {
				unset($_SESSION[SYNOPHOTO_ADMIN_USER]['admin_syno_user']);
			}
		}
	}
}
