<?php

class Decorator {

	static function CategoryFormula ($dbObject, $config = array())
	{
		$encodedId = $config['id'];
		$categroy = array();
		$category['id'] = $encodedId ? $encodedId : 'category_'.$dbObject['id'];
		$category['name'] = $dbObject['name'];
		$category['hidden'] = $dbObject['hidden'];
		return $category;
	}

	static function AlbumFormula($dbObject, $config = array())
	{
		$allowComment = $config['allowComment'];
		$showAlbumHit = $config['showAlbumHit'];
		$id = $config['id'];
		$param = $config['param'];
		$needThumbSize = isset($config['needThumbSize']) ? $config['needThumbSize'] : in_array('thumb_size', $param['additional']);

		$sharepath = $dbObject['sharename'];
		$item_info = AlbumAPIUtil::FormAlbum($dbObject, $allowComment, $showAlbumHit);
		$item_info['allow_embed'] = AlbumAPIUtil::IsAllPublicAlbum($sharepath);
		if (!in_array('thumbnail', $param['ignore'])) {
			$result = csSYNOPhotoAlbum::GetAlbumInstance()->GetAlbumCover($sharepath);
			$coverPath = $result['coverPath'];
		}
		list($orig_resolutionx, $orig_resolutiony, $blThumbRotated) = AlbumAPIUtil::GetCoverResolutionRotation($coverPath);

		// replace conversion with the first layer album's
		$item_info['conversion'] = csSYNOPhotoMisc::IsAlbumAllowConversion($sharepath);
		$item = array(
			'info'	=> $item_info,
			'id'	=> $id ? $id : self::EncodeItemId($sharepath, 'album_'),
			'type'	=> 'album',
			'additional' => AlbumAPIUtil::FormAdditional('album', $dbObject, $param)
		);

		AlbumAPIUtil::FillThumbStatus($item, $coverPath, $needThumbSize, $orig_resolutionx, $orig_resolutiony, $blThumbRotated, $item_info['conversion']);
		return $item;
	}

	static function SmartFormula($dbObject, $config = array())
	{
		$param = $config['param'];
		$id = $config['id'];
		$needThumbSize = isset($config['needThumbSize']) ? $config['needThumbSize'] : in_array('thumb_size', $param['additional']);

        $smartAlbum['id'] = $id ? $id : self::EncodeItemId($dbObject['name'], 'smart_');
        $smartAlbum['type'] = 'smart';
        $album = SmartAlbum::GetSmartAlbumInstance()->GetCoverOfSmartAlbumByName($dbObject['name']);
        $smartAlbum['thumbnail_status'] = 'default';

		if (false === $album['success'] && !isset($_SESSION[SYNOPHOTO_ADMIN_USER]['admin_syno_user'])) {
			return -1;
		}

		$coverPath = '';
        if ($album['success'] && isset($album['cover']['dbPath'])) {
			$coverPath = $album['cover']['dbPath'];
			$relativePath = substr($coverPath, strlen(SYNOPHOTO_SERVICE_REAL_DIR_PATH));
			$dirname = dirname($relativePath);
			$sharename = Album::IsRootSharename($dirname) ? '/' : $dirname;
        }

        $smartAlbum['name'] = $dbObject['name'];
        if (in_array('smart_condition', $param['additional'])) {
			$smartAlbumCond = SmartAlbum::GetSmartAlbumInstance()->GetSmartCondition($dbObject['name']);
            $smartAlbum['additional']['smart_condition'] = $smartAlbumCond;
        }

        $blConversion = csSYNOPhotoMisc::IsAlbumAllowConversion($sharename);
        list($orig_resolutionx, $orig_resolutiony, $blThumbRotated) = AlbumAPIUtil::GetCoverResolutionRotation($coverPath);
        AlbumAPIUtil::FillThumbStatus($smartAlbum, $coverPath, $needThumbSize, $orig_resolutionx, $orig_resolutiony, $blThumbRotated, $blConversion);

        return $smartAlbum;
	}

	static function TagFormula($dbObject, $config = array())
	{
		$param = $config['param'];
		$needThumbSize = isset($config['needThumbSize']) ? $config['needThumbSize'] : in_array('thumb_size', $param['additional']);
		$id = $config['id'];

		$tag['id'] = $id ? $id : 'tag_'.$dbObject['id'];
		$tag['type'] = 'tag';
		$tag['tag_type'] = Label::GetCategoryName($dbObject['category']);
		$tag['name'] = $dbObject['name'];

		$additional = self::TagAdditional($dbObject, $param);
		if (null !== $additional) {
			$tag['additional'] = $additional;
		}
		if ('true' === $param['thumbnail_status']) {
			$result = csSYNOPhotoAlbum::GetAlbumInstance()->GetLabelAlbumCoverFromDB($dbObject['id']);
			$coverPath = $result['dbPath'];
			$relativePath = substr($coverPath, strlen(SYNOPHOTO_SERVICE_REAL_DIR_PATH));
			$dirname = dirname($relativePath);
			$sharename = Album::IsRootSharename($dirname) ? '/' : $dirname;

			$blConversion = csSYNOPhotoMisc::IsAlbumAllowConversion($sharename);
			list($orig_resolutionx, $orig_resolutiony, $blThumbRotated) = AlbumAPIUtil::GetCoverResolutionRotation($coverPath);
			AlbumAPIUtil::FillThumbStatus($tag, $coverPath, $needThumbSize, $orig_resolutionx, $orig_resolutiony, $blThumbRotated, $blConversion);
		}
		return $tag;
	}

    private static function TagAdditional($data, $params)
    {
        if (in_array('info', $params['additional'])) {
            if (Label::PEOPLE === $data['category']) {
                $people['name'] = $data['name'];
                $additional['info'] = $people;
            } elseif (Label::GEO === $data['category']) {
                $geo['name'] = $data['name'];
                if (false !== ($extra = json_decode($data['info'], true))) {
                    $geo['lat'] = $extra['lat'];
                    $geo['lng'] = $extra['lng'];
                    $geo['place_id'] = $extra['placeId'];
                    $geo['address'] = (null === $extra['address']) ? '' : $extra['address'];
                }
                $additional['info'] = $geo;
            } elseif (Label::DESC === $data['category']) {
                $desc['name'] = $data['name'];
                $additional['info'] = $desc;
            }
        }
        if (in_array('extra', $params['additional'])) {
            $additional['extra'] = $data['info'];
        }
        if (in_array('count', $params['additional'])) {
            $total = ItemLabel::GetCountByLabelId($data['id']);
            $additional['count'] = (int)$total;
        }
        return $additional;
    }

	static function VideoFormula($dbObject, $config = array())
	{
		$params = $config['param'];
		$needThumbSize = $config['needThumbSize'] ? $config['needThumbSize'] : in_array('thumb_size', $params['additional']);
		$item = array(
			'id'	=> $config['id'] ? $config['id'] : self::EncodeItemId($dbObject['path'], "video_"),
			'type'	=> 'video'
		);
        $customTitleDesc = csSYNOPhotoDB::GetDBInstance()->GetVideoCustomizedTitleDescription($dbObject['path']);

		$item_info = array(
			'name'			=> $dbObject['name'],
			'title'			=> empty($customTitleDesc['title']) ? $dbObject['name'] : $customTitleDesc['title'],
			'description'	=> $customTitleDesc['description'],
			'createdate'	=> $dbObject['date'],
			'takendate'		=> $dbObject['mdate'],
			'size'			=> $dbObject['filesize'],
			'duration'		=> (int)$dbObject['duration'],
			'gps'			=> json_decode($dbObject['gps']),
			'rotation'		=> (int)$dbObject['rotation'],
			'rating'		=> (int)$dbObject['rating']
		);
		if (isset($dbObject['pos'])) {
			$item['pos'] = (int) $dbObject['pos'];
		}

		$coverPath = $dbObject['path'];
		$sharepath = substr($coverPath, strlen(SYNOPHOTO_SERVICE_REAL_DIR_PATH));
		$dir = Album::IsRootSharename(dirname($sharepath)) ? '/' : dirname($sharepath);
		// additional handler
		$item['info'] = $item_info;
		$item['additional'] = AlbumAPIUtil::FormAdditional('video', $dbObject, $params);

		$isConversion = csSYNOPhotoMisc::IsAlbumAllowConversion($dir);

		AlbumAPIUtil::FillThumbStatus($item, $coverPath, $needThumbSize, $dbObject['resolutionx'], $dbObject['resolutiony'], false, $isConversion);
		return $item;
	}

	static function PhotoFormula($dbObject, $config = array())
	{
		$params = $config['param'];
		$needThumbSize = $config['needThumbSize'] ? $config['needThumbSize'] : in_array('thumb_size', $params['additional']);
		$item = array(
			'id'	=> $config['id'] ? $config['id'] : self::EncodeItemId($dbObject['path'], "photo_"),
			'type'	=> 'photo'
		);

		$item_info = array(
			'name'			=> $dbObject['name'],
			'title'			=> $dbObject['title'],
			'description'	=> $dbObject['description'],
			'createdate'	=> $dbObject['createdate'],
			'takendate'		=> $dbObject['timetaken'],
			'size'			=> $dbObject['size'],
			'resolutionx'	=> (int)$dbObject['resolutionx'],
			'resolutiony'	=> (int)$dbObject['resolutiony'],
			'rotated'		=> (0 === (int)$dbObject['version'] % 2) ? false : true,
			'rotate_version'=> (int)$dbObject['version'],
			'rotation'		=> (int)$dbObject['rotation'],
			'lat'			=> $dbObject['lat'],
			'lng'			=> $dbObject['lng'],
			'rating'		=> (int)$dbObject['rating']
		);
		if (isset($dbObject['pos'])) {
			$item['pos'] = (int) $dbObject['pos'];
		}

		if (isset($dbObject['gps_idx'])) {
			$item['gps_idx'] = $dbObject['gps_idx'];
		}

		$coverPath = $dbObject['path'];
		$blThumbRotated = (0 === (int)$dbObject['version'] % 2) ? false : true;

		$sharepath = substr($coverPath, strlen(SYNOPHOTO_SERVICE_REAL_DIR_PATH));
		$dir = Album::IsRootSharename(dirname($sharepath)) ? '/' : dirname($sharepath);
		// additional handler
		$item['info'] = $item_info;
		$item['additional'] = AlbumAPIUtil::FormAdditional('photo', $dbObject, $params);

		$isConversion = csSYNOPhotoMisc::IsAlbumAllowConversion($dir);

		AlbumAPIUtil::FillThumbStatus($item, $coverPath, $needThumbSize, $dbObject['resolutionx'], $dbObject['resolutiony'], $blThumbRotated, $isConversion);
		return $item;
	}

	static function EncodeItemId($id, $prefix) {
		if (!in_array($prefix, array('photo_', 'video_'))) {
			return $prefix.bin2hex($id);
		}

		$sharepath = substr($id, strlen(SYNOPHOTO_SERVICE_REAL_DIR_PATH));
		$fileName = basename($sharepath);
		$sharename = dirname($sharepath);
		if ('.' === $sharename || '' === $sharename) {
			$sharename = '/';
		}
		return $prefix.bin2hex($sharename)."_".bin2hex($fileName);
	}

	static function AlbumPublicFormula($dbObject, $config = array())
	{
		$itemFormat = Decorator::AlbumFormula($dbObject, $config);
		$title = $itemFormat['info']['title'];
		$thumbsize = $itemFormat['additional']['thumb_size'];
		$is_public = (count(explode('/', $itemFormat['info']['sharepath'])) > 2) || ($itemFormat['info']['type'] === 'public');
		if ($is_public) {
			$item = array(
				'id' => $itemFormat['id'],
				'title' => $title,
				'thumb_size' => $thumbsize,
				'type' => $itemFormat['type']
			);
			return $item;
		}
		return false;
	}

	static function PhotoPublicFormula($dbObject, $config = array())
	{
		$itemFormat = Decorator::PhotoFormula($dbObject, $config);
		$title = $itemFormat['info']['title'];
		$thumbsize = array();
		$thumbsize = $itemFormat['additional']['thumb_size'];
		$item = array(
			'id' => $itemFormat['id'],
			'title' => $title,
			'thumb_size' => $thumbsize,
			'type' => $itemFormat['type']
		);
		return $item;
	}

	static function SmartPublicFormula($dbObject, $config = array())
	{
		$itemFormat = Decorator::SmartFormula($dbObject, $config);
		if (-1 === $itemFormat) {
			return -1;
		}
		$thumbsize = $itemFormat['additional']['thumb_size'];
		$item = array(
			'id' => $itemFormat['id'],
			'title' => $itemFormat['name'],
			'thumb_size' => $thumbsize,
			'type' => $itemFormat['type']
		);
		return $item;
	}

	static function SmartPhotoPublicFormula($dbObject, $config = array()) {
		$thumbsize = array();
		$thumbsize = $dbObject['additional']['thumb_size'];
		$item = array(
			'id' => $dbObject['id'],
			'title' => $dbObject['info']['title'],
			'thumb_size' => $thumbsize,
			'type' => $dbObject['type']
		);
		return $item;
	}

}

?>
