<?PHP

set_time_limit(0);
session_cache_limiter("must-revalidate");

//workaround for locale-awared function "basename()" in DSM 5.0 env (#bug 2037)
setlocale(LC_CTYPE, "en_US.UTF-8");

require_once('thumb.inc.php');
require_once '../include/SYNOPhotoEA.php';
require_once('../include/photo/synophoto_csPhotoMisc.php');
require_once '../include/shared_album.php';
require_once('../include/photo/synophoto_csPhotoDB.php');
require_once '../include/album.php';

class ThumbAPI extends WebAPI
{
	function __construct()
	{
		parent::__construct(SZ_WEBAPI_API_DESCRIPTION_PATH);
	}

	protected function Process()
	{
		csSYNOPhotoMisc::PhotoSessionStart();
		if ('' == SYNOPHOTO_URL_PREFIX && csSYNOPhotoMisc::checkDsmAccountEnabled()) {
			define('PHOTO_ACCESS_RIGHT_TABLE', 'photo_access_right_for_dsm_account');
			define('PHOTO_UPLOAD_RIGHT_TABLE', 'photo_upload_right_for_dsm_account');
			define('PHOTO_MANAGE_RIGHT_TABLE', 'photo_manage_right_for_dsm_account');
			define('PHOTO_GROUP_PERMISSION_TABLE', 'photo_group_permission_for_dsm_account');
			define('SHARED_ALBUM_TABLE_NAME', 'photo_personal_collection_for_dsm_account');
			define('SHARED_ALBUM_PHOTO_TABLE_NAME', 'photo_personal_collection_photo_for_dsm_account');
			define('SHARED_ALBUM_VIDEO_TABLE_NAME', 'photo_personal_collection_video_for_dsm_account');
		} else {
			define('PHOTO_ACCESS_RIGHT_TABLE', 'photo_access_right');
			define('PHOTO_UPLOAD_RIGHT_TABLE', 'photo_upload_right');
			define('PHOTO_MANAGE_RIGHT_TABLE', 'photo_manage_right');
			define('PHOTO_GROUP_PERMISSION_TABLE', 'photo_group_permission');
			define('PHOTO_USER_TABLE', 'photo_user');
			define('PHOTO_USER_GROUP_TABLE', 'photo_user_group');
			define('PHOTO_GROUP_TABLE', 'photo_group');
			define('SHARED_ALBUM_TABLE_NAME', 'photo_personal_collection');
			define('SHARED_ALBUM_PHOTO_TABLE_NAME', 'photo_personal_collection_photo');
			define('SHARED_ALBUM_VIDEO_TABLE_NAME', 'photo_personal_collection_video');
		}
		define('SHARED_ALBUM_ADMIN_TABLE_NAME', 'photo_personal_collection_for_admin');
		define('SHARED_ALBUM_PHOTO_ADMIN_TABLE_NAME', 'photo_personal_collection_photo_for_admin');
		define('SHARED_ALBUM_VIDEO_ADMIN_TABLE_NAME', 'photo_personal_collection_video_for_admin');

		if (preg_match('/\/~[^\/]+/', $_SERVER['REQUEST_URI'], $matches)){
			$userHome = csSYNOPhotoMisc::getUserHomePath(SYNOPHOTO_ADMIN_NAME);
			$userRealHomePath = csSYNOPhotoMisc::getUserRealHomePath(SYNOPHOTO_ADMIN_NAME);
			define('SYNOPHOTO_SERVICE_DIR', $userHome.'/photo');
			define('SYNOPHOTO_SERVICE_REAL_DIR', $userRealHomePath.'/photo');
			define('SYNOPHOTO_SERVICE_REAL_DIR_PREFIX', $userRealHomePath.'/photo/');
		}

		csSYNOPhotoDB::GetDBInstance()->SetSessionCache();
		if (isset($_REQUEST['public_share_id'])) {
			csSYNOPhotoDB::GetDBInstance()->SetPublicShareSessionCache($_REQUEST['public_share_id']);
		} else if (isset($_REQUEST['id']) && 0 === strpos($_REQUEST['id'], 'publicshare_')) {
			$id = $_REQUEST['id'];
			$id_arr = explode('_', $id);
			csSYNOPhotoDB::GetDBInstance()->SetPublicShareSessionCache($id_arr[1]);
		}
		session_write_close();
		if (!strcasecmp($this->method, "get")) {
			$this->Get();
		} else if (!strcasecmp($this->method, "get_dsm_thumb")) {
			$this->GetDSMThumb();
		}
	}

	private function PickThumbPath($dir, $fileName, $size)
	{
		$hasSmall = true;
		$hasLarge = true;
		$needSmall = false;
		$needLarge = false;

		if ('small' === $size) {
			$needSmall = true;
			$hasSmall = SYNOPhotoEA::checkFilePathByDirFile($dir, $fileName, SYNOPhotoEA::FILE_THUMB_M, $path);
		} elseif ('large' === $size) {
			$needLarge = true;
			$hasLarge = SYNOPhotoEA::checkFilePathByDirFile($dir, $fileName, SYNOPhotoEA::FILE_THUMB_XL, $path);
			if (!$hasLarge) {
				$hasLarge = SYNOPhotoEA::checkFilePathByDirFile($dir, $fileName, SYNOPhotoEA::FILE_THUMB_LARGE_PREVIEW, $path);
			}
		} elseif ('preview' === $size) {
			SYNOPhotoEA::checkFilePathByDirFile($dir, $fileName, SYNOPhotoEA::FILE_THUMB_PREVIEW, $path);
		}

		if ($needSmall && !$hasSmall) {
			if (!csSYNOPhotoMisc::IsAlbumAllowConversion($sharename)) {
				SYNOPhotoEA::checkFilePathByDirFile($dir, $fileName, SYNOPhotoEA::FILE_THUMB_PREVIEW, $path);
			}
		}

		if ($needLarge && !$hasLarge) {
			if (in_array(strtolower(pathinfo($fileName, PATHINFO_EXTENSION)), array('jpeg', 'bmp', 'png', 'jpg', 'jpe'))) {
				if (!csSYNOPhotoMisc::IsAlbumAllowConversion($sharename)) {
					$path = "$dir/$fileName";
				}
			}
		}

		return $path;
	}

	private function Get()
	{
		global $SYNOPHOTO_ALLOW_ID_TYPE;
		global $SYNOPHOTO_ID_TYPE_LEN;
		$ret = false;

		// return when lack of params
		if (!isset($_REQUEST['id']) || !isset($_REQUEST['size'])) {
			$this->SetError(PHOTOSTATION_THUMB_BAD_PARAMS);
			goto End;
		}

		// check params
		$id = $_REQUEST['id'];
		$id_arr = explode('_', $id);
		if ($id_arr[0] !== 'photo' && $id_arr[0] !== 'video') {
			// require albumutil.php before variable $type is assigned
			// due to "include/photo/album_util.php" will read variable $type and lead to check timeout
			require_once('albumutil.php');

			session_write_close();
		}

		$type = $id_arr[0];
		if (!in_array($type, $SYNOPHOTO_ALLOW_ID_TYPE)) {
			$this->SetError(PHOTOSTATION_THUMB_BAD_PARAMS);
			goto End;
		}
		if (count($id_arr) !== $SYNOPHOTO_ID_TYPE_LEN[$type]) {
			$this->SetError(PHOTOSTATION_THUMB_BAD_PARAMS);
			goto End;
		}
		$size = $_REQUEST['size'];
		if ('small' !== $size && 'large' !== $size && 'preview' !== $size) {
			$this->SetError(PHOTOSTATION_THUMB_BAD_PARAMS);
			goto End;
		}

		$publicShareId = NULL;
		$blSingleSharedAlbum = false;
		if (isset($_REQUEST['public_share_id']) || $id_arr[0] === 'publicshare') {
			$publicShareId = isset($_REQUEST['public_share_id']) ? $_REQUEST['public_share_id'] : $id_arr[1];
			if (!SharedAlbum::CheckPublicSharePermission($publicShareId)) {
				$this->SetError(PHOTOSTATION_THUMB_ACCESS_DENY);
				goto End;
			}
			$publicShareInfo = SharedAlbum::GetInfoByPublicShare($publicShareId);
			if (NULL === $publicShareInfo || 'valid' !== $publicShareInfo['share_status']) {
				$this->SetError(PHOTOSTATION_THUMB_ACCESS_DENY);
				goto End;
			}
			if ($publicShareInfo['advanced_info'] &&
				!AdvancedSharedAlbum::CheckSharedAlbumPassword(
					$publicShareInfo['id'],
					$publicShareInfo['userid'],
					$publicShareInfo['advanced_info'],
					$publicShareId,
					$_REQUEST['password'])) {
				$this->SetError(PHOTOSTATION_ALBUM_PASSWORD_ERROR);
				goto End;
			}
			$blSingleSharedAlbum = $publicShareInfo['shareid'];
		}
		if ($publicShareId !== NULL && ($type === 'photo' || $type === 'video')) {
			$albumName = @pack('H*', $id_arr[1]);
			$fileName = @pack('H*', $id_arr[2]);
			if (!csSYNOPhotoMisc::CheckAlbumAccessible($albumName, false, $publicShareId)) {
				$this->SetError(PHOTOSTATION_THUMB_ACCESS_DENY);
				goto End;
			}
			if (!$blSingleSharedAlbum) {
				$filePath = ('/' === $albumName ? "" : $albumName . "/") . $fileName;
				if (!SharedAlbum::CheckSharedAlbumItemValid($filePath, $type, $publicShareId)) {
					$this->SetError(PHOTOSTATION_THUMB_ACCESS_DENY);
					goto End;
				}
			}
		}

		// start to construct thumbnail path from the given id
		$dir = '';
		$sharename = '';
		$fileName = '';
		$albumName = '';
		$url = '';
		$path = '';
		$isPublic = false;
		if (SYNOPHOTO_UNCONFIRM_TAG_ID === $id) {
			$list = AlbumAPIUtil::GetUnConfirmItemList(1, 0);
			$keys = array_keys($list);
			$fullPath = $keys[0];
			$dir = dirname($fullPath);
			$albumName = substr($dir, strlen(SYNOPHOTO_SERVICE_REAL_DIR.'/'));
			$fileName = basename($fullPath);
			$sharename = $albumName;
		} else if ('photo' === $type || 'video' === $type) {
			$sharename = $albumName = @pack('H*', $id_arr[1]);
			$dir = SYNOPHOTO_SERVICE_REAL_DIR . ('/' === $albumName ? "" : "/" . $albumName);
			$fileName = @pack('H*', $id_arr[2]);
		} elseif ('smart' === $type) {
			$albumName = @pack('H*', $id_arr[1]);
			$album = SmartAlbum::GetSmartAlbumInstance()->GetCoverOfSmartAlbumByName($albumName);
			if (!$album['success']) {
				$this->SetError(PHOTOSTATION_THUMB_ACCESS_DENY);
				goto End;
			}
			$cover_path = $album['cover']['path'];
			if ('' !== $cover_path) {
				$dir = substr($cover_path, 0, strrpos($cover_path, '/'));
				$fileName = basename($cover_path);
			} else {
				$path = SYNO_PKG_DIR . "/target" . SYNOPHOTO_IMG_EMPTY_HIGH_QUALITY;
			}
			$isPublic = true;
		} else if ('sharedalbum' === $type || 'publicshare' === $type) {
			if ('sharedalbum' === $type) {
				if ($id_arr[1] === 'single') {
					$sharedAlbum = SharedAlbum::GetHiddenAlbumInfo();
					if ($sharedAlbum !== NULL) {
						$id_arr[1] = explode("_", $sharedAlbum['id'])[1];
					}
				}
				$cover = SharedAlbum::GetSharedAlbumCover($id_arr[1]);
			} else {
				$cover = SharedAlbum::GetSharedAlbumCover(NULL, $id_arr[1]);
			}
			if (NULL === $cover) {
				$this->SetError(PHOTOSTATION_THUMB_ACCESS_DENY);
				goto End;
			}
			$path_parts = pathinfo($cover['path']);
			$fileName = $path_parts['basename'];
			$sharename = substr($path_parts['dirname'], strlen(SYNOPHOTO_SERVICE_REAL_DIR_PATH));
			$dir = $path_parts['dirname'];
			if ('root' === SYNOPHOTO_ADMIN_USER) {
				if ($dir === SYNOPHOTO_SERVICE_REAL_DIR) {
					$albumName = '/';
				} else {
					$albumName = substr($dir, strlen(SYNOPHOTO_SERVICE_REAL_DIR) + 1);
				}
			} else {
				$albumName = "." === $dir ? "/" : $dir;
				$dir = SYNOPHOTO_SERVICE_REAL_DIR . "/" . $dir;
			}
			if (empty($albumName) || empty($fileName)) {
				$this->SetError(PHOTOSTATION_THUMB_NO_COVER);
				goto End;
			}
		} else {
			if ('album' === $type) {
				$albumName = @pack('H*', $id_arr[1]);
				$album = csSYNOPhotoAlbum::GetAlbumInstance()->GetAlbumCover($albumName);
			} elseif ('virtual' === $type) {
				$isPublic = true;
				$album = csSYNOPhotoBrowse::GetBrowseInstance()->GetVirtualAlbumThumb($id_arr[1]);
			} elseif ('tag' === $type) {
				$isPublic = true;
				$album = csSYNOPhotoAlbum::GetAlbumInstance()->GetLabelAlbumCover($id_arr[1]);
            } elseif ('defaultsmart' === $type) {
                $index = 0;
                if ('people' === $id_arr[1]) {
                    $index = 0;
                } elseif ('geo' === $id_arr[1]) {
                    $index = 1;
                } elseif ('desc' === $id_arr[1]) {
                    $index = 2;
                }
                $isPublic = true;
                $categoryArr = array();
                array_push($categoryArr, $index);
                $result = SYNOPHOTO_LABEL_UTIL_GetAllLabel(false, $categoryArr);
                $album = csSYNOPhotoAlbum::GetAlbumInstance()->GetLabelAlbumCover($result[$index][0]['id']);
            }
			$url = $album['bigCover']['src'];

			if (!empty($album['coverPath'])) {
				// extract cover info from coverPath
				$relativePath = substr($album['coverPath'], strlen(SYNOPHOTO_SERVICE_REAL_DIR_PATH));
				$path_parts = pathinfo($relativePath);
				$fileName = $path_parts['basename'];
				$albumName = $path_parts['dirname'];
				if (Album::IsRootSharename($albumName)) {
					$albumName = '/';
				}
				$dir = SYNOPHOTO_SERVICE_REAL_DIR . "/" . $albumName;
			} else {
				$albumName = @pack('H*', substr($url, strpos($url, 'dir=') + 4, strpos($url, '&name') - strpos($url, 'dir=') - 4));
				$fileName = @pack('H*', substr($url, strpos($url, 'name=') + 5, strpos($url, '&type') - strpos($url, 'name=') - 5));
				$dir = SYNOPHOTO_SERVICE_REAL_DIR . "/" . $albumName;
			}

			if ("" === $albumName || empty($fileName)) {
				$this->SetError(PHOTOSTATION_THUMB_NO_COVER);
				goto End;
			}
		}

		// check access right
		if (!$isPublic && !csSYNOPhotoMisc::CheckAlbumAccessible($albumName, false, $publicShareId)) {
			$this->SetError(PHOTOSTATION_THUMB_ACCESS_DENY);
			goto End;
		}

		// construct corresonding thumbnail path
		if ('' === $path) {
			$path = $this->PickThumbPath($dir, $fileName, $size);
		}

		// set mime type, default is jpeg
		$mime = 'image/jpeg';
		preg_match('/\.([^\.]*?)$/', $fileName, $matches);
		$extension = strtolower($matches[1]);
		// special case for gif, return original file
		if ('gif' === $extension) {
			$path = $dir . "/" . $fileName;
			$mime = 'image/gif';
		}

		if (!file_exists($path)) {
			$this->SetError(PHOTOSTATION_THUMB_FILE_NOT_EXISTS);
			goto End;
		}

		@header("Cache-Control: max-age=".(3600*24*7));

		// check last-modified value
		$lastModified = $this->GetLastModified($path);
		if ($lastModified) {
			if ($this->CheckLastModified($lastModified)) {
				@header("HTTP/1.1 304 Not Modified");
				return;
			} else {
				@header("Last-Modified: " . $lastModified);
			}
		}

		// output binary
		@header("Content-Type: $mime");
		$filename = $fileName;

		// Windows Phone WebHttpReponse cannot accept non-ascii character in response header
		// Replace non-ascii character with '_'
		if (preg_match("/Windows Phone OS/i", $_SERVER['HTTP_USER_AGENT'])) {
			$filename = preg_replace('/[^(\x20-\x7F)]*/', '_', $filename);
		}
		@header('Content-Disposition: inline; filename="'.addslashes($filename).'"');

		// Show backup file (original image without watermark) in watermark window preview panel
		$path_bak = $path . '.bak';
		if (isset($_REQUEST['w']) && $_REQUEST['w'] && file_exists($path_bak)) {
			$path = $path_bak;
		}

		$this->SYNOPHOTO_CONVERT_Rrange_Download($path);
		exit;

		End:
			return $ret;
	}

	private function GetPhotoMimeType($path)
	{
		$SYNOPHOTO_THUMB_MIME = array(
			'jpg' => 'image/jpeg',
			'jpeg' => 'image/jpeg',
			'jpe' => 'image/jpeg',
			'bmp' => 'image/bmp',
			'gif' => 'image/gif',
			'png' => 'image/png'
		);

		$path = strtolower($path);
		$path_parts = pathinfo($path);
		$extension = $path_parts['extension'];
		if (array_key_exists($extension, $SYNOPHOTO_THUMB_MIME)) {
			return $SYNOPHOTO_PICASA_MIME[$extension];
		}
		return null;
	}

	private function GetLoginUsername() {
		if (!isset($_SESSION[SYNOPHOTO_ADMIN_USER]) || (!isset($_SESSION[SYNOPHOTO_ADMIN_USER]['admin_syno_user']) && !isset($_SESSION[SYNOPHOTO_ADMIN_USER]['reg_syno_user']))) {
			return "Guest";
		}
		$username = 'admin';
		if (SYNOPHOTO_ADMIN_USER !== "root") {
			$username = substr(SYNOPHOTO_ADMIN_USER, 1);
		}
		if (isset($_SESSION[SYNOPHOTO_ADMIN_USER]['reg_syno_user'])) {
			$username = $_SESSION[SYNOPHOTO_ADMIN_USER]['reg_syno_user'];
			if (!isset($_SESSION[SYNOPHOTO_ADMIN_USER]['use_dsm_account']) || $_SESSION[SYNOPHOTO_ADMIN_USER]['use_dsm_account'] != '1') {
				$username = "Guest";
			}
		}
		return $username;
	}

	private function GetDSMThumb()
	{
		$ret = false;

		// return when lack of params
		$id = $this->DecodeItemId($_REQUEST['id'], 'dsmshare_');
		if (false === $id) {
			$this->SetError(PHOTOSTATION_THUMB_BAD_PARAMS);
			goto End;
		}

		//$command = "/usr/syno/bin/synophoto_extract_preview ".escapeshellarg(urldecode($id))." --stdout ".escapeshellarg($this->GetLoginUsername());
		//$output = @shell_exec($command);
		$output = '';
		csSYNOPhotoMisc::ExecCmd('/usr/syno/bin/synophoto_extract_preview', array(urldecode($id), '--stdout', $this->GetLoginUsername()), false, $output, true);

		if (($pos = strpos($output, "\n")) === false) {
			//output default image
			$imagefp = fopen("../photo_new/images/Window/image_default_photo_dark.png", "rb");
			@header("Content-Type: image/png");
			@header('Content-Disposition: inline; filename="image_default_photo_dark.png"');
			fpassthru($imagefp);
			exit;
		}
		$thumbPath = substr($output, 0, $pos);
		$mime = $this->GetPhotoMimeType($thumbPath);
		@header("Cache-Control: public, max-age=86400");
		@header("Content-Type: $mime");
		@header('Content-Disposition: inline; filename="'.addslashes($fileName).'"');
		echo substr($output, $pos+1);
		//echo $thumbName;
		exit;
	End:
		return $ret;
	}

	private function GetLastModified($thumbPath)
	{
		$filest = @stat($thumbPath);

		if ($filest !== false) {
			$lastModified = gmdate('D, d M Y H:i:s', $filest[9]) . ' GMT';
			return $lastModified;
		} else {
			return false;
		}
	}

	private function CheckLastModified($lastModified)
	{
		if (isset($_SERVER['HTTP_IF_MODIFIED_SINCE'])) {
			$ims = preg_replace('/;.*$/', '', $_SERVER['HTTP_IF_MODIFIED_SINCE'] );
			if ($ims === $lastModified) {
				return true;
			}
		}

		return false;
	}

	private function SYNOPHOTO_CONVERT_Rrange_Download($file)
	{
		$fp = @fopen($file, 'rb');
		if (FALSE == $fp) {
			return FALSE;
		}

		$size   = filesize($file); // File size
		$length = $size;		   // Content length
		$start  = 0;			   // Start byte
		$end	= $size - 1;	   // End byte
		// Now that we've gotten so far without errors we send the accept range header
		// At the moment we only support single ranges.
		// Multiple ranges requires some more work to ensure it works correctly
		// and comply with the spesifications: http://www.w3.org/Protocols/rfc2616/rfc2616-sec19.html#sec19.2
		//
		// Multirange support annouces itself with:
		// header('Accept-Ranges: bytes');
		//
		// Multirange content must be sent with multipart/byteranges mediatype,
		// (mediatype = mimetype)
		// as well as a boundry header to indicate the various chunks of data.
		//
		//header("Accept-Ranges: 0-$length");
		header('Accept-Ranges: bytes');
		// multipart/byteranges
		// http://www.w3.org/Protocols/rfc2616/rfc2616-sec19.html#sec19.2
		if (isset($_SERVER['HTTP_RANGE'])) {
			$c_start = $start;
			$c_end   = $end;
			// Extract the range string
			list(, $range) = explode('=', $_SERVER['HTTP_RANGE'], 2);
			// Make sure the client hasn't sent us a multibyte range
			if (strpos($range, ',') !== false) {

				// (?) Shoud this be issued here, or should the first
				// range be used? Or should the header be ignored and
				// we output the whole content?
				header('HTTP/1.1 416 Requested Range Not Satisfiable');
				header("Content-Range: bytes $start-$end/$size");
				// (?) Echo some info to the client?
				exit;
			}
			// If the range starts with an '-' we start from the beginning
			// If not, we forward the file pointer
			// And make sure to get the end byte if spesified
			if ($range{0} == '-') {

				// The n-number of the last bytes is requested
				$c_start = $size - substr($range, 1);
			}
			else {

				$range  = explode('-', $range);
				$c_start = $range[0];
				$c_end   = (isset($range[1]) && is_numeric($range[1])) ? $range[1] : $size;
			}
			// Check the range and make sure it's treated according to the specs.
			// http://www.w3.org/Protocols/rfc2616/rfc2616-sec14.html
			//
			// End bytes can not be larger than $end.
			$c_end = ($c_end > $end) ? $end : $c_end;
			// Validate the requested range and return an error if it's not correct.
			if ($c_start > $c_end || $c_start > $size - 1 || $c_end >= $size) {

				header('HTTP/1.1 416 Requested Range Not Satisfiable');
				header("Content-Range: bytes $start-$end/$size");
				// (?) Echo some info to the client?
				exit;
			}
			$start  = $c_start;
			$end	= $c_end;
			$length = $end - $start + 1; // Calculate new content length
			fseek($fp, $start);
			header('HTTP/1.1 206 Partial Content');
		}
		// Notify the client the byte range we'll be outputting
		if (preg_match("/Windows Mobile/i", $_SERVER['HTTP_USER_AGENT'])) {
			header("Content-Range: bytes $start-$end/$size");
		}
		header("Content-Length: $length");

		// Start buffered download
		$buffer = 1024 * 8;
		while(!feof($fp) && ($p = ftell($fp)) <= $end) {

			if ($p + $buffer > $end) {

				// In case we're only outputtin a chunk, make sure we don't
				// read past the length
				$buffer = $end - $p + 1;
			}

			echo fread($fp, $buffer);
			flush(); // Free up memory. Otherwise large files will trigger PHP's memory limit.
		}
		fclose($fp);
	}
}

$api = new ThumbAPI();
$api->Run();
?>
