<?php

define('SYNO_PKG_DIR', $argv[1]);

/* include php files */
require_once(SYNO_PKG_DIR . '/target/photo_scripts/misc.php');

define('MUSIC_CONFIG', "SYNOPHOTO_MUSIC_CONFIG");
define("DEFAULT_MUSIC_ID", "SYNOPHOTO_MUSIC_DEFAULT");

function main()
{
	global $user, $userHome;

	/* list dsm users */
	$dsmUserList = getDSMUserList();
	$usernameList = array_merge(array(''), $dsmUserList);

	foreach ($usernameList as $username) {
		$user = $username;
		if (false === ($userHome = getUserHomePath())) {
			exit(1);
		}
		$photoSharedFolder = getPhotoSharedFolderPath();
		AddPhotoDefaultMusic("$photoSharedFolder/@eaDir");
	}
}

function AddPhotoDefaultMusic($eaPath)
{
	if (!$eaPath) {
		return false;
	}
	if (!file_exists($eaPath)) {
		@mkdir($eaPath);
		@chmod($eaPath, 0777);
	}
	$data = ReadMusicFile($eaPath);
	if ($data[DEFAULT_MUSIC_ID]) {
		return true;
	}

	$data[DEFAULT_MUSIC_ID] = array(
		'title'	=> 'peaceful-now',
		'default' => false
	);

	if (WriteMusicFile($data, $eaPath)) {
		return false;
	}
	return true;
}

function ReadMusicFile ($eaDir)
{
	$musicFile = $eaDir.'/'.MUSIC_CONFIG;

	if (!@file_exists($musicFile)) {
		return array();
	}

	//get contents from smart album config file
	if (!$musicFileJSON = @file_get_contents($musicFile)) {
		return array();
	}

	//parse contents
	if (!$music = json_decode($musicFileJSON, true)) {
		return array();
	}

	$res = array();

	foreach ($music as $k => $v) {
		$res[$k] = array(
			'title' => $v['title'],
			'default' => $v['default'] ? true : false
		);
	}
	return $res;
}

function WriteMusicFile($data, $eaDir)
{
	$musicFile = $eaDir.'/'.MUSIC_CONFIG;

	if (!$music = json_encode($data)) {
		return false;
	}

	//beautify json string
	$content = indentJson($music);

	//put contents to smart album config file
	if (!@file_put_contents($musicFile, $content)) {
		return false;
	}

	chmod($musicFile, 0666);
	return true;
}

main();

exit;
?>
