#!/bin/sh
# Copyright (c) 2000-2019 Synology Inc. All rights reserved.

BIN_FOLDER="/usr/bin"
BIN_SH="/bin/sh"
BIN_SU="/bin/su"
POSTGRESQL_USER="-U postgres"

POSTGRESQL_PSQL="$BIN_FOLDER/psql $POSTGRESQL_USER"
POSTGRESQL_CREATEDB="$BIN_FOLDER/createdb $POSTGRESQL_USER"
POSTGRESQL_DROPDB="$BIN_FOLDER/dropdb $POSTGRESQL_USER"
POSTGRESQL_PG_DUMP="$BIN_FOLDER/pg_dump $POSTGRESQL_USER"
POSTGRESQL_PSQL_PHOTO="$POSTGRESQL_PSQL photo"

PHOTO_PSQL_CMD="$BIN_SU PhotoStation -s $BIN_SH -c"
PHOTO_PSQL_PHOTO="$BIN_FOLDER/psql photo"

SYNOPHOTO_DSM_USER="/usr/syno/bin/synophoto_dsm_user"
get_user_home_path() {
	$SYNOPHOTO_DSM_USER --getinfo $1 | while read line
	do
		path=`echo $line | awk -F: '/^User\sDir\s+:\s+\[(.+)\]$/ {print $2}'`
		if [ "$path" != "" ]; then
			echo ${path//[\[|\]]/}
		fi
	done
}
