#!/bin/sh
# Copyright (c) 2000-2019 Synology Inc. All rights reserved.
Upgrade=0

. /var/packages/PhotoStation/target/photo_scripts/include.sh

echo "Update photo log table where log id = 0 to test db existence"
$POSTGRESQL_PSQL_PHOTO -c "update photo_log set success = false where logid = 0"
Ret=$?
if [ $Ret = 2 ]; then
   $POSTGRESQL_CREATEDB photo
   if [ $? != 0 ]; then
      echo "Failed to create database"
      exit
   fi
   $POSTGRESQL_PSQL -c "ALTER DATABASE photo OWNER TO PhotoStation"
   Ret=1
fi

if [ $Ret = 1 ]; then
   $PHOTO_PSQL_CMD "$PHOTO_PSQL_PHOTO -f /var/packages/PhotoStation/target/photo_scripts/sql/photo.pgsql"
   if [ $? != 0 ]; then
      echo "Failed to create tables in photo database"
      exit
   fi
   /usr/syno/bin/synoindex -P PhotoStation -R photo
fi

if [ -f "/tmp/photo.pgdump" ]; then
   $POSTGRESQL_PSQL_PHOTO < /tmp/photo.pgdump
   if [ $? != 0 ]; then
      echo "Failed to restore photo database"
      exit
   fi

   rm /tmp/photo.pgdump
   if [ $? != 0 ]; then
      echo "Failed to remove photo database backup"
      exit
   fi
fi

echo "Update blog_config table in photo db where config_id = 0 to test blog tables existence"
$POSTGRESQL_PSQL_PHOTO -c "update blog_config set config_value = '' where config_id = 0"
Ret=$?
echo  $Ret
if [ $Ret = 1 ]; then
   Script="/var/packages/PhotoStation/target/photo_scripts/sql/blog.pgsql"
   $PHOTO_PSQL_CMD "$PHOTO_PSQL_PHOTO < $Script"
   if [ $? != 0 ]; then
      echo "Failed to create blog tables"
      exit
   fi
fi
