#!/bin/sh
# Copyright (c) 2000-2019 Synology Inc. All rights reserved.

GREP="/bin/grep"
SQLITE="/usr/bin/sqlite3"
UPGRADE_DIR="/var/packages/PhotoStation/target/photo_scripts/sql/pps_upgrade"
UPGRADE_SCRIPT="013_photo_index_all_photo_folder.sql"

echo "Check root folder (/) in photo_share table or not"
SQL="SELECT count(sharename) FROM photo_share WHERE sharename='/'"
db="$1"

$SQLITE "$db" "$SQL" | $GREP "0" > /dev/null 2>&1
hasRootFolder=$?

if [ $hasRootFolder = 0 ]; then
	username=$(echo $db | sed 's/^.*homes\///g')
	username=$(echo $username | sed "s/\/.*$//g")

	Script="$UPGRADE_DIR/$UPGRADE_SCRIPT"

	$SQLITE "$db" < $Script

	echo "Re-index personal photo db of [$username] due to no root folder in photo_share"
	/usr/syno/bin/synoindex -P PhotoStation -R user:"$username" > /dev/null 2>&1
fi

