#!/bin/sh
# Copyright (c) 2000-2019 Synology Inc. All rights reserved.

SQLITE="/usr/bin/sqlite3"
UPGRADE_DIR="/var/packages/PhotoStation/target/photo_scripts/sql/pps_upgrade"
UPGRADE_SCRIPT="017_photo_image_video_add_column.sql"


echo "Select photo_image table to test column privilege_shareid existence"
SQL="SELECT privilege_shareid FROM photo_image LIMIT 1;"
db="$1"
$SQLITE "$db" "$SQL" >/dev/null 2>&1
Ret=$?
if [ $Ret = 1 ]; then
	Script="$UPGRADE_DIR/$UPGRADE_SCRIPT"

	$SQLITE "$db" < $Script
	if [ $? != 0 ]; then
		echo "Failed to upgrade photo database pps-017"
		exit 2
	fi
fi

CREATE_INDEX="CREATE INDEX photo_image_shareid_idx ON photo_image USING btree (shareid);
			 CREATE INDEX photo_image_privilege_shareid_idx ON photo_image USING btree (privilege_shareid);
			 CREATE INDEX video_shareid_idx ON video USING btree (shareid);
			 CREATE INDEX video_privilege_shareid_idx ON video USING btree (privilege_shareid);"


$SQLITE "$db" "$CREATE_INDEX"

exit 0
