#!/bin/sh
# Copyright (c) 2000-2019 Synology Inc. All rights reserved.

SQLITE="/usr/bin/sqlite3"
UPGRADE_DIR="/var/packages/PhotoStation/target/photo_scripts/sql/pps_upgrade"
UPGRADE_SCRIPT="024_pps_photo_image_lens_add_column.sql"


echo "Select photo_image table to test column focal_length_v2 existence"
SQL="SELECT focal_length_v2 FROM photo_image LIMIT 1;"
db="$1"
$SQLITE "$db" "$SQL" >/dev/null 2>&1
Ret=$?
if [ $Ret = 1 ]; then
	Script="$UPGRADE_DIR/$UPGRADE_SCRIPT"

	$SQLITE "$db" < $Script
	if [ $? != 0 ]; then
		echo "Failed to upgrade photo database pps-024"
		exit 2
	fi
	# check focal_length exist, update focal_length to focal_length_v2
	$SQLITE "$db" "SELECT focal_length FROM photo_image LIMIT 1" >/dev/null 2>&1
	Ret=$?
	if [ $Ret = 0 ]; then
		$SQLITE "$db" "UPDATE photo_image SET focal_length = '' WHERE focal_length IS NULL" > /dev/null 2>&1
		$SQLITE "$db" "UPDATE photo_image SET lens = '' WHERE lens IS NULL" > /dev/null 2>&1
		$SQLITE "$db" "UPDATE photo_image SET flash = '' WHERE flash IS NULL" > /dev/null 2>&1
		$SQLITE "$db" "UPDATE photo_image SET focal_length_v2 = focal_length, flash_v2 = flash, lens_v2 = lens" >/dev/null 2>&1
	fi
fi
