#!/bin/sh
# Copyright (c) 2000-2019 Synology Inc. All rights reserved.

SQLITE="/usr/bin/sqlite3"
UPGRADE_DIR="/var/packages/PhotoStation/target/photo_scripts/sql/pps_upgrade"
UPGRADE_SCRIPT="027_photo_image_label_add_constraint.sql"

echo "Update photo_label table to test constraint correct"
SQL="SELECT sql FROM sqlite_master WHERE type='table' AND name='photo_image_label'"
db="$1"

$SQLITE "$db" "$SQL" | grep "image_label_ukey" > /dev/null 2>&1
Ret=$?

if [ $Ret = 1 ]; then
	echo "Change primary key constraint to photo_label table"
	Script="$UPGRADE_DIR/$UPGRADE_SCRIPT"

	$SQLITE "$db" < $Script
	if [ $? != 0 ]; then
		echo "Failed to upgrade photo database pps-027"
		exit 2
	fi
fi
