BEGIN;

CREATE TABLE photo_image_label_tmp (
  id INTEGER PRIMARY KEY AUTOINCREMENT,
  image_id int4 NOT NULL,
  label_id int4 NOT NULL,
  info text DEFAULT '',
  info_new TEXT DEFAULT '',
  status text DEFAULT 't',
  CONSTRAINT photo_image_label_photo_id_fkey1 FOREIGN KEY (image_id) REFERENCES photo_image (id) MATCH SIMPLE ON UPDATE RESTRICT ON DELETE CASCADE,
  CONSTRAINT photo_image_label_label_id_fkey1 FOREIGN KEY (label_id) REFERENCES photo_label (id) MATCH SIMPLE ON UPDATE RESTRICT ON DELETE CASCADE,
  CONSTRAINT image_label_ukey UNIQUE (image_id, label_id)
);

INSERT INTO photo_image_label_tmp (image_id, label_id, info, info_new, status) SELECT DISTINCT image_id, label_id, info, info_new, status from photo_image_label;
DROP TABLE photo_image_label;
ALTER TABLE photo_image_label_tmp RENAME TO photo_image_label;

COMMIT;
