#!/bin/sh
# Copyright (c) 2000-2019 Synology Inc. All rights reserved.

SQLITE="/usr/bin/sqlite3"
UPGRADE_DIR="/var/packages/PhotoStation/target/photo_scripts/sql/pps_upgrade"
UPGRADE_SCRIPT="028_photo_video_add_rating_column.sql"


echo "Select photo_image table to test column rating existence"
SQL="SELECT rating FROM photo_image LIMIT 1;"
db="$1"
$SQLITE "$db" "$SQL" >/dev/null 2>&1
Ret=$?
if [ $Ret = 1 ]; then
	Script="$UPGRADE_DIR/$UPGRADE_SCRIPT"

	$SQLITE "$db" < $Script
	if [ $? != 0 ]; then
		echo "Failed to upgrade photo database pps-028"
		exit 2
	else
		username=$(echo $db | sed 's/^.*homes\///g')
		username=$(echo $username | sed "s/\/.*$//g")
		/usr/syno/bin/synoindex -P PhotoStation -R user:"$username" > /dev/null 2>&1
		logger -p user.err -t "PhotoStation" "Re-index personal db of [$username] triggered by add rating column"
	fi
fi
