#!/bin/sh
# Copyright (c) 2000-2019 Synology Inc. All rights reserved.

SQLITE="/usr/bin/sqlite3"
UPGRADE_DIR="/var/packages/PhotoStation/target/photo_scripts/sql/pps_upgrade"
UPGRADE_SCRIPT="029_modify_photo_config_allow_download.sql"

echo "Check if allow_guest_download exist"

SQL="SELECT config_key FROM photo_config WHERE config_key = 'allow_guest_download'"
db="$1"

$SQLITE "$db" "$SQL" | grep "allow_guest_download" > /dev/null 2>&1
Ret=$?
if [ $Ret = 0 ]; then
	echo "Already modify to allow_guest_download, return"
	exit 0;
fi

echo "Modify allow_album_download to allow_guest_download"
Script="$UPGRADE_DIR/$UPGRADE_SCRIPT"

$SQLITE "$db" < $Script
if [ $? != 0 ]; then
	echo "Failed to upgrade photo database pps-029"
	exit 2
fi
