BEGIN;

ALTER TABLE photo_personal_collection ADD COLUMN is_advanced text NOT NULL DEFAULT 'f';
ALTER TABLE photo_personal_collection_for_admin ADD COLUMN is_advanced text NOT NULL DEFAULT 'f';

CREATE TABLE photo_advanced_personal_collection
(
	collectionid integer NOT NULL,
	comment text DEFAULT 'f',
	tag_area text DEFAULT 'f',
	enable_password text DEFAULT 'f',
	password varchar(128) DEFAULT '',
	color_label text DEFAULT 'f',
	color_label_1 varchar(128),
	color_label_2 varchar(128),
	color_label_3 varchar(128),
	color_label_4 varchar(128),
	color_label_5 varchar(128),
	color_label_6 varchar(128),
	CONSTRAINT photo_advanced_personal_collection_pkey PRIMARY KEY (collectionid),
	CONSTRAINT photo_advanced_personal_collection_collectionID_fkey FOREIGN KEY (collectionid)
	REFERENCES photo_personal_collection (id) MATCH SIMPLE ON UPDATE CASCADE ON DELETE CASCADE
);

CREATE TABLE photo_advanced_personal_collection_for_admin
(
	collectionid integer NOT NULL,
	comment text DEFAULT 'f',
	tag_area text DEFAULT 'f',
	enable_password text DEFAULT 'f',
	password varchar(128) DEFAULT '',
	color_label text DEFAULT 'f',
	color_label_1 varchar(128),
	color_label_2 varchar(128),
	color_label_3 varchar(128),
	color_label_4 varchar(128),
	color_label_5 varchar(128),
	color_label_6 varchar(128),
	CONSTRAINT photo_advanced_personal_collection_for_admin_pkey PRIMARY KEY (collectionid),
	CONSTRAINT photo_advanced_personal_collection_for_admin_collectionID_fkey FOREIGN KEY (collectionid)
	REFERENCES photo_personal_collection_for_admin (id) MATCH SIMPLE ON UPDATE CASCADE ON DELETE CASCADE
);

CREATE TABLE photo_advanced_personal_collection_item
(
	id integer NOT NULL,
	collectionid integer NOT NULL,
	type varchar(8) NOT NULL,
	item_id integer NOT NULL,
	color_label int4 DEFAULT 0,
	CONSTRAINT photo_advanced_personal_collection_item_pkey PRIMARY KEY (id),
	CONSTRAINT photo_advanced_personal_collection_item_collectionID_fkey FOREIGN KEY (collectionid)
	REFERENCES photo_personal_collection (id) MATCH SIMPLE ON UPDATE CASCADE ON DELETE CASCADE
);

CREATE TABLE photo_advanced_personal_collection_item_for_admin
(
	id integer NOT NULL,
	collectionid integer NOT NULL,
	type varchar(8) NOT NULL,
	item_id integer NOT NULL,
	color_label int4 DEFAULT 0,
	CONSTRAINT photo_advanced_personal_collection_item_for_admin_pkey PRIMARY KEY (id),
	CONSTRAINT photo_advanced_personal_collection_item_for_admin_collectionID_fkey FOREIGN KEY (collectionid)
	REFERENCES photo_personal_collection_for_admin (id) MATCH SIMPLE ON UPDATE CASCADE ON DELETE CASCADE
);

CREATE TABLE photo_advanced_personal_collection_comment
(
	id integer NOT NULL,
	advanced_item_id integer NOT NULL,
	name varchar(100),
	email varchar(128),
	comment text,
	date timestamp,
	CONSTRAINT photo_advanced_personal_collection_comment_pkey PRIMARY KEY (id),
	CONSTRAINT photo_advanced_personal_collection_comment_itemID_fkey FOREIGN KEY (advanced_item_id)
	REFERENCES photo_advanced_personal_collection_item (id) MATCH SIMPLE ON UPDATE CASCADE ON DELETE CASCADE
);

CREATE TABLE photo_advanced_personal_collection_comment_for_admin
(
	id integer NOT NULL,
	advanced_item_id integer NOT NULL,
	name varchar(100),
	email varchar(128),
	comment text,
	date timestamp,
	CONSTRAINT photo_advanced_personal_collection_comment_for_admin_pkey PRIMARY KEY (id),
	CONSTRAINT photo_advanced_personal_collection_comment_for_admin_itemID_fkey FOREIGN KEY (advanced_item_id)
	REFERENCES photo_advanced_personal_collection_item_for_admin (id) MATCH SIMPLE ON UPDATE CASCADE ON DELETE CASCADE
);

CREATE TABLE photo_advanced_personal_collection_tag_area
(
	id integer NOT NULL,
	advanced_item_id integer NOT NULL,
	position text DEFAULT '',
	info text,
	CONSTRAINT photo_advanced_personal_collection_tag_area_pkey PRIMARY KEY (id),
	CONSTRAINT photo_advanced_personal_collection_tag_area_itemID_fkey FOREIGN KEY (advanced_item_id)
	REFERENCES photo_advanced_personal_collection_item (id) MATCH SIMPLE ON UPDATE CASCADE ON DELETE CASCADE
);

CREATE TABLE photo_advanced_personal_collection_tag_area_for_admin
(
	id integer NOT NULL,
	advanced_item_id integer NOT NULL,
	position text DEFAULT '',
	info text,
	CONSTRAINT photo_advanced_personal_collection_tag_area_for_admin_pkey PRIMARY KEY (id),
	CONSTRAINT photo_advanced_personal_collection_tag_area_for_admin_itemID_fkey FOREIGN KEY (advanced_item_id)
	REFERENCES photo_advanced_personal_collection_item_for_admin (id) MATCH SIMPLE ON UPDATE CASCADE ON DELETE CASCADE
);

CREATE TABLE photo_advanced_personal_collection_log
(
	id integer NOT NULL,
	collectionid integer NOT NULL,
	advanced_item_id integer NOT NULL,
	log text NOT NULL default '',
	date timestamp,
	category int2 NOT NULL default 0,
	CONSTRAINT photo_advanced_personal_collection_log_pkey PRIMARY KEY (id)
	CONSTRAINT "photo_advanced_personal_collectionid_fkey" FOREIGN KEY (collectionid)
		REFERENCES photo_personal_collection (id) MATCH SIMPLE
		ON UPDATE CASCADE ON DELETE CASCADE,
	CONSTRAINT "photo_advanced_personal_advanced_item_id_fkey" FOREIGN KEY (advanced_item_id)
		REFERENCES photo_advanced_personal_collection_item (id) MATCH SIMPLE
		ON UPDATE CASCADE ON DELETE CASCADE
);

CREATE TABLE photo_advanced_personal_collection_log_for_admin
(
	id integer NOT NULL,
	collectionid integer NOT NULL,
	advanced_item_id integer NOT NULL,
	log text NOT NULL default '',
	date timestamp,
	category int2 NOT NULL default 0,
	CONSTRAINT photo_advanced_personal_collection_log_for_admin_pkey PRIMARY KEY (id)
	CONSTRAINT "photo_advanced_personal_for_admin_collectionid_fkey" FOREIGN KEY (collectionid)
		REFERENCES photo_personal_collection_for_admin (id) MATCH SIMPLE
		ON UPDATE CASCADE ON DELETE CASCADE,
	CONSTRAINT "photo_advanced_personal_for_admin_advanced_item_id_fkey" FOREIGN KEY (advanced_item_id)
		REFERENCES photo_advanced_personal_collection_item_for_admin (id) MATCH SIMPLE
		ON UPDATE CASCADE ON DELETE CASCADE
);
COMMIT;
