BEGIN;
-- rename table to old
ALTER TABLE photo_personal_collection RENAME TO photo_personal_collection_old;
ALTER TABLE photo_personal_collection_for_admin RENAME TO photo_personal_collection_for_admin_old;

-- alter table add shareid and recursive column
CREATE TABLE photo_personal_collection
(
	id INTEGER PRIMARY KEY AUTOINCREMENT,
	userid int8 NOT NULL,
	name varchar(128) NOT NULL,
	is_shared bool NOT NULL,
	start_time date,
	end_time date,
	sharelink varchar(8),
	hidden bool NOT NULL,
	create_date timestamp DEFAULT current_timestamp,
	is_album text NOT NULL DEFAULT 'f',
	is_advanced text NOT NULL DEFAULT 'f',
	shareid int4,
	recursive bool NOT NULL DEFAULT 'f',
	CONSTRAINT photo_personal_collection_fkey FOREIGN KEY (userid)
		REFERENCES photo_user (userid) MATCH SIMPLE ON UPDATE RESTRICT ON DELETE CASCADE,
	CONSTRAINT photo_collection_shareid_fkey FOREIGN KEY (shareid)
		REFERENCES photo_share (shareid) ON UPDATE CASCADE ON DELETE CASCADE
);

CREATE TABLE photo_personal_collection_for_admin
(
	id INTEGER PRIMARY KEY AUTOINCREMENT,
	name varchar(128) NOT NULL,
	is_shared bool NOT NULL,
	start_time date,
	end_time date,
	sharelink varchar(8),
	hidden bool NOT NULL,
	create_date timestamp DEFAULT current_timestamp,
	is_album text NOT NULL DEFAULT 'f',
	is_advanced text NOT NULL DEFAULT 'f',
	shareid int4,
	recursive bool NOT NULL DEFAULT 'f',
	CONSTRAINT photo_collection_admin_shareid_fkey FOREIGN KEY (shareid)
		REFERENCES photo_share (shareid) ON UPDATE CASCADE ON DELETE CASCADE
);

INSERT INTO photo_personal_collection (id, userid, name, is_shared, start_time, end_time, sharelink, hidden, create_date, is_album, is_advanced)
	SELECT * FROM photo_personal_collection_old;
INSERT INTO photo_personal_collection_for_admin (id, name, is_shared, start_time, end_time, sharelink, hidden, create_date, is_album, is_advanced)
	SELECT * FROM photo_personal_collection_for_admin_old;

-- drop photo_personal_collection_album* ?
DROP TABLE photo_personal_collection_old;
DROP TABLE photo_personal_collection_for_admin_old;

CREATE INDEX photo_personal_collection_sharelink_idx ON photo_personal_collection (sharelink);
CREATE INDEX photo_personal_collection_for_admin_sharelink_idx ON photo_personal_collection_for_admin (sharelink);

COMMIT;
