#!/bin/sh
# Copyright (c) 2000-2019 Synology Inc. All rights reserved.

bak=_bak

. /var/packages/PhotoStation/target/photo_scripts/include.sh

bak_tables=$($POSTGRESQL_PSQL_PHOTO -t -c "select tablename from pg_tables where \
  schemaname='public' and tablename in ('photo_access_right_bak', 'photo_comment_bak', \
  'photo_config_bak', 'photo_image_bak', 'photo_log_bak', 'photo_share_bak', \
  'photo_upload_right_bak', 'photo_user_bak', 'video_comment_bak', 'video_desc_bak')")

tables=$($POSTGRESQL_PSQL_PHOTO -t -c "select tablename from pg_tables where \
  schemaname='public' and tablename in ('photo_access_right', 'photo_comment', \
  'photo_config', 'photo_image', 'photo_log', 'photo_share', \
  'photo_upload_right', 'photo_user', 'video_comment', 'video_desc')")

for i in $bak_tables
do
	found=0
	for j in $tables
	do
		if [ "$i" == "${j}_bak" ]; then
			found=1
		fi
	done

	if [ $found = 0 ]; then
		# Only table_name_bak, so rename table_name_bak to table_name
		name=$(echo $i | awk -F "_bak" '{print $1}')
		$POSTGRESQL_PSQL_PHOTO -c "ALTER TABLE $i RENAME TO $name;" > /dev/null 2>&1
	else
		# Both table_name and table_name_bak, so drop table_name_bak
		$POSTGRESQL_PSQL_PHOTO -c "DROP TABLE $i;" > /dev/null 2>&1
	fi
done
