#!/bin/sh
# Copyright (c) 2000-2019 Synology Inc. All rights reserved.
Upgrade=0

. /var/packages/PhotoStation/target/photo_scripts/include.sh

echo "Update photoImage table to test new table existence"
$POSTGRESQL_PSQL_PHOTO -c "update photo_image set updated = '0' where id=0"
Ret=$?
if [ $Ret = 1 ]; then
   Ret=1
   Script="/var/packages/PhotoStation/target/photo_scripts/sql/upgrade/001_photo_upgrade.pgsql"
   Upgrade=1
else
   Ret=0
fi

if [ $Ret = 1 ]; then      
   $POSTGRESQL_PSQL_PHOTO < $Script
   if [ $? != 0 ]; then
      echo "Failed to upgrade photo database 001"
      exit
   fi
   /usr/syno/bin/synoindex -P PhotoStation -R photo
fi

if [ $Upgrade -eq 1 -a -d "/var/services/photo/" ]; then
   echo "Stop creating thumbnails ..."
   killall synothumb
   killall convert
   echo "Removing all thumbnails ..."
   find /var/services/photo/ -name "SYNOPHOTO:THUMB_*" -exec rm \"{}\" \;
   echo "Start recreating thumbnails ..."
   find /var/services/photo/ -type d | grep -v @eaDir > /tmp/thumb_dir_list
   mv /tmp/thumb_dir_list $SZF_THUMB_CREATE_QUEUE
   kill -s SIGUSR1 `cat /var/run/synomkthumbd.pid`
fi
            
# TODO: this upgrade script shall be able to remove.

