do
$$
declare
	time integer;
	path integer;
begin
	select count(*)
		into time
		from pg_indexes
		where schemaname = 'public'
		and tablename = 'photo_image'
		and indexname = 'photo_image_create_time_idx';

	if time = 0 then
		CREATE INDEX photo_image_create_time_idx ON photo_image(create_time);
	end if;

	select count(*)
		into path
		from pg_indexes
		where schemaname = 'public'
		and tablename = 'photo_image'
		and indexname = 'photo_image_path_idx';

	if path = 0 then
		CREATE UNIQUE INDEX photo_image_path_idx ON photo_image(path);
	end if;
end;
$$
