#!/bin/sh
# Copyright (c) 2000-2019 Synology Inc. All rights reserved.

. /var/packages/PhotoStation/target/photo_scripts/include.sh

SQL_UPDATE="SELECT privilege_shareid FROM photo_image LIMIT 1"
SCRIPT="/var/packages/PhotoStation/target/photo_scripts/sql/upgrade/025_photo_image_video_add_column.pgsql"

echo "Select photo_image table to test column privilege_shareid existence"
$POSTGRESQL_PSQL_PHOTO -c "$SQL_UPDATE"
Ret=$?
if [ $Ret = 1 ]; then
	$POSTGRESQL_PSQL_PHOTO < $SCRIPT
	if [ $? != 0 ]; then
		echo "Failed to upgrade photo database 025"
	fi
fi

INDEX_CHECK="SELECT 1 FROM pg_indexes WHERE tablename = 'photo_image' AND indexname = 'photo_image_shareid_idx';"
CREATE_INDEX="CREATE INDEX photo_image_shareid_idx ON photo_image USING btree (shareid);
             CREATE INDEX photo_image_privilege_shareid_idx ON photo_image USING btree (privilege_shareid);
			 CREATE INDEX video_shareid_idx ON video USING btree (shareid);
			 CREATE INDEX video_privilege_shareid_idx ON video USING btree (privilege_shareid);"


Ret=`$POSTGRESQL_PSQL_PHOTO -t -c "$INDEX_CHECK"`

if [ !$Ret ]; then
	$POSTGRESQL_PSQL_PHOTO -c "$CREATE_INDEX"
	if [ $? != 0 ]; then
		echo "Failed to create index"
	fi
fi
