DO
$$
DECLARE
	exist integer;
BEGIN

SELECT count(*) into exist FROM information_schema.columns WHERE table_name = 'photo_image' AND column_name IN ('lens', 'flash', 'focal_length');

IF exist != 0 then
	UPDATE photo_image SET focal_length = '' WHERE focal_length IS NULL;
	UPDATE photo_image SET lens = '' WHERE lens IS NULL;
	UPDATE photo_image SET flash = '' WHERE flash IS NULL;

	ALTER TABLE photo_image RENAME COLUMN focal_length TO focal_length_v2;
	ALTER TABLE photo_image RENAME COLUMN lens TO lens_v2;
	ALTER TABLE photo_image RENAME COLUMN flash TO flash_v2;

	ALTER TABLE photo_image
		ALTER focal_length_v2 TYPE text,
		ALTER focal_length_v2 SET NOT NULL,
		ALTER focal_length_v2 SET DEFAULT '',
		ALTER lens_v2 TYPE text,
		ALTER lens_v2 SET NOT NULL,
		ALTER lens_v2 SET DEFAULT '',
		ALTER flash_v2 TYPE text,
		ALTER flash_v2 SET NOT NULL,
		ALTER flash_v2 SET DEFAULT '';
ELSE
	ALTER TABLE photo_image
		ADD COLUMN focal_length_v2 TEXT NOT NULL DEFAULT '',
		ADD COLUMN lens_v2 TEXT NOT NULL DEFAULT '',
		ADD COLUMN flash_v2 TEXT NOT NULL DEFAULT '';
END IF;

END;
$$
