#!/bin/sh
# Copyright (c) 2000-2019 Synology Inc. All rights reserved.

. /var/packages/PhotoStation/target/photo_scripts/include.sh

SQL_UPDATE="SELECT config_key FROM photo_config WHERE config_key = 'allow_guest_download'"
SCRIPT="/var/packages/PhotoStation/target/photo_scripts/sql/upgrade/037_modify_photo_config_allow_download.pgsql"

echo "Check if allow_guest_download exist"
$POSTGRESQL_PSQL_PHOTO -c "$SQL_UPDATE" | grep "allow_guest_download" > /dev/null 2>&1
if [ $? = 0 ] ; then
	echo "Already modify to allow_guest_download, return"
	exit 0;
fi

echo "Modify allow_album_download to allow_guest_download"
$POSTGRESQL_PSQL_PHOTO < $SCRIPT
if [ $? != 0 ]; then
	echo "Failed to modify allow_album_download to allow_guest_download"
	exit
fi

exit 0;
