#!/bin/sh
# Copyright (c) 2000-2019 Synology Inc. All rights reserved.

. /var/packages/PhotoStation/target/photo_scripts/include.sh

SQL_COUNT="SELECT COUNT(*) FROM photo_config WHERE config_key = 'account_system'"
SQL_INSERT="INSERT INTO photo_config (module_name, config_key, config_value) VALUES ('global', 'account_system', '1')"

echo "Check if account_system config exists"
count=`$POSTGRESQL_PSQL_PHOTO -At -c "$SQL_COUNT"`
if [ "$count" = "0" ] ; then
	echo "Insert default value for account_system"
	$POSTGRESQL_PSQL_PHOTO -c "$SQL_INSERT"
	if [ $? != 0 ]; then
		echo "Failed to insert default value for account_system"
		exit
	fi
fi

exit 0;
