BEGIN;

ALTER TABLE photo_personal_collection ADD COLUMN is_advanced bool NOT NULL DEFAULT false;
ALTER TABLE photo_personal_collection_for_dsm_account ADD COLUMN is_advanced bool NOT NULL DEFAULT false;
ALTER TABLE photo_personal_collection_for_admin ADD COLUMN is_advanced bool NOT NULL DEFAULT false;

CREATE TABLE photo_advanced_personal_collection
(
	collectionid integer NOT NULL,
	comment bool DEFAULT false,
	tag_area bool DEFAULT false,
	enable_password bool DEFAULT false,
	password varchar(128) DEFAULT '',
	color_label bool DEFAULT false,
	color_label_1 varchar(128),
	color_label_2 varchar(128),
	color_label_3 varchar(128),
	color_label_4 varchar(128),
	color_label_5 varchar(128),
	color_label_6 varchar(128),
	CONSTRAINT photo_advanced_personal_collection_pkey PRIMARY KEY (collectionid),
	CONSTRAINT photo_advanced_personal_collection_collectionID_fkey FOREIGN KEY (collectionid)
		REFERENCES photo_personal_collection (id) MATCH SIMPLE ON UPDATE CASCADE ON DELETE CASCADE
);

CREATE TABLE photo_advanced_personal_collection_for_admin
(
	collectionid integer NOT NULL,
	comment bool DEFAULT false,
	tag_area bool DEFAULT false,
	enable_password bool DEFAULT false,
	password varchar(128) DEFAULT '',
	color_label bool DEFAULT false,
	color_label_1 varchar(128),
	color_label_2 varchar(128),
	color_label_3 varchar(128),
	color_label_4 varchar(128),
	color_label_5 varchar(128),
	color_label_6 varchar(128),
	CONSTRAINT photo_advanced_personal_collection_for_admin_pkey PRIMARY KEY (collectionid),
	CONSTRAINT photo_advanced_personal_collection_for_admin_collectionID_fkey FOREIGN KEY (collectionid)
		REFERENCES photo_personal_collection_for_admin (id) MATCH SIMPLE ON UPDATE CASCADE ON DELETE CASCADE
);

CREATE TABLE photo_advanced_personal_collection_for_dsm_account
(
	collectionid integer NOT NULL,
	comment bool DEFAULT false,
	tag_area bool DEFAULT false,
	enable_password bool DEFAULT false,
	password varchar(128) DEFAULT '',
	color_label bool DEFAULT false,
	color_label_1 varchar(128),
	color_label_2 varchar(128),
	color_label_3 varchar(128),
	color_label_4 varchar(128),
	color_label_5 varchar(128),
	color_label_6 varchar(128),
	CONSTRAINT photo_advanced_collection_for_dsm_account_pkey PRIMARY KEY (collectionid),
	CONSTRAINT photo_advanced_collection_for_dsm_account_collectionID_fkey FOREIGN KEY (collectionid)
		REFERENCES photo_personal_collection_for_dsm_account (id) MATCH SIMPLE ON UPDATE CASCADE ON DELETE CASCADE
);

CREATE TABLE photo_advanced_personal_collection_item
(
	id serial NOT NULL,
	collectionid integer NOT NULL,
	type varchar(8) NOT NULL,
	item_id integer NOT NULL,
	color_label int4 DEFAULT 0,
	CONSTRAINT photo_advanced_personal_collection_item_pkey PRIMARY KEY (id),
	CONSTRAINT photo_advanced_personal_collection_item_collectionID_fkey FOREIGN KEY (collectionid)
		REFERENCES photo_personal_collection (id) MATCH SIMPLE ON UPDATE CASCADE ON DELETE CASCADE
);

CREATE TABLE photo_advanced_personal_collection_item_for_admin
(
	id serial NOT NULL,
	collectionid integer NOT NULL,
	type varchar(8) NOT NULL,
	item_id integer NOT NULL,
	color_label int4 DEFAULT 0,
	CONSTRAINT photo_advanced_personal_collection_item_for_admin_pkey PRIMARY KEY (id),
	CONSTRAINT photo_advanced_personal_collection_item_for_admin_collectionID_fkey FOREIGN KEY (collectionid)
		REFERENCES photo_personal_collection_for_admin (id) MATCH SIMPLE ON UPDATE CASCADE ON DELETE CASCADE
);

CREATE TABLE photo_advanced_personal_collection_item_for_dsm_account
(
	id serial NOT NULL,
	collectionid integer NOT NULL,
	type varchar(8) NOT NULL,
	item_id integer NOT NULL,
	color_label int4 DEFAULT 0,
	CONSTRAINT photo_advanced_collection_item_for_dsm_account_pkey PRIMARY KEY (id),
	CONSTRAINT photo_advanced_collection_item_for_dsm_account_collectionID_fkey FOREIGN KEY (collectionid)
		REFERENCES photo_personal_collection_for_dsm_account (id) MATCH SIMPLE ON UPDATE CASCADE ON DELETE CASCADE
);

CREATE TABLE photo_advanced_personal_collection_comment
(
	id serial NOT NULL,
	advanced_item_id integer NOT NULL,
	name varchar(100),
	email varchar(128),
	comment text,
	date timestamp,
	CONSTRAINT photo_advanced_collection_comment_pkey PRIMARY KEY (id),
	CONSTRAINT photo_advanced_collection_comment_itemID_fkey FOREIGN KEY (advanced_item_id)
		REFERENCES photo_advanced_personal_collection_item (id) MATCH SIMPLE ON UPDATE CASCADE ON DELETE CASCADE
);

CREATE TABLE photo_advanced_personal_collection_comment_for_admin
(
	id serial NOT NULL,
	advanced_item_id integer NOT NULL,
	name varchar(100),
	email varchar(128),
	comment text,
	date timestamp,
	CONSTRAINT photo_advanced_collection_comment_for_admin_pkey PRIMARY KEY (id),
	CONSTRAINT photo_advanced_collection_comment_for_admin_itemID_fkey FOREIGN KEY (advanced_item_id)
		REFERENCES photo_advanced_personal_collection_item_for_admin (id) MATCH SIMPLE ON UPDATE CASCADE ON DELETE CASCADE
);

CREATE TABLE photo_advanced_personal_collection_comment_for_dsm_account
(
	id serial NOT NULL,
	advanced_item_id integer NOT NULL,
	name varchar(100),
	email varchar(128),
	comment text,
	date timestamp,
	CONSTRAINT photo_advanced_collection_comment_for_dsm_account_pkey PRIMARY KEY (id),
	CONSTRAINT photo_advanced_collection_comment_for_dsm_account_itemID_fkey FOREIGN KEY (advanced_item_id)
		REFERENCES photo_advanced_personal_collection_item_for_dsm_account (id) MATCH SIMPLE ON UPDATE CASCADE ON DELETE CASCADE
);

CREATE TABLE photo_advanced_personal_collection_tag_area
(
	id serial NOT NULL,
	advanced_item_id integer NOT NULL,
	position text DEFAULT '',
	info text,
	CONSTRAINT photo_advanced_personal_collection_tag_area_pkey PRIMARY KEY (id),
	CONSTRAINT photo_advanced_personal_collection_tag_area_itemID_fkey FOREIGN KEY (advanced_item_id)
		REFERENCES photo_advanced_personal_collection_item (id) MATCH SIMPLE ON UPDATE CASCADE ON DELETE CASCADE
);

CREATE TABLE photo_advanced_personal_collection_tag_area_for_admin
(
	id serial NOT NULL,
	advanced_item_id integer NOT NULL,
	position text DEFAULT '',
	info text,
	CONSTRAINT photo_advanced_collection_tag_area_for_admin_pkey PRIMARY KEY (id),
	CONSTRAINT photo_advanced_collection_tag_area_for_admin_itemID_fkey FOREIGN KEY (advanced_item_id)
		REFERENCES photo_advanced_personal_collection_item_for_admin (id) MATCH SIMPLE ON UPDATE CASCADE ON DELETE CASCADE

);

CREATE TABLE photo_advanced_personal_collection_tag_area_for_dsm_account
(
	id serial NOT NULL,
	advanced_item_id integer NOT NULL,
	position text DEFAULT '',
	info text,
	CONSTRAINT photo_advanced_collection_tag_area_for_dsm_account_pkey PRIMARY KEY (id),
	CONSTRAINT photo_advanced_collection_tag_area_for_dsm_account_itemID_fkey FOREIGN KEY (advanced_item_id)
		REFERENCES photo_advanced_personal_collection_item_for_dsm_account (id) MATCH SIMPLE ON UPDATE CASCADE ON DELETE CASCADE
);

CREATE TABLE photo_advanced_personal_collection_log (
	id serial PRIMARY KEY,
	collectionid integer
		REFERENCES photo_personal_collection (id)
		ON UPDATE CASCADE ON DELETE CASCADE,
	advanced_item_id integer
		REFERENCES photo_advanced_personal_collection_item (id)
		ON UPDATE CASCADE ON DELETE CASCADE,
	log text NOT NULL default '',
	date timestamp,
	category int2 NOT NULL default 0
);

CREATE TABLE photo_advanced_personal_collection_log_for_admin
(
	id serial PRIMARY KEY,
	collectionid integer
		REFERENCES photo_personal_collection_for_admin (id)
		ON UPDATE CASCADE ON DELETE CASCADE,
	advanced_item_id integer
		REFERENCES photo_advanced_personal_collection_item_for_admin (id)
		ON UPDATE CASCADE ON DELETE CASCADE,
	log text NOT NULL default '',
	date timestamp,
	category int2 NOT NULL default 0
);

CREATE TABLE photo_advanced_personal_collection_log_for_dsm_account
(
	id serial PRIMARY KEY,
	collectionid integer
		REFERENCES photo_personal_collection_for_dsm_account (id)
		ON UPDATE CASCADE ON DELETE CASCADE,
	advanced_item_id integer
		REFERENCES photo_advanced_personal_collection_item_for_dsm_account(id)
		ON UPDATE CASCADE ON DELETE CASCADE,
	log text NOT NULL default '',
	date timestamp,
	category int2 NOT NULL default 0
);

COMMIT;
