<?php

/**
 * move root album order setting from database to sort file
 */

namespace set_root_album_order;

const SYNOPHOTO_SORT_FILE = 'SYNOPHOTO_ALBUM.sort';

function run()
{
	$sortFile = getRootSortFile();
	if (checkRootOrderExists($sortFile)) {
		return;
	}

	$rootOrderInDB = getRootAlbumOrderFromDB();
	if (!$rootOrderInDB) {
		return;
	}

	setRootOrderToEA($rootOrderInDB, $sortFile);
}

function checkRootOrderExists($sortFile) {
	if (false === ($result = @file_get_contents($sortFile))) {
		return false;
	}

	$result = json_decode($result, true);
	if (empty($result['list'])) {
		return false;
	}

	return true;
}

function setRootOrderToEA($order, $sortFile) {
	$result = array();
	$albumArr = json_decode($order);
	foreach($albumArr as $album) {
		$result['list'][] = $album . '/';
	}
	@file_put_contents($sortFile, json_encode($result));
}

function getRootSortFile()
{
	global $photoSharedFolder;

	return "$photoSharedFolder/@eaDir/" . SYNOPHOTO_SORT_FILE;
}

function getRootAlbumOrderFromDB()
{
	global $dbh;

	$sqlCond = "SELECT config_value FROM photo_config WHERE module_name = 'album' AND config_key = 'order_list'";
	$sqlParam = array();

	$dbResult = $dbh->prepare($sqlCond);
	$dbResult->execute($sqlParam);

	if (false !== ($row = $dbResult->fetch())) {
		return $row[0];
	}

	return false;
}

?>
