<?php

/**
 * update lat,lng (photo_image, video) for faster accessing
 */

namespace update_gps;

function run()
{
	global $photoSharedFolder, $dbh;

	updateGPS();
}

function updateGPS()
{
	global $dbh;

	$tables = array('photo_image', 'video');

	foreach ($tables as $table) {
		$sql = "SELECT id, gps FROM $table WHERE gps != '' and (lat IS NULL or lng IS NULL)";
		$select = $dbh->prepare($sql);
		if (!$select) {
			return;
		}
		$select->execute();
		$update = $dbh->prepare("UPDATE $table set lat = ?, lng = ? WHERE id = ?");
		while($row = $select->fetch()) {
			$gps = json_decode($row['gps'], true);
			if ($gps) {
				$lat = $gps['lat'] + 0;
				$lng = $gps['lng'] + 0;
				$update->execute(array($lat, $lng, $row['id']));
			}
		}
	}
}

?>
