
check_version_older () # $1 base version $2 target version
{
	BASE_VER=$1
	TARGET_VER=$2

	# if no ver, always return false
	if [ -z "${BASE_VER}" ]; then
		return 0
	fi

	# getting major, minor, macro, build
	base_major=`echo ${BASE_VER} | sed 's/^\([0-9]*\)[.]\([0-9]*\).*/\1/'`
	base_minor=`echo ${BASE_VER} | sed 's/^\([0-9]*\)[.]\([0-9]*\).*/\2/'`
	base_macro=`echo ${BASE_VER} | sed 's/^\([0-9]*\)[.]\([0-9]*\)[.]\([0-9]*\)[-]\([0-9]*\).*/\3/'`
	if [ "$base_macro" == "${BASE_VER}" ]; then
		base_macro=`echo 0`
	fi
	base_build=`echo ${BASE_VER} | sed 's/^\([0-9]*\)[.]\([0-9]*\)[.]\([0-9]*\)[-]\([0-9]*\).*/\4/'`
	if [ "$base_build" == "${BASE_VER}" ]; then
		base_build=`echo ${BASE_VER} | sed 's/^\([0-9]*\)[.]\([0-9]*\)[-]\([0-9]*\).*/\3/'`
	fi

	target_major=`echo ${TARGET_VER} | sed 's/^\([0-9]*\)[.]\([0-9]*\).*/\1/'`
	target_minor=`echo ${TARGET_VER} | sed 's/^\([0-9]*\)[.]\([0-9]*\).*/\2/'`
	target_macro=`echo ${TARGET_VER} | sed 's/^\([0-9]*\)[.]\([0-9]*\)[.]\([0-9]*\)[-]\([0-9]*\).*/\3/'`
	if [ "$target_macro" == "${TARGET_VER}" ]; then
		target_macro=`echo 0`
	fi
	target_build=`echo ${TARGET_VER} | sed 's/^\([0-9]*\)[.]\([0-9]*\)[.]\([0-9]*\)[-]\([0-9]*\).*/\4/'`
	if [ "$target_build" == "${TARGET_VER}" ]; then
		target_build=`echo ${TARGET_VER} | sed 's/^\([0-9]*\)[.]\([0-9]*\)[-]\([0-9]*\).*/\3/'`
	fi

	# compare major, version must equal or above limitation
	if [ $target_major -lt $base_major ]; then
		return 1;
	elif [ $target_major -gt $base_major ]; then
		return 0;
	fi
	# compare minor
	if [ $target_minor -lt $base_minor ]; then
		return 1;
	elif [ $target_minor -gt $base_minor ]; then
		return 0;
	fi
	# compare macro
	if [ $target_macro -lt $base_macro ]; then
		return 1;
	elif [ $target_macro -gt $base_macro ]; then
		return 0;
	fi
	# compare build
	if [ $target_build -lt $base_build ]; then
		return 1;
	else
		return 0;
	fi
}
